{
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>

Original copyright and license information follows. This unit is distributed
under the terms of the GNU LGPL, as the original library.

GdkPixbuf library - Main header file

Copyright (C) 1999 The Free Software Foundation

Authors: Mark Crichton <crichton@gimp.org>
         Miguel de Icaza <miguel@gnu.org>
         Federico Mena-Quintero <federico@gimp.org>
         Jonathan Blandford <jrb@redhat.com>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

unit GdkPixbufLoader;

interface

uses Glib, GdkPixbuf, GtkObject;

function GDK_TYPE_PIXBUF_LOADER : TGtkType;
asmname 'gdk_pixbuf_loader_get_type';

function GDK_IS_PIXBUF_LOADER (Obj : Pointer) : Boolean;
function GDK_IS_PIXBUF_LOADER_CLASS (Klass : Pointer) : Boolean;

type
  PGdkPixbufLoader = ^GdkPixbufLoader;
  PGdkPixbufLoaderClass = ^GdkPixbufLoaderClass;
  PGdkPixbufLoaderPrivate = Pointer;

  GdkPixbufLoader = record
    OObject : TGtkObject;
    { Private data. }
    Priv : PGdkPixbufLoaderPrivate
  end;

  GdkPixbufLoaderClass = record
    ParentClass : TGtkObjectClass;

    AreaPrepared : ^procedure(Loader : PGdkPixbufLoader);
    AreaUpdated : ^procedure(Loader : PGdkPixbufLoader; x, y, Width, Height : GUint);
    FrameDone : ^procedure(Loader : PGdkPixbufLoader; Frame : PGdkPixbufFrame);
    AnimationDone : ^procedure(Loader : PGdkPixbufLoader);
    Closed : ^procedure(Loader : PGdkPixbufLoader)
  end;

function GdkPixbufLoaderGetType : TGtkType;
asmname 'gdk_pixbuf_loader_get_type';

function GdkPixbufLoaderNew : PGdkPixbufLoader;
asmname 'gdk_pixbuf_loader_new';

function GdkPixbufLoaderWrite(Loader : PGdkPixbufLoader; Buf : PGUChar; Count : Integer) : GBoolean;
asmname 'gdk_pixbuf_loader_write';

function GdkPixbufLoaderGetPixbuf(Loader : PGdkPixbufLoader) : PGdkPixbuf;
asmname 'gdk_pixbuf_loader_get_pixbuf';

function GdkPixbufLoaderGetAnimation(Loader : PGdkPixbufLoader) : PGdkPixbufAnimation;
asmname 'gdk_pixbuf_loader_get_animation';

procedure GdkPixbufLoaderClose(Loader   :  PGdkPixbufLoader);
asmname 'gdk_pixbuf_loader_close';

implementation

function GDK_IS_PIXBUF_LOADER (Obj : Pointer) : Boolean;
begin
  GDK_IS_PIXBUF_LOADER := (Obj <> nil) and GDK_IS_PIXBUF_LOADER_CLASS(PGtkTypeObject(Obj)^.Klass)
end;

function GDK_IS_PIXBUF_LOADER_CLASS (Klass : Pointer) : Boolean;
begin
  GDK_IS_PIXBUF_LOADER_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GDK_TYPE_PIXBUF_LOADER) <> G_FALSE)
end;

end.
