program Test;

{$include "../units/gtk.inc"}
{$ignore-function-results}

uses GdkPixbuf, GdkPixbufLoader;

procedure CloseCB(Button : PGtkButton; Data : GPointer);
begin
  GtkWidgetDestroy(PGtkWidget(Data));
  GtkMainQuit
end;

procedure DeleteCB(Widget : PGtkWidget; Event : PGdkEventAny; Data : GPointer);
begin
  GtkWidgetDestroy(Widget);
  GtkMainQuit
end;

procedure DestroyCB(Widget : PGtkWidget; Event : PGdkEventAny; Data : GPointer);
begin
  GtkMainQuit
end;

var
  Window, VBox, PixmapWid, Close : PGtkWidget;
  Pixmap : PGdkPixmap;
  Mask : PGdkBitmap;
  Pixbuf : PGdkPixbuf;

begin
  GtkInit;

  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);
  GtkSignalConnect(PGtkObject(Window), 'delete_event', @DeleteCB, nil);
  GtkSignalConnect(PGtkObject(Window), 'destroy_event', @DestroyCB, nil);

  VBox := GtkVBoxNew(G_FALSE, 2);
  GtkContainerAdd(PGtkContainer(Window), VBox);

  Pixbuf := GdkPixbufNewFromFile('test.png');
  GdkPixbufRenderPixmapAndMask(Pixbuf, Pixmap, Mask, 0);
  GdkPixbufUnref(Pixbuf);

  PixmapWid := GtkPixmapNew(Pixmap, Mask);
  GtkBoxPackStart(PGtkBox(VBox), PixmapWid, G_FALSE, G_FALSE, 2);

  Close := GtkButtonNewWithLabel('Close');
  GtkSignalConnect(PGtkObject(Close), 'clicked', @CloseCB, Window);
  GtkBoxPackStart(PGtkBox(VBox), Close, G_FALSE, G_FALSE, 2);

  GtkWidgetShowAll(Window);
  GtkMain
end.
