(* 
 * Copyright (C) 1998 Janne Lf <jlof@mail.student.oulu.fi>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *)

unit GdkGL;

interface

uses
  GLib, Gdk, GdkTypes;

type
  pinteger = ^integer;

(*
 * These definitions are duplicated from GL/glx.h that comes with Mesa.
 * I don't want every program to include GL/glx.h because GtkGLArea
 * supports lecacy systems like Windows. You can still use GLX_xxxx
 * attributes with these, but then you lose portability.
 *)
const
  { _GDK_GL_CONFIGS - consts }
  GDK_GL_NONE               = 0;
  GDK_GL_USE_GL             = 1;
  GDK_GL_BUFFER_SIZE        = 2;
  GDK_GL_LEVEL              = 3;
  GDK_GL_RGBA               = 4;
  GDK_GL_DOUBLEBUFFER       = 5;
  GDK_GL_STEREO             = 6;
  GDK_GL_AUX_BUFFERS        = 7;
  GDK_GL_RED_SIZE           = 8;
  GDK_GL_GREEN_SIZE         = 9;
  GDK_GL_BLUE_SIZE          = 10;
  GDK_GL_ALPHA_SIZE         = 11;
  GDK_GL_DEPTH_SIZE         = 12;
  GDK_GL_STENCIL_SIZE       = 13;
  GDK_GL_ACCUM_RED_SIZE     = 14;
  GDK_GL_ACCUM_GREEN_SIZE   = 15;
  GDK_GL_ACCUM_BLUE_SIZE    = 16;
  GDK_GL_ACCUM_ALPHA_SIZE   = 17;
  (* GLX_EXT_visual_info extension *)
  GDK_GL_X_VISUAL_TYPE_EXT            = 16#22;
  GDK_GL_TRANSPARENT_TYPE_EXT         = 16#23;
  GDK_GL_TRANSPARENT_INDEX_VALUE_EXT  = 16#24;
  GDK_GL_TRANSPARENT_RED_VALUE_EXT    = 16#25;
  GDK_GL_TRANSPARENT_GREEN_VALUE_EXT  = 16#26;
  GDK_GL_TRANSPARENT_BLUE_VALUE_EXT   = 16#27;
  GDK_GL_TRANSPARENT_ALPHA_VALUE_EXT  = 16#28;

type
  GdkGLConfigs = Integer;   { see constants above }
  PGdkGLContext = Pointer;
  PGdkGLPixmap = Pointer;

function GdkGLQuery : gint; asmname 'gdk_gl_query';
function GdkGLGetInfo : PGChar; asmname 'gdk_gl_get_info';
function GdkGLChooseVisual(attrlist : PInteger):PGdkVisual;
asmname 'gdk_gl_choose_visual';
function GdkGLGetConfig(visual:PGdkVisual; attrib:integer):Integer;
asmname 'gdk_gl_get_config';
function GdkGLContextNew(visual:PGdkvisual) : PGdkGLContext;
asmname 'gdk_gl_context_new';
function GdkGLContextShareNew(visual:PGdkVisual; sharelist:PGdkGLContext;
                        direct:gint):PGdkGLContext;
asmname 'gdk_gl_context_share_new';
function GdkGLContextAttrlistShareNew(attrlist:PInteger;
                        sharelist:PGdkGLContext; direct:gint)
                        :PGdkGLContext;
asmname 'gdk_gl_context_attrlist_share_new';
function GdkGLContextRef(context:PGdkGLContext):PGdkGLContext;
asmname 'gdk_gl_context_ref';
procedure GdkGLContextUnref(context:PGdkGLContext);
asmname 'gdk_gl_context_unref';
function GdkGLMakeCurrent(drawable:PGdkDrawable;
                        context:PGdkGLContext):Gint;
asmname 'gdk_gl_make_current';
procedure GdkGLSwapBuffers(drawable:PGdkDrawable);
asmname 'gdk_gl_swap_buffers';
procedure GdkGLWaitGDK; asmname 'gdk_gl_wait_gdk';
procedure GdkGLWaitGL; asmname 'gdk_gl_wait_gl';

(* glpixmap stuff *)

function GdkGLPixmapNew(visual:PGdkVisual; pixmap:PGdkPixmap):PGdkGLPixmap;
asmname 'gdk_gl_pixmap_new';

function GdkGLPixmapRef(glpixmap:PGdkGLPixmap):PGdkGLPixmap;
asmname 'gdk_gl_pixmap_ref';

procedure GdkGLPixmapUnref(glpixmap:PGdkGLPixmap);
asmname 'gdk_gl_pixmap_unref';

function GdkGLPixmapMakeCurrent(glpixmap:PGdkGLPixmap;
                        context:PGdkGLContext):GInt;
asmname 'gdk_gl_pixmap_make_current';

(* fonts *)

procedure GdkGLUseGdkFont(font:PGdkFont; first,count,listBase:Integer);
asmname 'gdk_gl_use_gdk_font';

implementation

end.
