{
Copyright (C) 1998 Janne Lof <jlof@mail.student.oulu.fi>

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

program GLPixmap;

{$include "../units/gtk.inc"}
{$ignore-function-results}

uses GdkGL, GtkGLArea, GL;

var
  VisualAttributes : array[1..8] of Integer = ( GDK_GL_RGBA, GDK_GL_RED_SIZE,
                                                1, GDK_GL_GREEN_SIZE,1,
                                                GDK_GL_BLUE_SIZE,1,
                                                GDK_GL_NONE );
  Window, PixmapWid : PGtkWidget;
  Visual : PGdkVisual;
  Pixmap : PGdkPixmap;
  GlPixmap : PGdkGLPixmap;
  Context : PGdkGLContext;

begin
  GtkInit;
  { Check opengl }
  if GdkGLQuery = G_FALSE then
    begin
      Writeln(StdErr, 'OpenGL not supported');
      Exit
    end;

  { Select and use visual as default so all widgets are OpenGL renderable }
  Visual := GdkGLChooseVisual(@VisualAttributes[1]);
  if Visual = nil then
    begin
      Writeln(StdErr, 'Can''t get visual');
      Exit
    end;

  GtkWidgetSetDefaultColormap(GdkColormapNew(Visual, G_TRUE));
  GtkWidgetSetDefaultVisual(Visual);

  { Top level window. }
  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);
  GtkWindowSetTitle(PGtkWindow(Window), 'glpixmap');
  GtkContainerSetBorderWidth(PGtkContainer(Window), 10);
  GtkSignalConnect(PGtkObject(Window), 'delete_event', @GtkMainQuit, nil);
  GtkWidgetSetUSize(Window, 100, 100);
  GtkWidgetShow(Window);

  { pixmap }
  Context := GdkGLContextNew(Visual);
  Pixmap := GdkPixmapNew(nil, 80, 80, Visual^.Depth);
  GlPixmap := GdkGLPixmapNew(Visual, Pixmap);
  if GdkGLPixmapMakeCurrent(GlPixmap, Context) <> G_FALSE then
    begin
      (* @@@ gluOrtho2D is undefined.
      glMatrixMode(GL_PROJECTION);
      glLoadIdentity;
      gluOrtho2D(0,100,100,0); *)
      glMatrixMode(GL_MODELVIEW);
      glLoadIdentity;

      glClearColor(0,0,0,1);
      glClear(GL_COLOR_BUFFER_BIT);
      glColor3f(1,1,1);
      glBegin(GL_TRIANGLES);
      glVertex2f(10,10);
      glVertex2f(10,90);
      glVertex2f(90,90);
      glEnd
    end;
  GdkGLContextUnref(Context);
  GdkGLPixmapUnref(GlPixmap);

  { pixmapwidget }
  PixmapWid := GtkPixmapNew(Pixmap, nil);
  GdkPixmapUnref(Pixmap);

  GtkContainerAdd(PGtkContainer(Window), PixmapWid);
  GtkWidgetShow(PixmapWid);
  GtkMain
end.
