(*
 * Copyright (C) 1997-1998 Janne Lf <jlof@mail.student.oulu.fi>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *)

unit GtkGLArea;

interface

uses glib, gdktypes, gtkenums, gdkgl, gtkdrawingarea, gtkobject, gtkwidget;

function GTK_TYPE_GL_AREA : TGtkType;
asmname 'gtk_gl_area_get_type';

function GTK_IS_GL_AREA (Obj : Pointer) : Boolean;
function GTK_IS_GL_AREA_CLASS (Klass : Pointer) : Boolean;

type
  PGtkGLArea = ^TGtkGLArea;
  PGtkGLAreaClass = ^TGtkGLAreaClass;
  
  TGtkGLArea = record
    darea : TGtkDrawingArea;
    glcontext : PGdkGLContext;
  end;
  
  TGtkGLAreaClass = record
    parentClass : TGtkDrawingAreaClass;
  End;

function  GtkGLAreaGetType : TGtkType;
asmname 'gtk_gl_area_get_type';

function GtkGLAreaNew(attrlist:PInteger):PGtkWidget;
asmname 'gtk_gl_area_new';

function GtkGLAreaShareNew(attrlist:PInteger; share:PGtkGLArea):PGtkWidget;
asmname 'gtk_gl_area_share_new';

function GtkGLAreaNewVargs(share:PGtkGLArea; ...):PGtkWidget;
asmname 'gtk_gl_area_new_vargs';

function GtkGLAreaMakeCurrent(glarea:PGtkGLArea):GInt;
asmname 'gtk_gl_area_make_current';

procedure GtkGLAreaSwapBuffers(glarea:PGtkGLArea);
asmname 'gtk_gl_area_swap_buffers';

{ !! Deprecated functions not prototyped. }

implementation 

function GTK_IS_GL_AREA (Obj : Pointer) : Boolean;
begin
  GTK_IS_GL_AREA := (Obj <> nil) and GTK_IS_GL_AREA_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_GL_AREA_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_GL_AREA_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_GL_AREA) = G_TRUE);
end;

end.
