{ Report bugs to Nicola Girardi <nikke@swlibero.org> }
program Arrow;

{$include "../units/gtk.inc"}
{$ignore-function-results}

{ Create an Arrow widget with the specified parameters
  and pack it into a button. }
function CreateArrowButton (ArrowType : TGtkArrowType; ShadowType : TGtkShadowType) = Button : PGtkWidget;
var
  Arrow : PGtkWidget;
begin
  Button := GtkButtonNew;
  Arrow := GtkArrowNew(ArrowType, ShadowType);

  GtkContainerAdd(PGtkContainer(Button), Arrow);

  GtkWidgetShow(Button);
  GtkWidgetShow(Arrow);
end;

var
  Window, Button, Box : PGtkWidget;

begin
  GtkInit;

  { Create a new window. }
  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);
  GtkWindowSetTitle(PGtkWindow(Window), 'Arrow Buttons');

  { It's a good idea to do this for all windows. }
  GtkSignalConnect(PGtkObject(Window), 'destroy', @GtkMainQuit, nil);

  { Sets the border width of the window. }
  GtkContainerSetBorderWidth(PGtkContainer(Window), 10);

  { Create a box to hold the arrows/buttons. }
  Box := GtkHBoxNew(G_FALSE, 0);
  GtkContainerSetBorderWidth(PGtkContainer(Box), 2);
  GtkContainerAdd(PGtkContainer(Window), Box);

  { Pack and show all our widgets. }
  GtkWidgetShow(Box);

  Button := CreateArrowButton(GTK_ARROW_UP, GTK_SHADOW_IN);
  GtkBoxPackStart(PGtkBox(Box), Button, G_FALSE, G_FALSE, 3);

  Button := CreateArrowButton(GTK_ARROW_DOWN, GTK_SHADOW_OUT);
  GtkBoxPackStart(PGtkBox(Box), Button, G_FALSE, G_FALSE, 3);

  Button := CreateArrowButton(GTK_ARROW_LEFT, GTK_SHADOW_ETCHED_IN);
  GtkBoxPackStart(PGtkBox(Box), Button, G_FALSE, G_FALSE, 3);

  Button := CreateArrowButton(GTK_ARROW_RIGHT, GTK_SHADOW_ETCHED_OUT);
  GtkBoxPackStart(PGtkBox(Box), Button, G_FALSE, G_FALSE, 3);

  GtkWidgetShow(Window);
  
  { Rest in gtk_main and wait for the fun to begin! }
  GtkMain;
end.
