{ Report bugs to Nicola Girardi <nikke@swlibero.org> }
program AspectFrame;

{$include "../units/gtk.inc"}
{$ignore-function-results}

var
  Window, AspectFrame, Area : PGtkWidget;

begin
  GtkInit;

  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);
  GtkWindowSetTitle(PGtkWindow(Window), 'Aspect Frame');
  GtkSignalConnect(PGtkObject(Window), 'destroy', @GtkMainQuit, nil);
  GtkContainerSetBorderWidth(PGtkContainer(Window), 10);

  { Create an aspect_frame and add it to our toplevel window }
  AspectFrame := GtkAspectFrameNew('2x1' {label}, 0.5 {center x}, 0.5 {center y}, 2 {xsize/ysize=2}, G_FALSE {ignore child's aspect});
  GtkContainerAdd(PGtkContainer(Window), AspectFrame);
  GtkWidgetShow(AspectFrame);

  { Now add a child widget to the aspect frame }
  Area := GtkDrawingAreaNew;

  { Ask for a 200x200 window, but the AspectFrame will give us a 200x100
    window since we are forcing a 2x1 aspect ratio }
  GtkWidgetSetUSize(Area, 200, 200);
  GtkContainerAdd(PGtkContainer(AspectFrame), Area);
  GtkWidgetShow(Area);

  GtkWidgetShow(Window);
  GtkMain;
end.
