{ Report bugs to Nicola Girardi <nikke@swlibero.org> }
program ButtonBox;

{$include "../units/gtk.inc"}
{$ignore-function-results}

{ Create a Button Box with the specified parameters }
function CreateBBox(Horizontal : Boolean; Title : String; Spacing, ChildW, ChildH, Layout : GInt) = W : PGtkWidget;
var
  Frame, BBox, Button : PGtkWidget;
begin
  Frame := GtkFrameNew(Title);

  if Horizontal then
    BBox := GtkHbuttonBoxNew
  else
    BBox := GtkVbuttonBoxNew;

  GtkContainerSetBorderWidth(PGtkContainer(BBox), 5);
  GtkContainerAdd(PGtkContainer(Frame), BBox);

  { Set the appearance of the Button Box }
  GtkButtonBoxSetLayout(PGtkButtonBox(BBox), Layout);
  GtkButtonBoxSetSpacing(PGtkButtonBox(BBox), Spacing);
  GtkButtonBoxSetChildSize(PGtkButtonBox(BBox), ChildW, ChildH);

  Button := GtkButtonNewWithLabel('OK');
  GtkContainerAdd(PGtkContainer(BBox), Button);

  Button := GtkButtonNewWithLabel('Cancel');
  GtkContainerAdd(PGtkContainer(BBox), Button);

  Button := GtkButtonNewWithLabel('Help');
  GtkContainerAdd(PGtkContainer(BBox), Button);

  W := Frame;
end;

var
  Window : static PGtkWidget = nil;
  MainVBox, VBox, HBox, FrameHorz, FrameVert : PGtkWidget;

begin
  { Initialize GTK }
  GtkInit;

  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);
  GtkWindowSetTitle(PGtkWindow(Window), 'Button Boxes');

  GtkSignalConnect(PGtkObject(Window), 'destroy', @GtkMainQuit, nil);

  GtkContainerSetBorderWidth(PGtkContainer(Window), 10);

  MainVBox := GtkVBoxNew(G_FALSE, 0);
  GtkContainerAdd(PGtkContainer(Window), MainVBox);

  FrameHorz := GtkFrameNew('Horizontal Button Boxes');
  GtkBoxPackStart(PGtkBox(MainVBox), FrameHorz, G_TRUE, G_TRUE, 10);

  VBox := GtkVBoxNew(G_FALSE, 0);
  GtkContainerSetBorderWidth(PGtkContainer(VBox), 10);
  GtkContainerAdd(PGtkContainer(FrameHorz), VBox);

  GtkBoxPackStart(PGtkBox(VBox), CreateBBox(True, 'Spread (spacing 40)', 40, 85, 20, GTK_BUTTONBOX_SPREAD), G_TRUE, G_TRUE, 0);
  GtkBoxPackStart(PGtkBox(VBox), CreateBBox(True, 'Edge (spacing 30)', 30, 85, 20, GTK_BUTTONBOX_EDGE), G_TRUE, G_TRUE, 5);
  GtkBoxPackStart(PGtkBox(VBox), CreateBBox(True, 'Start (spacing 20)', 20, 85, 20, GTK_BUTTONBOX_START), G_TRUE, G_TRUE, 5);
  GtkBoxPackStart(PGtkBox(VBox), CreateBBox(True, 'End (spacing 10)', 10, 85, 20, GTK_BUTTONBOX_END), G_TRUE, G_TRUE, 5);

  FrameVert := GtkFrameNew('Vertical Button Boxes');
  GtkBoxPackStart(PGtkBox(MainVBox), FrameVert, G_TRUE, G_TRUE, 10);

  HBox := GtkHBoxNew(G_FALSE, 0);
  GtkContainerSetBorderWidth(PGtkContainer(HBox), 10);
  GtkContainerAdd(PGtkContainer(frameVert), HBox);

  GtkBoxPackStart(PGtkBox(HBox), CreateBBox(False, 'Spread (spacing 5)', 5, 85, 20, GTK_BUTTONBOX_SPREAD), G_TRUE, G_TRUE, 0);
  GtkBoxPackStart(PGtkBox(HBox), CreateBBox(False, 'Edge (spacing 30)', 30, 85, 20, GTK_BUTTONBOX_EDGE), G_TRUE, G_TRUE, 5);
  GtkBoxPackStart(PGtkBox(HBox), CreateBBox(False, 'Start (spacing 20)', 20, 85, 20, GTK_BUTTONBOX_START), G_TRUE, G_TRUE, 5);
  GtkBoxPackStart(PGtkBox(HBox), CreateBBox(False, 'End (spacing 20)', 20, 85, 20, GTK_BUTTONBOX_END), G_TRUE, G_TRUE, 5);

  GtkWidgetShowAll(Window);

  { Enter the event loop }
  GtkMain;
end.
