{ Report bugs to Nicola Girardi <nikke@swlibero.org> }
program Buttons;

{$include "../units/gtk.inc"}
{$ignore-function-results}

uses GPC;

var
  CoolButton_Str : TString = 'CoolButton';

{ Create a new hbox with an image and a label packed into it
  and return the box. }
function XPMLabelBox(Parent : PGtkWidget; FileName, LabelText : String) : PGtkWidget;
var
  Box, Lbl, PixmapWid : PGtkWidget;
  Pixmap : PGdkPixmap;
  Mask : PGdkBitmap;
  Style : PGtkStyle;
begin
  { Create box for xpm and label. }
  Box := GtkHBoxNew(G_FALSE, 0);
  GtkContainerSetBorderWidth(PGtkContainer(Box), 2);

  { Get the style of the button to get the background color. }
  Style := GtkWidgetGetStyle(Parent);

  { Now on to the XPM stuff. }
  Pixmap := GdkPixmapCreateFromXPM(Parent^.Window, @Mask, @Style^.Bg[GTK_STATE_NORMAL], FileName);
  PixmapWid := GtkPixmapNew(Pixmap, Mask);

  { Create a label for the button. }
  Lbl := GtkLabelNew(LabelText);

  { Pack the pixmap and label into the box. }
  GtkBoxPackStart(PGtkBox(Box), PixmapWid, G_FALSE, G_FALSE, 3);
  GtkBoxPackStart(PGtkBox(Box), Lbl, G_FALSE, G_FALSE, 3);

  GtkWidgetShow(PixmapWid);
  GtkWidgetShow(Lbl);

  XPMLabelBox := Box;
end;

{ Our usual callback function. }
procedure Callback(Widget : PGtkWidget; Data : GPointer);
begin
  Writeln('Hello again - ', PString(Data)^, ' was pressed.');
end;

var
  Window, Button, LabelBox : PGtkWidget;

begin
  GtkInit;

  { Create a new window. }
  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);
  GtkWindowSetTitle(PGtkWindow(Window), 'Pixmap''d buttons!');

  { It's a good idea to do this for all windows. }
  GtkSignalConnect(PGtkObject(Window), 'destroy', @GtkExit, nil);
  GtkSignalConnect(PGtkObject(Window), 'delete_event', @GtkExit, nil);

  { Sets the border width of the window. }
  GtkContainerSetBorderWidth(PGtkContainer(Window), 10);
  GtkWidgetRealize(Window);

  { Create a new button. }
  Button := GtkButtonNew;

  { Connect the 'clicked' signal of the button to our callback. }
  GtkSignalConnect(PGtkObject(Button), 'clicked', @Callback, @CoolButton_Str);

  { This calls our box creating function. }
  LabelBox := XPMLabelBox(Window, 'info.xpm', 'cool button');

  { Pack and show all our widgets. }
  GtkWidgetShow(LabelBox);
  GtkContainerAdd(PGtkContainer(Button), LabelBox);
  GtkWidgetShow(Button);
  GtkContainerAdd(PGtkContainer(Window), Button);
  GtkWidgetShow(Window);

  { Rest in GtkMain and wait for the fun to begin! }
  GtkMain;
end.
