{ Report bugs to Nicola Girardi <nikke@swlibero.org> }
program DialTest;

{$include "../units/gtk.inc"}
{$ignore-function-results}

uses GtkDial;

procedure ValueChanged(Adjustment : PGtkAdjustment; LLabel : PGtkWidget);
var
  Buffer : String(16);
begin
  WriteStr(Buffer, Adjustment^.VValue:1:2);
  GtkLabelSetText(PGtkLabel(LLabel), Buffer);
end;

var
  Window, Dial, Frame, VBox, LLabel : PGtkWidget;
  Adjustment : PGtkAdjustment;

begin
  GtkInit;

  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);
  
  GtkWindowSetTitle(PGtkWindow(Window), 'Dial');
  GtkSignalConnect(PGtkObject(Window), 'destroy', @GtkExit, nil);
  GtkContainerSetBorderWidth(PGtkContainer(Window), 10);

  Vbox := GtkVboxNew(G_FALSE, 5);
  GtkContainerAdd(PGtkContainer(Window), VBox);
  GtkWidgetShow(VBox);

  Frame := GtkFrameNew(nil);
  GtkFrameSetShadowType(PGtkFrame(Frame), GTK_SHADOW_IN);
  GtkBoxPackStart(PGtkBox(VBox), Frame, G_TRUE, G_TRUE, 0);
  GtkWidgetShow(Frame);
 
  Adjustment := PGtkAdjustment(GtkAdjustmentNew(0, -1.0, 1.0, 0.01, 0.1, 0));
  
  Dial := GtkDialNew(Adjustment);
  GtkDialSetUpdatePolicy(PGtkDial(Dial), GTK_UPDATE_DELAYED);
  (*GtkWidgetSetUsize(Dial, 100, 100);*)
  
  GtkContainerAdd(PGtkContainer(Frame), Dial);
  GtkWidgetShow(Dial);

  LLabel := GtkLabelNew('0.00');
  GtkBoxPackStart(PGtkBox(VBox), LLabel, G_TRUE, G_TRUE, 0);
  GtkWidgetShow(LLabel);

  GtkSignalConnect(PGtkObject(Adjustment), 'value_changed', @ValueChanged, LLabel);
  GtkWidgetShow(Window);
  GtkMain;
end.
