{ Report bugs to Nicola Girardi <nikke@swlibero.org> }
program Entry;

{$include "../units/gtk.inc"}
{$ignore-function-results}

procedure EnterCallback(Widget, Entry : PGtkWidget);
var
  EntryText : PGChar;
begin
  EntryText := GtkEntryGetText(PGtkEntry(Entry));
  Writeln('Entry contents: ', CString2String(EntryText));
end;

procedure EntryToggleEditable(CheckButton, Entry : PGtkWidget);
begin
  GtkEntrySetEditable(PGtkEntry(Entry), 
    GtkToggleButtonGetActive(PGtkToggleButton(CheckButton)));
end;

procedure EntryToggleVisibility(CheckButton, Entry : PGtkWidget);
begin
  GtkEntrySetVisibility(PGtkEntry(Entry), 
    GtkToggleButtonGetActive(PGtkToggleButton(CheckButton)));
end;

var
  Window, VBox, HBox, Entry, Button, Check : PGtkWidget;

begin
  GtkInit;

  { Create a new window }
  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);
  GtkWidgetSetUSize(PGtkWidget(Window), 200, 100);
  GtkWindowSetTitle(PGtkWindow(Window), 'GTK Entry');
  GtkSignalConnect(PGtkObject(Window), 'delete_event', @GtkExit, nil);

  VBox := GtkVBoxNew(G_FALSE, 0);
  GtkContainerAdd(PGtkContainer(Window), VBox);
  GtkWidgetShow(VBox);

  Entry := GtkEntryNewWithMaxLength(50);
  GtkSignalConnect(PGtkObject(Entry), 'activate', @EnterCallback, Entry);
  GtkEntrySetText(PGtkEntry(Entry), 'hello');
  GtkEntryAppendText(PGtkEntry(Entry), ' world');
  GtkEntrySelectRegion(PGtkEntry(Entry), 0, PGtkEntry(Entry)^.TextLength);
  GtkBoxPackStart(PGtkBox(VBox), Entry, G_TRUE, G_TRUE, 0);
  GtkWidgetShow(Entry);

  HBox := GtkHBoxNew(G_FALSE, 0);
  GtkContainerAdd(PGtkContainer(VBox), HBox);
  GtkWidgetShow(HBox);

  Check := GtkCheckButtonNewWithLabel('Editable');
  GtkBoxPackStart(PGtkBox(HBox), Check, G_TRUE, G_TRUE, 0);
  GtkSignalConnect(PGtkObject(Check), 'toggled', @EntryToggleEditable, Entry);
  GtkToggleButtonSetActive(PGtkToggleButton(Check), G_TRUE);
  GtkWidgetShow(Check);

  Check := GtkCheckButtonNewWithLabel('Visible');
  GtkBoxPackStart(PGtkBox(HBox), Check, G_TRUE, G_TRUE, 0);
  GtkSignalConnect(PGtkObject(Check), 'toggled', @EntryToggleVisibility, Entry);
  GtkToggleButtonSetActive(PGtkToggleButton(Check), G_TRUE);
  GtkWidgetShow(Check);

  Button := GtkButtonNewWithLabel('Close');
  GtkSignalConnectObject(PGtkObject(Button), 'clicked', @GtkExit, PGtkObject(Window));
  GtkBoxPackStart(PGtkBox(VBox), Button, G_TRUE, G_TRUE, 0);
  GTK_WIDGET_SET_FLAGS(Button, GTK_CAN_DEFAULT);
  GtkWidgetGrabDefault(Button);
  GtkWidgetShow(Button);

  GtkWidgetShow(Window);
  GtkMain;
end.
