{ Report bugs to Nicola Girardi <nikke@swlibero.org> }
program Fixed;

{$include "../units/gtk.inc"}
{$ignore-function-results}

{ I'm going to be lazy and use some global variables to store the position
  of the widget within the fixed container }
var
  Window, Fixed, Button : PGtkWidget;
  x : GInt = 50;
  y : GInt = 50;
  i : Integer;

{ This callback function moves the button to a new position in the Fixed container. }
procedure MoveButton(Widget, Fixed : PGtkWidget);
begin
  x := (x+30) mod 300;
  y := (y+50) mod 300;
  GtkFixedMove(PGtkFixed(Fixed), Widget, x, y);
end;

begin
  { Initialise GTK }
  GtkInit;

  { Create a new window }
  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);
  GtkWindowSetTitle(PGtkWindow(Window), 'Fixed Container');

  { Here we connect the "destroy" event to a signal handler }
  GtkSignalConnect(PGtkObject(Window), 'destroy', @GtkMainQuit, nil);

  { Sets the border width of the window. }
  GtkContainerSetBorderWidth(PGtkContainer(Window), 10);

  { Create a Fixed Container }
  Fixed := GtkFixedNew;
  GtkContainerAdd(PGtkContainer(Window), Fixed);
  GtkWidgetShow(Fixed);

  for i := 1 to 3 do
    begin
      { Creates a new button with the label "Press me" }
      Button := GtkButtonNewWithLabel('Press me');
  
      { When the button receives the "clicked" signal, it will call the
        function move_button() passing it the Fixed Container as its
        argument. }
      GtkSignalConnect(PGtkObject(Button), 'clicked', @MoveButton, Fixed);

      { This packs the button into the fixed containers window. }
      GtkFixedPut(PGtkFixed(Fixed), Button, i*50, i*50);

      { The final step is to display this newly created widget. }
      GtkWidgetShow(Button);
    end;

  { Display the window }
  GtkWidgetShow(Window);

  { Enter the event loop }
  GtkMain;
end.
