{ Report bugs to Nicola Girardi <nikke@swlibero.org> }
program LLabel;

{$include "../units/gtk.inc"}
{$ignore-function-results}

var
  Window, HBox, VBox, Frame, Lbl : PGtkWidget;

begin
  GtkInit;

  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);
  GtkSignalConnect(PGtkObject(Window), 'destroy', @GtkMainQuit, nil);
  GtkWindowSetTitle(PGtkWindow(Window), 'Label');
  GtkContainerSetBorderWidth(PGtkContainer(Window), 5);

  HBox := GtkHBoxNew(G_FALSE, 5);
  GtkContainerAdd(PGtkContainer(Window), HBox);

  VBox := GtkVBoxNew(G_FALSE, 5);
  GtkBoxPackStart(PGtkBox(HBox), VBox, G_FALSE, G_FALSE, 0);

  Frame := GtkFrameNew('Normal label');
  Lbl := GtkLabelNew('This is a normal label.');
  GtkContainerAdd(PGtkContainer(Frame), Lbl);
  GtkBoxPackStart(PGtkBox(VBox), Frame, G_FALSE, G_FALSE, 0);

  Frame := GtkFrameNew('Multi-line label');
  Lbl := GtkLabelNew("This is a multi-line label.\nSecond line.\nThird line.");
  GtkContainerAdd(PGtkContainer(Frame), Lbl);
  GtkBoxPackStart(PGtkBox(VBox), Frame, G_FALSE, G_FALSE, 0);

  Frame := GtkFrameNew('Right-justified label');
  Lbl := GtkLabelNew("This is a right-justified\nmulti-line\nlabel.");
  GtkLabelSetJustify(PGtkLabel(Lbl), GTK_JUSTIFY_RIGHT);
  GtkContainerAdd(PGtkContainer(Frame), Lbl);
  GtkBoxPackStart(PGtkBox(VBox), Frame, G_FALSE, G_FALSE, 0);

  VBox := GtkVBoxNew(G_FALSE, 5);
  GtkBoxPackStart(PGtkBox(HBox), VBox, G_FALSE, G_FALSE, 0);
  Frame := GtkFrameNew('Line wrapped label');
  Lbl := GtkLabelNew('This is an example of a line-wrapped label. It '
                     'should not be taking up the entire '                     { Big space to test spacing. }
                     'width allocated to it, but automatically '
                     'wraps the words to fit. '
                     'The time has come, for all good men, to come to '
                     'the aid of their party. '
                     'The sixth sheik''s six sheep''s sick. '
                     'It supports multiple paragraphs correctly, '
                     'and correctly adds '
                     'many extra spaces.');
  GtkLabelSetLineWrap(PGtkLabel(Lbl), G_TRUE);
  GtkContainerAdd(PGtkContainer(Frame), Lbl);
  GtkBoxPackStart(PGtkBox(VBox), Frame, G_FALSE, G_FALSE, 0);

  Frame := GtkFrameNew('Underlined label');
  Lbl := GtkLabelNew("This is underlined!\nThis one is underlined in quite a funky fashion.");
  GtkLabelSetJustify(PGtkLabel(Lbl), GTK_JUSTIFY_LEFT);
  GtkLabelSetPattern(PGtkLabel(Lbl), "_________________________ _ _________ _ ______     __    _______ ___");
  GtkContainerAdd(PGtkContainer(Frame), Lbl);
  GtkBoxPackStart(PGtkBox(VBox), Frame, G_FALSE, G_FALSE, 0);

  GtkWidgetShowAll(Window);
  GtkMain;
end.
