{ Report bugs to Nicola Girardi <nikke@swlibero.org> }
program Menu;

{$include "../units/gtk.inc"}
{$ignore-function-results}

uses GPC;

{ Respond To A Button-press By Posting A Menu Passed In As Widget.

  Note That The 'widget' Argument Is The Menu Being Posted, NOT
  The Button That Was Pressed. }

function ButtonPress(Widget : PGtkWidget; Event : PGdkEvent) : GInt;
begin
  if Event^.TType = GDK_BUTTON_PRESS then
    begin
      var BEvent : PGdkEventButton = PGdkEventButton(Event);
      GtkMenuPopup(PGtkMenu(Widget), nil, nil, nil, nil, BEvent^.Button, BEvent^.Time);
      { Tell Calling Code That We Have Handled This Event; The Buck Stops Here. }
      ButtonPress := G_TRUE;
    end
  else
    { Tell calling code that we have not handled this event; pass it on. }
    ButtonPress := G_FALSE;
end;

{ Print a string when a menu item is selected }
procedure MenuItemResponse(Str : PString);
begin
  Writeln(Str^);
end;

var
  Window, Menu, MenuBar, RootMenu, MenuItems, VBox, Button : PGtkWidget;
  Buf : String(128);
  i : Integer;
  MenuNames : array[0..2] of String(32) = ( 'Test-Undermenu - 0',
                                            'Test-Undermenu - 1',
                                            'Test-Undermenu - 2');
begin
  GtkInit;

  { Create a new window }
  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);
  GtkWidgetSetUsize(Window, 200, 100);
  GtkWindowSetTitle(PGtkWindow(Window), 'GTK Menu Test');
  GtkSignalConnect(PGtkObject(Window), 'delete_event', @GtkMainQuit, nil);

  { Init The Menu-widget, And Remember -- Never
    GtkShowWidget() The Menu Widget!!
    This Is The Menu That Holds The Menu Items, The One That
    Will Pop Up When You Click On The 'Root Menu' In The App }
  Menu := GtkMenuNew;

  { Next We Make A Little Loop That Makes Three Menu-entries For 'test-menu'.
    Notice The Call To GtkMenuAppend.  Here We Are Adding A List Of
    Menu Items To Our Menu.  Normally, We'd Also Catch The 'clicked'
    Signal On Each Of The Menu Items And Setup A Callback For It,
    But It's Omitted Here To Save Space. }
  for i := 0 to 2 do
    begin
      { Create a new menu-item with a name... }
      MenuItems := GtkMenuItemNewWithLabel(MenuNames[i]);
      { ...and add it to the menu. }
      GtkMenuAppend(PGtkMenu(Menu), MenuItems);

      { Do something interesting when the menuitem is selected }
                                                                                  (* @@ Terrible kludge. I'm reporting as is. *)
      GtkSignalConnectObject(PGtkObject(MenuItems), 'activate', @MenuItemResponse, PGtkObject(@MenuNames[i]));

      { Show the widget }
      GtkWidgetShow(MenuItems);
    end;

  { This Is The Root Menu, And Will Be The Label
    Displayed On The Menu Bar.  There Won't Be A Signal Handler Attached,
    As It Only Pops Up The Rest Of The Menu When Pressed. }
  RootMenu := GtkMenuItemNewWithLabel('Root Menu');

  GtkWidgetShow(RootMenu);

  { Now We Specify That We Want Our Newly Created 'menu' To Be The Menu
    For The 'root menu' }
  GtkMenuItemSetSubmenu(PGtkMenuItem(RootMenu), Menu);

  { A VBox to put a menu and a button in: }
  VBox := GtkVBoxNew(G_FALSE, 0);
  GtkContainerAdd(PGtkContainer(Window), VBox);
  GtkWidgetShow(VBox);

  { Create a menu-bar to hold the menus and add it to our main window }
  MenuBar := GtkMenuBarNew;
  GtkBoxPackStart(PGtkBox(VBox), MenuBar, G_FALSE, G_FALSE, 2);
  GtkWidgetShow(MenuBar);

  { Create a button to which to attach menu as a popup }
  Button := GtkButtonNewWithLabel('press me');
  GtkSignalConnectObject(PGtkObject(Button), 'event', @ButtonPress, PGtkObject(Menu));
  GtkBoxPackEnd(PGtkBox(VBox), Button, G_TRUE, G_TRUE, 2);
  GtkWidgetShow(button);

  { And Finally We Append The Menu-item To The Menu-bar -- This Is The
    'root' Menu-item I Have Been Raving About =) }
  GtkMenuBarAppend(PGtkMenuBar(MenuBar), RootMenu);

  { Always Display The Window As The Last Step So It All Splashes On
    The Screen At Once. }
  GtkWidgetShow(Window);
  GtkMain;
end.
