{ Report bugs to Nicola Girardi <nikke@swlibero.org> }
program Rulers;

{$include "../units/gtk.inc"}
{$ignore-function-results}

{$define EVENT_METHOD(i, x) PGtkWidgetClass(PGtkObject(i)^.Klass)^.x}

const
  XSIZE = 600;
  YSIZE = 400;

{ This routine gets control when the close button is clicked }
function CloseApplication(Widget : PGtkWidget; Event : PGdkEvent; Data : GPointer) : GInt;
begin
  GtkMainQuit;
  CloseApplication := G_FALSE;
end;

var
  Window, Table, Area, HRule, VRule : PGtkWidget;

{ The main routine }
begin
  { Initialize GTK and create the main window }
  GtkInit;

  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);
  GtkSignalConnect(PGtkObject(Window), 'delete_event', @CloseApplication, nil);
  GtkContainerSetBorderWidth(PGtkContainer(Window), 10);

  { Create a table for placing the ruler and the drawing area }
  Table := GtkTableNew(3, 2, G_FALSE);
  GtkContainerAdd(PGtkContainer(Window), Table);

  Area := GtkDrawingAreaNew;
  GtkDrawingAreaSize(PGtkDrawingArea(Area), XSIZE, YSIZE);
  GtkTableAttach(PGtkTable(Table), Area, 1, 2, 1, 2, GTK_EXPAND or GTK_FILL, GTK_FILL, 0, 0);
  GtkWidgetSetEvents(Area, GDK_POINTER_MOTION_MASK or GDK_POINTER_MOTION_HINT_MASK);

  { The horizontal ruler goes on top. As the mouse moves across the
    drawing area, a motion_notify_event is passed to the
    appropriate event handler for the ruler. }
  HRule := GtkHRulerNew;
  GtkRulerSetMetric(PGtkRuler(HRule), GTK_PIXELS);
  GtkRulerSetRange(PGtkRuler(HRule), 7, 13, 0, 20 );
  GtkSignalConnectObject(PGtkObject(Area), 'motion_notify_event', EVENT_METHOD(HRule, MotionNotifyEvent), PGtkObject(HRule));
  GtkTableAttach(PGtkTable(Table), HRule, 1, 2, 0, 1, GTK_EXPAND or GTK_SHRINK or GTK_FILL, GTK_FILL, 0, 0);

  { The vertical ruler goes on the left. As the mouse moves across
    the drawing area, a motion_notify_event is passed to the
    appropriate event handler for the ruler. }
  VRule := GtkVRulerNew;
  GtkRulerSetMetric(PGtkRuler(VRule), GTK_PIXELS);
  GtkRulerSetRange(PGtkRuler(VRule), 0, YSIZE, 10, YSIZE);
  GtkSignalConnectObject(PGtkObject(Area), 'motion_notify_event', EVENT_METHOD(VRule, MotionNotifyEvent), PGtkObject(VRule));
  GtkTableAttach(PGtkTable(Table), VRule, 0, 1, 1, 2,  GTK_FILL, GTK_EXPAND or GTK_SHRINK or GTK_FILL, 0, 0);

  { Now show everything }
  GtkWidgetShow(Area);
  GtkWidgetShow(HRule);
  GtkWidgetShow(VRule);
  GtkWidgetShow(Table);
  GtkWidgetShow(Window);

  GtkMain;
end.
