{ Report bugs to Nicola Girardi <nikke@swlibero.org> }
program SpinButton;

{$include "../units/gtk.inc"}
{$ignore-function-results}

var
  Spinner1 : static PGtkWidget;

procedure ToggleSnap(Widget : PGtkWidget; Spin : PGtkSpinButton);
begin
  GtkSpinButtonSetSnapToTicks(Spin, GtkToggleButtonGetActive(PGtkToggleButton(Widget)));
end;

procedure ToggleNumeric(Widget : PGtkWidget; Spin : PGtkSpinButton);
begin
  GtkSpinButtonSetNumeric(Spin, GtkToggleButtonGetActive(PGtkToggleButton(Widget)));
end;

procedure ChangeDigits(Widget : PGtkWidget; Spin : PGtkSpinButton);
begin
  GtkSpinButtonSetDigits(PGtkSpinButton(Spinner1), GtkSpinButtonGetValueAsInt(Spin));
end;

procedure GetValue(Widget : PGtkWidget; Data : GPointer);
var
  Buf : String(32);
  LLabel : PGtkLabel;
  Spin : PGtkSpinButton;
begin
  Spin := PGtkSpinButton(Spinner1);
  LLabel := PGtkLabel(GtkObjectGetUserData(PGtkObject(Widget)));
  if Integer(Data) = 1 then
    WriteStr(Buf, GtkSpinButtonGetValueAsInt(Spin))
  else
    WriteStr(Buf, GtkSpinButtonGetValueAsFloat(Spin));
  GtkLabelSetText(LLabel, Buf);
end;

var
  Window, Frame, HBox, MainVBox, VBox, VBox2, Spinner2, Spinner, Button,
  LLabel, ValLabel : PGtkWidget;
  Adj : PGtkAdjustment;

begin
  { Initialise GTK }
  GtkInit;

  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);

  GtkSignalConnect(PGtkObject(Window), 'destroy', @GtkMainQuit, nil);
  GtkWindowSetTitle(PGtkWindow(Window), 'Spin Button');

  MainVBox := GtkVBoxNew(G_FALSE, 5);
  GtkContainerSetBorderWidth(PGtkContainer(MainVBox), 10);
  GtkContainerAdd(PGtkContainer(Window), MainVBox);
  
  Frame := GtkFrameNew('Not accelerated');
  GtkBoxPackStart(PGtkBox(mainVBox), Frame, G_TRUE, G_TRUE, 0);
  
  VBox := GtkVBoxNew(G_FALSE, 0);
  GtkContainerSetBorderWidth(PGtkContainer(VBox), 5);
  GtkContainerAdd(PGtkContainer(Frame), VBox);
  
  { Day, month, year spinners }
  
  HBox := GtkHBoxNew(G_FALSE, 0);
  GtkBoxPackStart(PGtkBox(VBox), HBox, G_TRUE, G_TRUE, 5);
  
  VBox2 := GtkVBoxNew(G_FALSE, 0);
  GtkBoxPackStart(PGtkBox(HBox), VBox2, G_TRUE, G_TRUE, 5);
  
  LLabel := GtkLabelNew('Day :');
  GtkMiscSetAlignment(PGtkMisc(LLabel), 0, 0.5);
  GtkBoxPackStart(PGtkBox(VBox2), LLabel, G_FALSE, G_TRUE, 0);
  
  Adj := PGtkAdjustment(GtkAdjustmentNew(1.0, 1.0, 31.0, 1.0, 5.0, 0.0));
  Spinner := GtkSpinButtonNew(Adj, 0, 0);
  GtkSpinButtonSetWrap(PGtkSpinButton(Spinner), G_TRUE);
  GtkSpinButtonSetShadowType(PGtkSpinButton(Spinner), GTK_SHADOW_OUT);
  GtkBoxPackStart(PGtkBox(VBox2), Spinner, G_FALSE, G_TRUE, 0);
  
  VBox2 := GtkVBoxNew(G_FALSE, 0);
  GtkBoxPackStart(PGtkBox(HBox), VBox2, G_TRUE, G_TRUE, 5);
  
  LLabel := GtkLabelNew('Month :');
  GtkMiscSetAlignment(PGtkMisc(LLabel), 0, 0.5);
  GtkBoxPackStart(PGtkBox(VBox2), LLabel, G_FALSE, G_TRUE, 0);
  
  Adj := PGtkAdjustment(GtkAdjustmentNew(1.0, 1.0, 12.0, 1.0, 5.0, 0.0));
  Spinner := GtkSpinButtonNew(Adj, 0, 0);
  GtkSpinButtonSetWrap(PGtkSpinButton(Spinner), G_TRUE);
  GtkSpinButtonSetShadowType(PGtkSpinButton(Spinner), GTK_SHADOW_ETCHED_IN);
  GtkBoxPackStart(PGtkBox(VBox2), Spinner, G_FALSE, G_TRUE, 0);
  
  VBox2 := GtkVBoxNew(G_FALSE, 0);
  GtkBoxPackStart(PGtkBox(HBox), VBox2, G_TRUE, G_TRUE, 5);
  
  LLabel := GtkLabelNew('Year :');
  GtkMiscSetAlignment(PGtkMisc(LLabel), 0, 0.5);
  GtkBoxPackStart(PGtkBox(VBox2), LLabel, G_FALSE, G_TRUE, 0);
  
  Adj := PGtkAdjustment(GtkAdjustmentNew(1998.0, 0.0, 2100.0, 1.0, 100.0, 0.0));
  Spinner := GtkSpinButtonNew(Adj, 0, 0);
  GtkSpinButtonSetWrap(PGtkSpinButton(Spinner), G_FALSE);
  GtkSpinButtonSetShadowType(PGtkSpinButton(Spinner), GTK_SHADOW_IN);
  GtkWidgetSetUsize(Spinner, 55, 0);
  GtkBoxPackStart(PGtkBox(VBox2), Spinner, G_FALSE, G_TRUE, 0);
  
  Frame := GtkFrameNew('Accelerated');
  GtkBoxPackStart(PGtkBox(MainVBox), Frame, G_TRUE, G_TRUE, 0);
  
  VBox := GtkVBoxNew(G_FALSE, 0);
  GtkContainerSetBorderWidth(PGtkContainer(VBox), 5);
  GtkContainerAdd(PGtkContainer(Frame), VBox);
  
  HBox := GtkHBoxNew(G_FALSE, 0);
  GtkBoxPackStart(PGtkBox(VBox), HBox, G_FALSE, G_TRUE, 5);
  
  VBox2 := GtkVBoxNew(G_FALSE, 0);
  GtkBoxPackStart(PGtkBox(HBox), VBox2, G_TRUE, G_TRUE, 5);
  
  LLabel := GtkLabelNew('Value :');
  GtkMiscSetAlignment(PGtkMisc(LLabel), 0, 0.5);
  GtkBoxPackStart(PGtkBox(VBox2), LLabel, G_FALSE, G_TRUE, 0);
  
  Adj := PGtkAdjustment(GtkAdjustmentNew(0.0, -10000.0, 10000.0, 0.5, 100.0, 0.0));
  Spinner1 := GtkSpinButtonNew(Adj, 1.0, 2);
  GtkSpinButtonSetWrap(PGtkSpinButton(Spinner1), G_TRUE);
  GtkWidgetSetUsize(Spinner1, 100, 0);
  GtkBoxPackStart(PGtkBox(VBox2), Spinner1, G_FALSE, G_TRUE, 0);
  
  VBox2 := GtkVBoxNew(G_FALSE, 0);
  GtkBoxPackStart(PGtkBox(HBox), VBox2, G_TRUE, G_TRUE, 5);
  
  LLabel := GtkLabelNew('Digits :');
  GtkMiscSetAlignment(PGtkMisc(LLabel), 0, 0.5);
  GtkBoxPackStart(PGtkBox(VBox2), LLabel, G_FALSE, G_TRUE, 0);
  
  Adj := PGtkAdjustment(GtkAdjustmentNew(2, 1, 5, 1, 1, 0));
  Spinner2 := GtkSpinButtonNew(Adj, 0.0, 0);
  GtkSpinButtonSetWrap(PGtkSpinButton(Spinner2), G_TRUE);
  GtkSignalConnect(PGtkObject(Adj), 'value_changed', @ChangeDigits, Spinner2);
  GtkBoxPackStart(PGtkBox(VBox2), Spinner2, G_FALSE, G_TRUE, 0);
  
  HBox := GtkHBoxNew(G_FALSE, 0);
  GtkBoxPackStart(PGtkBox(VBox), HBox, G_FALSE, G_TRUE, 5);
  
  Button := GtkCheckButtonNewWithLabel('Snap to 0.5-ticks');
  GtkSignalConnect(PGtkObject(button), 'clicked', @ToggleSnap, Spinner1);
  GtkBoxPackStart(PGtkBox(VBox), Button, G_TRUE, G_TRUE, 0);
  GtkToggleButtonSetActive(PGtkToggleButton(Button), G_TRUE);
  
  Button := GtkCheckButtonNewWithLabel('Numeric only input mode');
  GtkSignalConnect(PGtkObject(button), 'clicked', @ToggleNumeric, Spinner1);
  GtkBoxPackStart(PGtkBox(VBox), Button, G_TRUE, G_TRUE, 0);
  GtkToggleButtonSetActive(PGtkToggleButton(Button), G_TRUE);
  
  ValLabel := GtkLabelNew('');
  
  HBox := GtkHBoxNew(G_FALSE, 0);
  GtkBoxPackStart(PGtkBox(VBox), HBox, G_FALSE, G_TRUE, 5);
  Button := GtkButtonNewWithLabel('Value as Int');
  GtkObjectSetUserData(PGtkObject(Button), ValLabel);
  GtkSignalConnect(PGtkObject(Button), 'clicked', @GetValue, Pointer(1));
  GtkBoxPackStart(PGtkBox(HBox), Button, G_TRUE, G_TRUE, 5);
  
  Button := GtkButtonNewWithLabel('Value as Float');
  GtkObjectSetUserData(PGtkObject(Button), ValLabel);
  GtkSignalConnect(PGtkObject(Button), 'clicked', @GetValue, Pointer(2));
  GtkBoxPackStart(PGtkBox(HBox), Button, G_TRUE, G_TRUE, 5);
  
  GtkBoxPackStart(PGtkBox(VBox), ValLabel, G_TRUE, G_TRUE, 0);
  GtkLabelSetText(PGtkLabel(ValLabel), '0');
  
  HBox := GtkHBoxNew(G_FALSE, 0);
  GtkBoxPackStart(PGtkBox(MainVBox), HBox, G_FALSE, G_TRUE, 0);
  
  Button := GtkButtonNewWithLabel('Close');
  GtkSignalConnectObject(PGtkObject(Button), 'clicked', @GtkWidgetDestroy, PGtkObject(Window));
  GtkBoxPackStart(PGtkBox(HBox), Button, G_TRUE, G_TRUE, 5);

  GtkWidgetShowAll(Window);

  { Enter the event loop }
  GtkMain;
end.
