{ Report bugs to Nicola Girardi <nikke@swlibero.org> }
program StatusBar;

{$include "../units/gtk.inc"}
{$ignore-function-results}

uses GPC;

var
  Window, VBox, Button, StatusBar : PGtkWidget;
  ContextID : GInt;
  Count : Integer = 1;

procedure PushItem(Widget : PGtkWidget; Data : GPointer);
var
  Buff : TString;
begin
  WriteStr(Buff, 'Item ', Count);
  GtkStatusBarPush(PGtkStatusBar(StatusBar), GPOINTER_TO_INT(Data), Buff);
  Inc(Count);
end;

procedure PopItem(Widget : PGtkWidget; Data : GPointer);
begin
  GtkStatusBarPop(PGtkStatusBar(StatusBar), GPOINTER_TO_INT(Data))
end;

begin
  GtkInit;

  { create a new window }
  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);
  GtkWidgetSetUSize(PGtkWidget(Window), 200, 100);
  GtkWindowSetTitle(PGtkWindow(Window), 'GTK Statusbar Example');
  GtkSignalConnect(PGtkObject(Window), 'delete_event', @GtkExit, nil);

  VBox := GtkVBoxNew(G_FALSE, 1);
  GtkContainerAdd(PGtkContainer(Window), VBox);
  GtkWidgetShow(VBox);

  StatusBar := GtkStatusBarNew;
  GtkBoxPackStart(PGtkBox(VBox), StatusBar, G_TRUE, G_TRUE, 0);
  GtkWidgetShow(StatusBar);

  ContextID := GtkStatusBarGetContextID(PGtkStatusBar(StatusBar), 'StatusBar example');
  Button := GtkButtonNewWithLabel('push item');
  GtkSignalConnect(PGtkObject(Button), 'clicked', @PushItem, GINT_TO_POINTER(ContextID));
  GtkBoxPackStart(PGtkBox(VBox), Button, G_TRUE, G_TRUE, 2);
  GtkWidgetShow(Button);

  Button := GtkButtonNewWithLabel('pop last item');
  GtkSignalConnect(PGtkObject(Button), 'clicked', @PopItem, GINT_TO_POINTER(ContextID));
  GtkBoxPackStart(PGtkBox(VBox), Button, G_TRUE, G_TRUE, 2);
  GtkWidgetShow(Button);

  { Always display the window as the last step so it all splashes on
    the screen at once. }
  GtkWidgetShow(Window);

  GtkMain;
end.
