{ Report bugs to Nicola Girardi <nikke@swlibero.org> }
program Table;

{$include "../units/gtk.inc"}
{$ignore-function-results}

uses GPC;

var
  Button1_Str : TString = 'Button1';
  Button2_Str : TString = 'Button2';

{ Our callback. The data passed to this function is printed to stdout. }
procedure Callback (Widget : PGtkWidget; Data : GPointer);
begin
  Writeln('Hello again - ', PString(Data)^, ' was pressed.');
end;

{ This callback quits the program. }
function DeleteCB (Widget : PGtkWidget; Event : PGdkEvent; Data : GPointer) : GInt;
begin
  GtkMainQuit;
  DeleteCB := 0;
end;

var
  Window, Button, Table : PGtkWidget;

begin
  GtkInit;

  { Create a new window. }
  Window := GtkWindowNew(GTK_WINDOW_TOPLEVEL);

  { Set the window title. }
  GtkWindowSetTitle(PGtkWindow(Window), 'Table');

  { Set a handler for delete_event that immediately exits GTK. }
  GtkSignalConnect(PGtkObject(Window), 'delete_event', @DeleteCB, nil);

  { Sets the border width of the window. }
  GtkContainerSetBorderWidth(PGtkContainer(Window), 20);

  { Create a 2x2 table. }
  Table := GtkTableNew(2, 2, G_TRUE);

  { Put the table in the main window. }
  GtkContainerAdd(PGtkContainer(Window), Table);

  { Create first button. }
  Button := GtkButtonNewWithLabel('Button 1');

  { When the button is clicked, we call the "callback" function
    with a pointer to "button 1" as its argument. }
  GtkSignalConnect(PGtkObject(Button), 'clicked', @Callback, @Button1_Str);

  { Insert button 1 into the upper left quadrant of the table. }
  GtkTableAttachDefaults(PGtkTable(Table), Button, 0, 1, 0, 1);

  GtkWidgetshow(Button);

  { Create second button. }
  Button := GtkButtonNewWithLabel('Button 2');

  { When the button is clicked, we call the "callback" function
    with a pointer to "button 2" as its argument. }
  GtkSignalConnect(PGtkObject(Button), 'clicked', @Callback, @Button2_Str);
  { Insert button 2 into the upper right quadrant of the table. }
  GtkTableAttachDefaults(PGtkTable(Table), Button, 1, 2, 0, 1);

  GtkWidgetShow(Button);

  { Create "Quit" button. }
  Button := GtkButtonNewWithLabel('Quit');

  { When the button is clicked, we call the "delete_event" function
    and the program exits. }
  GtkSignalConnect(PGtkObject(Button), 'clicked', @DeleteCB, nil);

  { Insert the quit button into the both lower quadrants of the table. }
  GtkTableAttachDefaults(PGtkTable(Table), Button, 0, 2, 1, 2);

  GtkWidgetShow(Button);
  GtkWidgetShow(Table);
  GtkWidgetShow(Window);

  GtkMain;
end.
