/*
Type definitions grabber for C header files.
Copyright (C) 2001 Nicola Girardi <nikke@swlibero.org>

This lexer is free software; you can redistribute it and/or
modify it under the terms of the GNU lexer General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This lexer is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
lexer General Public License for more details.

You should have received a copy of the GNU lexer General Public
License along with this lexer; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
*/

%option noyywrap
%pointer

%x Declaration
%x TypeDef

%{

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

%}

OPT_SEPS [\ \t]*
SEPS [\ \t]+
ID [[:alpha:]_][[:alnum:]_]*

TYPEDEF "typedef"{SEPS}{ID}+
FUNCPOINTER \(\*{ID}\){SEPS}
OTHERDECL {ID}{OPT_SEPS}";"

%%

                       BEGIN(Declaration);

<Declaration>{TYPEDEF} BEGIN(TypeDef);

<TypeDef>{FUNCPOINTER} {
                         char *s, *p = yytext;
                         if ((s = strchr(p, ')')) ||
                             (s = strchr(p, ' ')) ||
                             (s = strchr(p, '\t')))
                                 *s = '\0';
                         p += 2;
                         fprintf(stdout, "%s\n", p, p);
                         BEGIN(Declaration);
                       }

<TypeDef>{OTHERDECL} {
                       char *s, *p = yytext;
                       if ((s = strchr(p, ';')) ||
                           (s = strchr(p, ' ')) ||
                           (s = strchr(p, '\t')))
                               *s = '\0';
                       fprintf(stdout, "%s\n", p, p);
                       BEGIN(Declaration);
                     }

<*>\n
<*>.

%%

int main(int argc, char *argv[])
{
        if (argc != 1)
                fprintf(stderr, "%s: ignoring arguments, reading from stdin...\n", argv[0]);
        yyin = stdin;
        yylex();
        return 0;
}
