{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GDK - The GIMP Drawing Kit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

{ From gdk.h, gdkrgb.h }

Unit Gdk;
  Interface

Uses
  Gpc, GLib, GdkTypes;

Const
  { GdkRgbDither }
  GDK_RGB_DITHER_NONE =0;
  GDK_RGB_DITHER_NORMAL=1;
  GDK_RGB_DITHER_MAX=2;

  
  
Type
  PGdkRgbCmap = ^GdkRgbCmap;
  GdkRgbDither = Integer;

  { only for GdkRgbCMap }
  GdkRgbCMapFrame1 = array [0..255] of guint32;
  GdkRgbCmapFrame2 = array [0..255] of guchar;
  GdkRgbCmap  = Record
    colors : GdkRgbCMapFrame1;  
    lut : GdkRgbCMapFrame2;  
  End;


  { Initialization, exit and events }
Procedure GdkInit;
Function GdkInitCheck : gboolean;

Procedure GdkExit(errcode :  gint);
  asmname 'gdk_exit';
Function GdkSetLocale : pgchar;
  asmname 'gdk_set_locale';

  {* Push and pop error handlers for X errors *}
Procedure GdkErrorTrapPush;
  asmname 'gdk_error_trap_push';
Function GdkErrorTrapPop : gint;
  asmname 'gdk_error_trap_pop';

Function GdkEventPending : gboolean;
  asmname 'gdk_events_pending';
Function GdkEventGet : PGdkEvent;
  asmname 'gdk_event_get';
Function GdkEventPeek : PGdkEvent;
  asmname 'gdk_event_peek';
Function GdkEventGetGraphicsExpose(window:PGdkWindow) : PGdkEvent;
  asmname 'gdk_event_get_graphics_expose';
Procedure GdkEventPut(evt : PGdkEvent);
  asmname 'gdk_event_put';
Function GdkEventCopy(evt : PGdkEvent) : PGdkEvent;
  asmname 'gdk_event_copy';
Procedure GdkEventFree(evt : PGdkEvent);
  asmname 'gdk_event_free';
Function GdkEventGetTime(evt : PGdkEvent) : guint32;
  asmname 'gdk_event_get_time';
Procedure GdkEventHandlerSet(eventFunc : GdkEventFunc; 
                          data:gpointer; notify:GDestroyNotify);
  asmname 'gdk_event_handler_set';
Procedure GdkSetShowEvents(show : gboolean);
  asmname 'gdk_set_show_events';
Procedure GdkSetUseXshm(usexshm : gboolean);
  asmname 'gdk_set_use_xshm';
Function GdkGetShowEvents : gboolean;
  asmname 'gdk_get_show_events';
Function GdkGetUseXshm : gboolean;
  asmname 'gdk_get_use_xshm';
Function GdkGetDisplay : PGChar;
  asmname 'gdk_get_display';

Function GdkTimeGet : guint32; 
  asmname 'gdk_time_get';
Function GdkTimerGet : guint32;
  asmname 'gdk_timer_get';
Procedure GdkTimerSet(milliseconds : guint32);
  asmname 'gdk_timer_set';
Procedure GdkTimerEnable;
  asmname 'gdk_timer_enable';
Procedure GdkTimerDisable;
  asmname 'gdk_timer_disable';

Function GdkInputAddFull(source: gint; cond:GdkInputCondition;
                        funktion : GdkInputFunction; data:gpointer;
                        destr : GdkDestroyNotify) : gint;
  asmname 'gdk_input_add_full';
Function GdkInputAdd(   source: gint; cond:GdkInputCondition;
                        funktion : GdkInputFunction; data:gpointer) : gint;
  asmname 'gdk_input_add';
Procedure GdkInputRemove(tag : gint);
  asmname 'gdk_input_remove';
Function GdkPointerGrab (win:PGdkWindow; ownerEvents:gint; 
                        EventMask:GdkEventMask;
                        confine:PGdkWindow; cursor:PGdkCursor;
                        time:guint32) : gint;
  asmname 'gdk_pointer_grab';
Procedure GdkPointerUngrab(time : guint32);
  asmname 'gdk_pointer_ungrab';
Function GdkKeyboardGrab(win:PGdkWindow; ownerEvt:gboolean; time:guint32):gint;
  asmname 'gdk_keyboard_grab';
Procedure GdkKeyboardUngrab(time:guint32);
  asmname 'gdk_keyboard_ungrab';
Function GdkPointerIsGrabbed : gboolean;
  asmname 'gdk_pointer_is_grabbed';

Function GdkScreenWidth : gint;
  asmname 'gdk_screen_width';
Function GdkScreenHeight : gint;
  asmname 'gdk_screen_height';
Function GdkScreenWidthMm : gint;
  asmname 'gdk_screen_width_mm';
Function GdkScreenHeightMm : gint;
  asmname 'gdk_screen_height_mm';
Procedure GdkFlush;
  asmname 'gdk_flush';
Procedure GdkBeep;
  asmname 'gdk_beep';
Procedure GdkKeyRepeatDisable;
  asmname 'gdk_key_repeat_disable';
Procedure GdkKeyRepeatRestore;
  asmname 'gdk_key_repeat_restore';

  {* Visuals *}
Function GdkVisualGetBestDepth : gint;
  asmname 'gdk_visual_get_best_depth';
Function GdkVisualGetBestType : GdkVisualType;
  asmname 'gdk_visual_get_best_type';
Function GdkVisualGetSystem : PGdkVisual;
  asmname 'gdk_visual_get_system';
Function GdkVisualGetBest : PGdkVisual;
  asmname 'gdk_visual_get_best';
Function GdkVisualGetBestWidthDepth(depth : gint) : PGdkVisual;
  asmname 'gdk_visual_get_best_with_depth';
Function GdkVisualGetBestWidthType(visualType : GdkVisualType) : PGdkVisual;
  asmname 'gdk_visual_get_best_with_type';
Function GdkVisualGetBestWidthBoth(depth:gint; visualType:GdkVisualType) : PGdkVisual;
  asmname 'gdk_visual_get_best_with_both';

  {* Actually, these are no-ops... *}
Function GdkVisualRef(vis : GdkVisual) : PGdkVisual;
  asmname 'gdk_visual_ref';
Procedure GdkVisualUnref(vis : PGdkVisual);
  asmname 'gdk_visual_unref';
Procedure GdkQueryDepths(depths: ppgint; count : pgint);
  asmname 'gdk_query_depths';
Procedure GdkQueryVisualTypes(vis : PPGdkVisualType; count :pgint);
  asmname 'gdk_query_visual_types';
Function GdkListVisuals : PGList;
  asmname 'gdk_list_visuals';

  {* Windows *}
Function GdkwindowNew(parent:PGdkwindow; attr:PGdkwindowAttr;
                      mask:gint) : PGdkWindow;
  asmname 'gdk_window_new';
Procedure GdkwindowDestroy(win : PGdkWindow);
  asmname 'gdk_window_destroy';
Function GdkWindowRef(win:PGdkWindow) : PGdkWindow;
  asmname 'gdk_window_ref';
Procedure GdkWindowUnref(win:PGdkWindow);
  asmname 'gdk_window_unref';
Function GdkWindowAtPointer(winX, winY : pgint) : PGdkwindow;
  asmname 'gdk_window_at_pointer';
Procedure GdkWindowShow(win:PGdkWindow);
  asmname 'gdk_window_show';
Procedure GdkWindowHide(win:PGdkWindow);
  asmname 'gdk_window_hide';
Procedure GdkWindowWithdraw(win:PGdkwindow);
  asmname 'gdk_window_withdraw';
Procedure GdkWindowMove(win:PGdkWindow; x, y:gint);
  asmname 'gdk_window_move';
Procedure GdkWindowResize(win:PGdkWindow; width, height:gint);
  asmname 'gdk_window_resize';
Procedure GdkwindowMoveResize(win:PGdkWindow; x, y, widht, height : gint);
  asmname 'gdk_window_move_resize';
Procedure GdkWindowReparent(win, newparent:PGdkWindow; x,y:gint);
  asmname 'gdk_window_reparent';
Procedure GdkWindowClear(win:PGdkWindow);
  asmname 'gdk_window_clear';
Procedure GdkWindowClearArea(win:PGdkWindow;x, y, width, height:gint);
  asmname 'gdk_window_clear_area';
Procedure GdkWindowClearAreaE(win:PGdkwindow; x, y, width, height:gint);
  asmname 'gdk_window_clear_area_e';
Procedure GdkWindowCopyArea(win:PGdkWindow; gc:PGdkGC; x, y:gint;
                            sourceWin:PGdkWindow;
                            sourceX, sourceY, width, height:gint);
  asmname 'gdk_window_copy_area';
Procedure GdkWindowRaise(win:PGdkwindow);
  asmname 'gdk_window_raise';
Procedure GdkWindowLower(win:PGdkWindow);
  asmname 'gdk_window_lower';
Procedure GdkWindowSetUserData(win:PGdkWindow; data:gpointer);
  asmname 'gdk_window_set_user_data';
Procedure GdkWindowSetOverrideRedirect(win:PGdkWindow; overr:gboolean);
  asmname 'gdk_window_set_override_redirect';
Procedure GdkWindowAddFilter(win:PGdkWindow;f:GdkFilterFunc;data:gpointer);
  asmname 'gdk_window_add_filter';
Procedure GdkwindowRemoveFilter(win:PGdkwindow;f:GdkfilterFunc;data:gpointer);
  asmname 'gdk_window_remove_filter';

{* 
 * This allows for making shaped (partially transparent) windows
 * - cool feature, needed for Drag and Drag for example.
 *  The shape_mask can be the mask
 *  from gdk_pixmap_create_from_xpm.   Stefan Wille
 *}
Procedure GdkwindowShapeCombineMask(win:PGdkwindow; shape:PGdkBitmap;
                            offstX, offstY : gint);
  asmname 'gdk_window_shape_combine_mask';

{*
 * This routine allows you to quickly take the shapes of all the child windows
 * of a window and use their shapes as the shape mask for this window - useful
 * for container windows that dont want to look like a big box
 * 
 * - Raster
 *}
Procedure GdkWindowSetChilsShapes (win : PGdkwindow);
  asmname 'gdk_window_set_child_shapes';

{*
 * This routine allows you to merge (ie ADD) child shapes to your
 * own window's shape keeping its current shape and ADDING the shild
 * shapes to it.
 * 
 * - Raster
 *}
Procedure GdkWindowMergeChildShapes(win:PGdkwindow);
  asmname 'gdk_window_merge_child_shapes';

{*
 * Check if a window has been shown, and whether all it's
 * parents up to a toplevel have been shown, respectively.
 * Note that a window that is_viewable below is not necessarily
 * viewable in the X sense.
 *}
Function GdkWindowIsVisible(win:PGdkwindow)  :gboolean;
  asmname 'gdk_window_is_visible';
Function GdkWindowIsViewable(win:PGdkwindow) :gboolean;
  asmname 'gdk_window_is_viewable';

 { Set static bit gravity on the parent, and static
 * window gravity on all children.
 }
Function GdkwindowSetStaticGravities(win:PGdkWindow; 
                            useStatic:gboolean) : gboolean;
  asmname 'gdk_window_set_static_gravities';

 {
 * The following function adds a global filter for all client
 * messages of type message_type
 }
Procedure GdkAddClientMessageFilter(msgtype:GdkAtom;
                            func:GdkFilterFunc; data:gpointer);
  asmname 'gdk_add_client_message_filter';

 { Drag and Drop }
Function GdkDragContextNew : PGdkDragContext;
  asmname 'gdk_drag_context_new';
Procedure GdkDragContextRef(context:PGdkDragcontext);
  asmname 'gdk_drag_context_ref';
Procedure GdkDragContextRef(context:PGdkDragcontext);
  asmname 'gdk_drag_context_unref';

 { Destination side }
Procedure GdkDragStatus(ctx:PGdkDragContext;action:GdkDragAction;t:guint32);
  asmname 'gdk_drag_status';
Procedure GdkDropReply(ctx:PGdkDragcontext; ok:gboolean; time:guint32);
  asmname 'gdk_drop_reply';
Procedure GdkDropFinish(ctx:PGdkDragContext;success:gboolean; time:guint32);
  asmname 'gdk_drop_finish';
Function GdkDragGetSelection(ctx:PGdkDragcontext) : GdkAtom;
  asmname 'gdk_drag_get_selection';

 { Source side }
Function GdkDragBegin(win:PGdkWindow; targets:PGlist) : PGdkDragContext;
  asmname 'gdk_drag_begin';
Function GdkDragGetProtocol(xid:guint32; proto:PGdkDragProtocol):guint32;
  asmname 'gdk_drag_get_protocol';
Procedure GdkDragFindWindow(ctx:PGdkDragcontext; win:PGdkWindow;
                        xRoot, yRoot:gint;dests:PPGdkwindow;
                        proto:GdkDragProtocol);
  asmname 'gdk_drag_find_window';
Function GdkDragMotion(ctx:PGdkDragContext;win:PGdkWindow;pr:GdkDragProtocol;
                       xRoot,yRoot:gint; suggest, possible:GdkDragAction;
                       time:guint32) : gboolean;
  asmname 'gdk_drag_motion';
Procedure GdkDragDrop(ctx:PGdkDragContext; time:guint32);
  asmname 'gdk_drag_drop';
Procedure GdkDragAbort(ctx:PGdkDragContext; time:guint32);
  asmname 'gdk_drag_abort';

 { GdkWindow }
Procedure GdkWindowSethints(win:PGdkWindow; x, y, minWidth, minHeight,
                            maxWidth, maxHeight, flags : gint);
  asmname 'gdk_window_set_hints';
Procedure GdkWindowSetGeometryHints(win:PGdkWindow;
                            geo:PGdkGeometry; flags:GdkWindowHints);
  asmname 'gdk_window_set_geometry_hints';
Procedure GdkSetSmClientId(id : PGChar);
  asmname 'gdk_set_sm_client_id';
Procedure GdkWindowSetTitle(win:PGdkWindow; title:PGChar);
  asmname 'gdk_window_set_title';
Procedure GdkWindowSetRole(win:PGdkWindow; role:PGChar);
  asmname 'gdk_window_set_role';
Procedure GdkWindowSetTransientFor(win, leader:PGdkWindow);
  asmname 'gdk_window_set_transient_for';
Procedure GdkWindowSetBackground(win:PGdkWindow; color:PGdkcolor);
  asmname 'gdk_window_set_background';
Procedure GdkWindowSetBackPixmap(win:PGdkWindow;
                                pix:PGdkPixmap;parent:gboolean);
  asmname 'gdk_window_set_back_pixmap';
Procedure GdkWindowSetCursor(win:PGdkWindow; cursor:PGdkCursor);
  asmname 'gdk_window_set_cursor';
Procedure GdkwindowSetColorMap(win:PGdkWindow; colmap:PGdkColorMap);
  asmname 'gdk_window_set_colormap';
Procedure GdkWindowGetUserData(win:PGdkwindow; Var data : gpointer);
  asmname 'gdk_window_get_user_data';
Procedure GdkWindowGetGeometry(win:PGdkWindow; Var x,y,width,height,depth:GInt);
  asmname 'gdk_window_get_geometry';
Procedure GdkWindowGetPosition(win:PGdkWindow; Var  x, y : GInt);
  asmname 'gdk_window_get_position';
Procedure GdkWindowGetSize(win:PGdkWindow; Var width, height:gint);
  asmname 'gdk_window_get_size';
Function GdkWindowGetVisual(win:PGdkWindow) : PGdkVisual;
  asmname 'gdk_window_get_visual';
Function GdkWindowGetColormap(win:PGdkWindow) : PGdkColormap;
  asmname 'gdk_window_get_colormap';
Function GdkWindowGetType(win:PGdkWindow) : GdkWindowType;
  asmname 'gdk_window_get_type';
Function GdkwindowGetOrigin(win:PGdkWindow; Var x, y : gint) : gint;
  asmname 'gdk_window_get_origin';
Function GdkWindowGetDeskrelativeOrigin(win:PGdkWindow;Var x,y:gint):gboolean;
  asmname 'gdk_window_get_deskrelative_origin';
Procedure GdkwindowGetRootOrigin(win:PGdkWindow; Var x,y:gint);
  asmname 'gdk_window_get_root_origin';
Function GdkWindowGetPointer(win:PGdkWindow; Var x,y:gint;
                            var mask:GdkModifierType) : PGdkwindow;
  asmname 'gdk_window_get_pointer';
Function GdkWindowGetParent(win:PGdkWindow) : PGdkwindow;
  asmname 'gdk_window_get_parent';
Function GdkWindowGetToplevel(win:PGdkWindow) : PGdkWindow;
  asmname 'gdk_window_get_toplevel';
Function GdkwindowGetChildren(win:PGdkWindow):PGlist;
  asmname 'gdk_window_get_children';
Function GdkWindowGetEvents(win:PGdkWindow):GdkEventMask;
  asmname 'gdk_window_get_events';
Procedure GdkWindowSetEvents(win:PGdkwindow; evtMask:GdkEventMask);
  asmname 'gdk_window_set_events';
Procedure GdkWindowSetIcon(win,iwin:GdkWindow; pix:PGdkPixmap; m:PGdkBitmap);
  asmname 'gdk_window_set_icon';
Procedure GdkwindowSetIconName(win:PGdkWindow; name:PGChar);
  asmname 'gdk_window_set_icon_name';
Procedure GdkWindowSetGroup(win, leader:PGdkWindow);
  asmname 'gdk_window_set_group';
Procedure GdkwindowSetDecorations(win:PGdkwindow; deco:GdkWMDecoration);
  asmname 'gdk_window_set_decorations';
Procedure GdkWindowSetFunctions(win:PGdkWindow; f:GdkWMFunction);
  asmname 'gdk_window_set_functions';
Function GdkWindowGetToplevels : PGList;
  asmname 'gdk_window_get_toplevels';
Procedure GdkwindowRegisterDnd(win:PGdkWindow);
  asmname 'gdk_window_register_dnd';
Procedure GdkDrawableSetData(draw:PGdkDrawable; key:PGChar; 
                            data:gpointer; destroyfunc:GDestroyNotify);
  asmname 'gdk_drawable_set_data';

 { Cursors }
Function GdkCursorNew(cursType:GdkCursorType) : PGdkCursor;
  asmname 'gdk_cursor_new';
Function GdkCursorNewFromPixmap(source,mask:PGdkPixmap; fg, bg: PGdkcolor;
                            x, y:gint) : PGdkCursor;
  asmname 'gdk_cursor_new_from_pixmap';
Procedure GdkCursorDestroy(cursor:PGdkCursor);
  asmname 'gdk_cursor_destroy';

 { GCs }
Function GdkGcNew(win:PGdkWindow) : PGdkGc;
  asmname 'gdk_gc_new';
Function GdkGcNewWithValues(win:PGdkWindow; values:PGdkGCValues;
                            mask : GdkGCValuesMask) : PGdkGC;
  asmname 'gdk_gc_new_with_values';
Function GdkGcRef(gc:PGdkGC) : PGdkGC;
  asmname 'gdk_gc_ref';
Procedure GdkGcUnref(gc:PGdkGC);
  asmname 'gdk_gc_unref';
Procedure GdkGcDestroy(gc:PGdkGc);
  asmname 'gdk_gc_destroy';
Procedure GdkGcGetValues(gc:PGdkGC; values:PGdkGCValues);
  asmname 'gdk_gc_get_values';
Procedure GdkGcSetForeground(gc:PGdkGC; color:PGdkColor);
  asmname 'gdk_gc_set_foreground';
Procedure GdkGcSetBackground(gc:PGdkGc; color:PGdkColor);
  asmname 'gdk_gc_set_background';
Procedure GdkGcSetFont(gc:PGdkGC; font:PGdkFont);
  asmname 'gdk_gc_set_font';
Procedure GdkGcSetFunction(gc:PGdkGc; f:GdkFunction);
  asmname 'gdk_gc_set_function';
Procedure GdkGcSetFill(gc:PGdkGC; fill:GdkFill);
  asmname 'gdk_gc_set_fill';
Procedure GdkGcSetTile(gc:PGdkGC; tile:PGdkPixmap);
  asmname 'gdk_gc_set_tile';
Procedure GdkGcSetStripple(gc:PGdkGC; stripple:PGdkPixmap);
  asmname 'gdk_gc_set_stipple';
Procedure GdkGcSetTsOrigin(gc:PGdkGC; x, y:gint);
  asmname 'gdk_gc_set_ts_origin';
Procedure GdkGcSetClipOrigin(gc:GdkGC; x,y:gint);
  asmname 'gdk_gc_set_clip_origin';
Procedure GdkGcSetClipMask(gc:GdkGC; mask:PGdkBitmap);
  asmname 'gdk_gc_set_clip_mask';
Procedure GdkGcSetClipRectangle(gc:PGdkGC; rect:PGdkRectangle);
  asmname 'gdk_gc_set_clip_rectangle';
Procedure GdkGcSetClipRegion(gc:PGdkGc; region:PGdkRegion);
  asmname 'gdk_gc_set_clip_region';
Procedure GdkGcSetSubwindow(gc:PGdkGC; mode:GdkSubwindowMode);
  asmname 'gdk_gc_set_subwindow';
Procedure GdkGcSetExposures(gc:GdkGC; exposures:gboolean);
  asmname 'gdk_gc_set_exposures';
Procedure GdkGcSetLineAttributes(gc:PGdkGC; line:gint; lStyle:GdkLineStyle;
                        cStyle:GdkCapStyle; jStyle:GdkJoinStyle);
  asmname 'gdk_gc_set_line_attributes';
Procedure GdkSetDashes(gc:GdkGC; dashOffset:gint; dashList:pgint8; n:gint);
  asmname 'gdk_gc_set_dashes';
Procedure GdkGcCopy(dst, src:PGdkGc);
  asmname 'gdk_gc_copy';

 { Pixmaps }
Function GdkPixmapNew(win:PGdkWindow; width, height, depth : gint) : PGdkPixmap;
  asmname 'gdk_pixmap_new';
Function GdkBitmapCreateFromData(win:PGdkWindow;data:PGChar;
                        width,height:gint):PGdkBitmap;
  asmname 'gdk_bitmap_create_from_data';

function GdkPixmapCreateFromData(Win : PGdkWindow; Data : PGChar; Width, Height, Depth : Gint; Foreground, Background : PGdkColor): PGdkPixmap;
asmname 'gdk_pixmap_create_from_data';

Function GdkPixmapCreateFromXpm(win:PGdkWindow; mask:PPGdkBitmap;
                            trans:PGdkcolor; filename:PGChar) : PGdkPixmap;
  asmname 'gdk_pixmap_create_from_xpm';
Function GdkPixmapColormapCreateFromXpm(win:GdkWindow; map:PPGdkColormap; 
                            mask:PPGdkBitmap;
                            trans:PGdkcolor; filename:PGChar) : PGdkPixmap;
  asmname 'gdk_pixmap_colormap_create_from_xpm';
Function GdkPixmapCreateFromXpmD(win:PGdkWindow; mask:PPGdkBitmap;
                            transcol:PGdkcolor; data : ppgchar):PGdkPixmap;
  asmname 'gdk_pixmap_create_from_xpm_d';
Function GdkPixmapColormapCreateFromXpmD(win:PGdkWindow; colmap:GdkColormap;
                            mask:PPGdkBitmap; trans:PGdkColor;
                            data:ppgchar) : PGdkPixmap;
  asmname 'gdk_pixmap_colormap_create_from_xpm_d';
Function GdkPixmapRef(pix :PGdkPixmap) : PGdkPixmap;
  asmname 'gdk_pixmap_ref';
Procedure GdkPixmapUnref(pix:PGdkPixmap);
  asmname 'gdk_pixmap_unref';
Function GdkBitmapRef(pix:PGdkPixmap) : PGdkBitmap;
  asmname 'gdk_bitmap_ref';
Procedure GdkBitmapUnref(pix:PGdkPixmap);
  asmname 'gdk_bitmap_unref';

 { Images }
Function GdkImageNewBitmap(visual:PGdkVisual;d:gpointer;w,h:gint):PGdkImage;
  asmname 'gdk_image_new_bitmap';
Function GdkImageNew(typ:GdkImageType; vis:PGdkVisual; 
                        width, height:gint):PGdkImage;
  asmname 'gdk_image_new';
Function GdkImageGet(win:PGdkWindow; x,y,width,height : gint) : PGdkImage;
  asmname 'gdk_image_get';
Procedure GdkImagePutPixel(img:PGdkImage; x,y:gint; pix:guint32);
  asmname 'gdk_image_put_pixel';
Function GdkImageGetPixel(img:PGdkImage; x, y: gint) : guint32;
  asmname 'gdk_image_get_pixel';
Procedure GdkImageDestroy(img:PGdkImage);
  asmname 'gdk_image_destroy';

 { Color }
Function GdkColormapNew(vis:PGdkVisual; allocate:gboolean):PGdkColormap;
  asmname 'gdk_colormap_new';
Function GdkColormapRef(cmap:PGdkColormap):PGdkColormap;
  asmname 'gdk_colormap_ref';
Procedure GdkColormapUnref(cmap:PGdkColormap);
  asmname 'gdk_colormap_unref';
Function GdkColormapGetSystem : PGdkColormap;
  asmname 'gdk_colormap_get_system';
Function GdkColormapGetSystemSize : gint;
  asmname 'gdk_colormap_get_system_size';
Procedure GdkColormapChange(col:PGdkColormap; ncol:gint);
  asmname 'gdk_colormap_change';

procedure GdkColormapSync(Colormap : PGdkColormap; NColors : GInt);
asmname 'gdk_colormap_sync';

Function GdkColormapAllocColors(colmap:PGdkColormap; colors:PGdkColor;
                            ncolors:gint; writable, best : gboolean;
                            success:pgboolean) : gint;
  asmname 'gdk_colormap_alloc_colors';
Function GdkColormapAllocColor(cmap:PGdkColormap; color:PGdkColor;
                            write, best : gboolean) : gboolean;
  asmname 'gdk_colormap_alloc_color';
Procedure GdkColorMapFreeColors(cmap:PGdkcolormap; c:PGdkcolor;
                            numColors:gint);
  asmname 'gdk_colormap_free_colors';
Function GdkColormapGetVisual(cmap:PGdkColormap) : PGdkVisual;
  asmname 'gdk_colormap_get_visual';
Function GdkColorCopy(color:PGdkColor) : PGdkColor;
  asmname 'gdk_color_copy';
Procedure GdkColorFree(color:PGdkColor);
  asmname 'gdk_color_free';
Function GdkColorParse(spec:PGChar; colr:PGdkColor) : gboolean;
  asmname 'gdk_color_parse';
Function GdkcolorHash(colorA, colorB : PGdkColor) : guint;
  asmname 'gdk_color_hash';
Function GdkColorEqual(colorA, colorB : PGdkColor) : gboolean;
  asmname 'gdk_color_equal';

function GdkColorAlloc(Colormap : PGdkColormap; Color : PGdkColor) : GBoolean;
asmname 'gdk_color_alloc';

 { Fonts }
Function GdkFontLoad(fontName : PGChar) : PGdkFont;
  asmname 'gdk_font_load';
Function GdkFontsetLoad(fontsetName : PGChar) : PGdkFont;
  asmname 'gdk_fontset_load';
Function GdkFontRef(f:PGdkFont) : PGdkFont;
  asmname 'gdk_font_ref';
Procedure GdkFontUnref(f:PGdkFont);
  asmname 'gdk_font_unref';
Function GdkFontId(f:PGdkFont) : gint;
  asmname 'gdk_font_id';
Function GdkFontEqual(fontA, fontB : PGdkFont) : gboolean;
  asmname 'gdk_font_equal';
Function GdkStringWidth(f:PGdkFont; stringg:PGChar) : gint;
  asmname 'gdk_string_width';
Function GdkTextWidth(f:PGdkFont; textt:PGChar; textLen : gint) : gint;
  asmname 'gdk_text_width';

(*@@ t is of GdkWChar* *)
Function GdkTextWidthWc(f:PGdkFont; textt:PGChar; len : gint) : gint;
  asmname 'gdk_text_width_wc';

Function GdkCharWidth(f:PGdkFont; ccharr:gchar) : gint;
  asmname 'gdk_char_width';
Function GdkCharWidthWc(f:PGdkFont; wideCharr:GdkWChar) : gint;
  asmname 'gdk_char_width_wc';
Function GdkStringMeasure(f:PGdkFont; stringg:PGChar) : gint;
  asmname 'gdk_string_measure';
Function GdkTextMeasure(f:PGdkFont; textt:PGChar; len:gint) : gint;
  asmname 'gdk_text_measure';
Function GdkCharMeasure(f:PGdkFont; charr:gchar) : gint;
  asmname 'gdk_char_measure';
Function GdkStringHeight(f:PGdkFont; stringg:PGChar) : gint;
  asmname 'gdk_string_height';
Function GdkTextHeight(f:PGdkFont; textt:PGChar; textLen:gint) : gint;
  asmname 'gdk_text_height';
Function GdkCharHeight(f:PGdkFont; charr:gchar) : gint;
  asmname 'gdk_char_height';
Procedure GdkTextExtents(f:PGdkfont; textt:PGChar; textLen:gint; 
                            lBering, rBering, width, ascend, descend : pgint);
  asmname 'gdk_text_extents';

(*@@ t is of GdkWChar* *)
Procedure GdkTextExtentsWc(f:PGdkfont; textt:PGChar; textLen:gint; 
                            lBering, rBering, width, ascend, descend : pgint);
  asmname 'gdk_text_extents_wc';
Procedure GdkStringExtents(f:PGdkfont; textt:PGChar;
                            lBering, rBering, width, ascend, descend : pgint);
  asmname 'gdk_string_extents';

 { Drawing }
Procedure GdkDrawPoint(draw:PGdkDrawable; gc:PGdkGC; x, y : gint);
  asmname 'gdk_draw_point';
Procedure GdkDrawLine(draw:PGdkDrawable; gc:PGdkGC; x1, y1, x2, y2: gint);
  asmname 'gdk_draw_line';
Procedure GdkDrawRectangle(draw:PGdkDrawable; gc:PGdkGC; fill,
                        x,y,width,height: gint);
  asmname 'gdk_draw_rectangle';
Procedure GdkDrawArc(draw:PGdkDrawable; gc:PGdkGC; fill,
                        x,y,width,height,angle1,angle2: gint);
  asmname 'gdk_draw_arc';
Procedure GdkDrawPolygon(draw:PGdkDrawable; gc:PGdkGC; p:PGdkPoint; num:gint);
  asmname 'gdk_draw_polygon';
Procedure GdkDrawString(draw:PGdkDrawable; f:PGdkFont; gc:PGdkGC; 
                            x,y:gint; stringg:PGChar);
  asmname 'gdk_draw_string';
Procedure GdkDrawText(draw:PGdkDrawable; f:PGdkFont; gc:PGdkGC; 
                            x,y:gint; textt:PGChar; len:gint);
asmname 'gdk_draw_text';

(*@@ t is of GdkWChar* *)
Procedure GdkDrawTextWc(draw:PGdkDrawable; f:PGdkFont; gc:PGdkGC; 
                            x,y:gint; textt:PGChar; len:gint);
  asmname 'gdk_draw_text_wc';
Procedure GdkDrawPixmap(draw:PGdkDrawable; gc:PGdkGC; src:PGdkDrawable;
                            xSource, ySource, xDest, yDest, 
                            width, height : gint);
  asmname 'gdk_draw_pixmap';
Procedure GdkDrawBitmap(draw:PGdkDrawable; gc:PGdkGC; src:PGdkDrawable;
                            xSource, ySource, xDest, yDest, 
                            width, height : gint);
  asmname 'gdk_draw_bitmap';
Procedure GdkDrawImage(draw:PGdkDrawable; gc:PGdkGC; img:PGdkImage;
                            xSource, ySource, xDest, yDest, 
                            width, height : gint);
  asmname 'gdk_draw_image';
Procedure GdkDrawPoints(draw:PGdkDrawable; gc:PGdkGC; p:PGdkPoint; num:gint);
  asmname 'gdk_draw_points';
Procedure GdkDrawSegments(draw:PGdkDrawable; gc:PGdkGC; s:PGdkSegment; num:gint);
  asmname 'gdk_draw_segments';
Procedure GdkDrawLines(draw:PGdkDrawable; gc:PGdkGC; p:PGdkPoint; num:gint);
  asmname 'gdk_draw_lines';

 { Selections }
Function GdkSelectionOwnerSet(o:PGdkWindow; sel:GdkAtom; time:guint32;
                            evt:gint) : gboolean;
  asmname 'gdk_selection_owner_set';
Function GdkSelectionOwnerGet(sel:GdkAtom) : PGdkWindow;
  asmname 'gdk_selection_owner_get';
Procedure GdkSelectionConvert(request:PGdkWindow;slctn,trgt:GdkAtom;time:guint32);
  asmname 'gdk_selection_convert';
Function GdkSelectionPropertyGet(req:PGdkWindow; Var data:pguchar;
                            Var proptype: GdkAtom; Var propFormat:gint) : gboolean;
  asmname 'gdk_selection_property_get';
Procedure GdkSelectionSendNotify(req:guint32; slctn,trgt,prprty:GdkAtom;
                            time:guint32);
  asmname 'gdk_selection_send_notify';

Function GdkTextPropertyToTextList(enc:GdkAtom; frmt:gint; textt:PGChar;
                            len:gint; var list: PPGChar) : gint;
  asmname 'gdk_text_property_to_text_list';
Procedure GdkFreeTextList(list:PPGChar);
  asmname 'gdk_free_text_list';
Function GdkStringToCompoundText(s:PGChar; encdng:PGdkAtom; frmt:pgint;
                            ctext:PPGChar; len:pgint) : gint;
  asmname 'gdk_string_to_compound_text';
Procedure GdkFreeCompoundText(ctext:PGChar);
  asmname 'gdk_free_compound_text';

 { Properties }
Function GdkAtomIntern(aname:PGChar; onlyIfExists : gint) : GdkAtom;
  asmname 'gdk_atom_intern';
Function GdkAtomName(atom : GdkAtom) : PGChar;
  asmname 'gdk_atom_name';
Function GdkPropertyGet(win:PGdkWindow; prprty, typ: GdkAtom;
                            offst,len:gulong; pdel:gint; Var actlProp:GdkAtom;
                            Var actlFormat,actlLen:gint;data:PGChar):gboolean;
  asmname 'gdk_property_get';
Procedure GdkPropertyChange(win:PGdkWindow; prprty, typ:GdkAtom; frmt:gint;
                            mode:GdkPropMode; data:PGChar; nelem:gint);
  asmname 'gdk_property_change';
Procedure GdkPropertyDelete(win:PGdkWindow; prprty:GdkAtom);
  asmname 'gdk_property_delete';

 { Rectangle utilities }
Function GdkRectangleIntersect(src1, src2, dest:PGdkRectangle) : gboolean;
  asmname 'gdk_rectangle_intersect';
Procedure GdkRectangleUnion(src1, src2, dest:PGdkRectangle);
  asmname 'gdk_rectangle_union';

 { XInput support }
Procedure GdkInputInit;
  asmname 'gdk_input_init';
Procedure GdkInputExit;
  asmname 'gdk_input_exit';
Function GdkInputListDevices : PGList;
  asmname 'gdk_input_list_devices';
Procedure GdkInputSetExtensionEvents(win:PGdkWindow; mask:gint;
                            mode:GdkExtensionMode);
  asmname 'gdk_input_set_extension_events';
Procedure GdkInputSetSource(devid:guint32; src:GdkInputSource);
  asmname 'gdk_input_set_source';
Function GdkInputSetMode(devid:guint32; mode:GdkInputMode) : gboolean;
  asmname 'gdk_input_set_mode';
Procedure GdkInputSetAxes(devid:guint32; axes:PGdkAxisUse);
  asmname 'gdk_input_set_axes';
Procedure GdkInputSetKey(devid:guint32; index,keyval:guint; modi:GdkModifierType);
  asmname 'gdk_input_set_key';
Procedure GdkInputWindowGetPointer(win:PGdkWindow; devid:guint32; 
                            Var x,y:gdouble;
                            Var prssurer,xTilt,yTilt:gdouble; 
                            Var mask:GdkModifierType);
  asmname 'gdk_input_window_get_pointer';
Function GdkInputMotionEvents(win:PGdkWindow; devid,strt,stp:guint32; 
                            Var neventsReturn : gint) : GdkTimeCoord;
  asmname 'gdk_input_motion_events';

 { International Input Method Support Functions }
Function GdkImReady : gboolean;
  asmname 'gdk_im_ready';
Procedure GdkImBegin(ic:PGdkIC; win:PGdkWindow);
  asmname 'gdk_im_begin';
Procedure GdkImEnd;
  asmname 'gdk_im_end';
Function GdkImDecideBestStyle(supportedStyle : GdkIMStyle) : GdkIMStyle;
  asmname 'gdk_im_decide_style';
Function GdkImSetBestStyle(bestStyle : GdkIMStyle) : GdkIMStyle;
  asmname 'gdk_im_set_best_style';
Function GdkIcNew(attr:PGdkICAttr; mask:GdkICAttributesType) : PGdkIC;
  asmname 'gdk_ic_new';
Procedure GdkIcDestroy(ic:PGdkIC);
  asmname 'gdk_ic_destroy';
Function GdkIcGetStyle(ic:PGdkIC) : GdkIMStyle;
  asmname 'gdk_ic_get_style';
Function GdkIcGetEvents(ic:PGdkIC) : GdkEventMask;
  asmname 'gdk_ic_get_events';
Function GdkIcAttrType : PGdkICAttr;
  asmname 'gdk_ic_attr_new';
Procedure GdkIcAttrDestroy(attr:GdkICAttr);
  asmname 'gdk_ic_attr_destroy';
Function GdkIcSetAttr(ic:PGdkIC; attr:GdkICAttr; mask:GdkICAttributesType)
                            : GdkICAttributesType;
  asmname 'gdk_ic_set_attr';
Function GdkIcGetAttr(ic:PGdkIC; attr:PGdkICAttr; mask:GdkICAttributesType)
                            : GdkICAttributesType;
  asmname 'gdk_ic_get_attr';

 { Conversion functions between wide char and multibyte strings. }

(* @@ These two functions may not do what you expect because 
we do not have a PGChar for GdkWChar ?? *)
Function GdkWcstombs(src:PGChar) : PGChar;
  asmname 'gdk_wcstombs';
Function GdkmbstoWcs(dest, src:PGChar; destMax:gint) : gint;
  asmname 'gdk_mbstowcs';

 { Color Context }
Function GdkColorContextNew(vis:PGdkVisual; colmap:PGdkColormap)
                            : PGdkColorContext;
  asmname 'gdk_color_context_new';
Function GdkColorContextNewMono(vis:PGdkVisual; colmap:PGdkColormap)
                            : PGdkColorContext;
  asmname 'gdk_color_context_new_mono';
Procedure GdkColorContextFree(cc:PGdkColorContext);
  asmname 'gdk_color_context_free';
Function GdkColorContextGetPixel(cc:PGdkColorContext; red,green,blue : gushort;
                            failed:pgint) : gulong;
  asmname 'gdk_color_context_get_pixel';
Procedure GdkColorContextGetPixels(cc:PGdkColorContext; red,green,blue : pgushort;
                            ncolors:gint; nallocated:pgint);
  asmname 'gdk_color_context_get_pixels';
Procedure GdkColorContextGetPixelsIncremental(cc:PGdkColorContext;
                            red,green,blue:pgushort; ncolors:gint; used:pgint;
                            color:pgulong; nallocated:pgint);
  asmname 'gdk_color_context_get_pixels_incremental';
Function GdkColorContextQueryColor(cc:PGdkColorContext; 
                            color:pgulong) : gint;
  asmname 'gdk_color_context_query_color';
Function GdkColorContextQueryColors(cc:PGdkColorContext; 
                            color:pgulong; num:gint) : gint;
  asmname 'gdk_color_context_query_colors';
Function GdkColorContextAddPalette(cc:PGdkColorContext; palette:PGdkcolor;
                            num:gint) : gint;
  asmname 'gdk_color_context_add_palette';
Procedure GdkColorContextInitDither(cc:PGdkColorcontext);
  asmname 'gdk_color_context_init_dither';
Procedure GdkColorContextFreeDither(cc:PGdkColorcontext);
  asmname 'gdk_color_context_free_dither';
Function GdkColorContextGetPixelFromPalette(cc:PGdkColorcontext; 
                            r,g,b:pgushort; failed:pgint) : gulong;
  asmname 'gdk_color_context_get_pixel_from_palette';
Function GdkColorContextGetIndexFromPalette(cc:PGdkColorcontext; 
                            r,g,b:pgushort; failed:pgint) : guchar;
  asmname 'gdk_color_context_get_index_from_palette';

 { Regions }
Function GdkRegionNew : PGdkRegion;
  asmname 'gdk_region_new';
Procedure GdkRegionDestroy(r:PGdkRegion);
  asmname 'gdk_region_destroy';
Procedure GdkRegionGetClipbox(r:PGdkRegion; rect:PGdkRectangle);
  asmname 'gdk_region_get_clipbox';
Function GdkRegionEmpty(r:PGdkRegion) : gboolean;
  asmname 'gdk_region_empty';
Function GdkRegionEqual(r1, r2 : PGdkRegion) : gboolean;
  asmname 'gdk_region_equal';
Function GdkRegionPointIn(r:PgdkRegion; x,y : integer) : gboolean;
  asmname 'gdk_region_point_in';
Function GdkRegionRectIn(r:PGdkRegion; rect:PGdkRectangle) : GdkOverlapType;
  asmname 'gdk_region_rect_in';
Function GdkRegionPolygon(p:PGdkPoint; nPoints:gint;fill:GdkFillRule):PGdkRegion;
  asmname 'gdk_region_polygon';
Procedure GdkRegionOffset(r:PGdkRegion; dx,dy : gint);
  asmname 'gdk_region_offset';
Procedure GdkRegionShrink(r:PGdkRegion; dx,dy : gint);
  asmname 'gdk_region_shrink';
Function GdkREgionUnionWithRect(r:PGdkRegion;rect:PGdkRectangle):PGdkRegion;
  asmname 'gdk_region_union_with_rect';
Function GdkRegionsIntersect(s1, s2:PGdkRegion) : PGdkRegion;
  asmname 'gdk_regions_intersect';
Function GdkRegionsUnion(s1, s2 : PGdkRegion) : PGdkRegion;
  asmname 'gdk_regions_union';
Function GdkRegionsSubtract(s1, s2 : PGdkRegion) : PGdkRegion;
  asmname 'gdk_regions_subtract';
Function GdkRegionsXor(s1, s2 : PGdkRegion) : PGdkRegion;
  asmname 'gdk_regions_xor';

 { Miscellaneous }
Procedure GdkEventSentClientmessageToall(evt:PGdkEvent);
  asmname 'gdk_event_send_clientmessage_toall';
Function GdkEventSendClientMessage(evt:PGdkEvent; xid:guint32) : gboolean;
  asmname 'gdk_event_send_client_message';

 { Key values }
Function GdkKeyvalName(k:guint) : pgchar;
  asmname 'gdk_keyval_name';
Function GdkKeyvalFromName(kname : PGChar) : guint;
  asmname 'gdk_keyval_from_name';
Function GdkKeyvalToUpper(k : guint) : guint;
  asmname 'gdk_keyval_to_upper';
Function GdkKeyvalToLower(k : guint) : guint;
  asmname 'gdk_keyval_to_lower';
Function GdkKeyvalIsUpper(k : guint) : gboolean;
  asmname 'gdk_keyval_is_upper';
Function GdkKeyvalIsLower(k : guint) : gboolean;
  asmname 'gdk_keyval_is_lower';

 { Threading }
var
  GdkThreadsMutex : PGMutex; asmname 'gdk_threads_mutex';

Procedure GdkThreadsEnter;
  asmname 'gdk_threads_enter';
Procedure GdkThreadsLeave;
  asmname 'gdk_threads_leave';

{ -------------- GDKRGB ----------------}
Procedure GdkRgbInit; 
asmname 'gdk_rgb_init';

Function GdkRgbXpixelFromRgb(rgb : guint32) : gulong;
asmname 'gdk_rgb_xpixel_from_rgb';

Procedure GdkRgbGcSetForeground(gc : PGdkGc; rgb : guint32);
asmname 'gdk_rgb_gc_set_foreground';

Procedure GdkRgbGcSetBackground(gc : PGdkGc; rgb : guint32);
asmname 'gdk_rgb_gc_set_background';

Procedure GdkDrawRgbImage(drawable : PGdkDrawable; gc:PGdkGc; 
                          x, y, width, height : gint; dith : GdkRgbDither;
                          buf : pguchar; rowstride : gint);
asmname 'gdk_draw_rgb_image';

Procedure GdkDrawRgbImageDithalign(drawable : PGdkDrawable; gc:PGdkGc; 
                          x, y, width, height : gint; dith : GdkRgbDither;
                          buf: pguchar; rowstride: gint; xdith, ydith: gint);
asmname 'gdk_draw_rgb_image_dithalign';

Procedure GdkDrawRgb32Image(drawable : PGdkDrawable; gc:PGdkGc; 
                          x, y, width, height : gint; dith : GdkRgbDither;
                          buf: pguchar; rowstride: gint);
asmname 'gdk_draw_rgb_32_image';

Procedure GdkDrawGrayImage(drawable : PGdkDrawable; gc:PGdkGc; 
                          x, y, width, height : gint; dith : GdkRgbDither;
                          buf: pguchar; rowstride: gint);
asmname 'gdk_draw_gray_image';

Function GdkRgbCmapNew (colors : pguint32; n_colors : gint) : PGdkRgbCmap;
asmname 'gdk_rgb_cmap_new';

Procedure GdkRgbCmapFree (cmap : PGdkRgbCmap);
asmname 'gdk_rgb_cmap_free';

Procedure GdkDrawIndexedImage(drawable : PGdkDrawable; gc:PGdkGc; 
                          x, y, width, height : gint; dith : GdkRgbDither;
                          buf: pguchar; rowstride: gint; cmap : PGdkRgbCmap);
asmname 'gdk_draw_indexed_image';

  { Below are some functions which are primarily useful for debugging
   and experimentation. }
Function GdkRgbDitherable : gboolean;
asmname 'gdk_rgb_ditherable';

Procedure GdkRgbSetVerbose (v : gboolean);
asmname 'gdk_rgb_set_verbose';

  { experimental colormap stuff }
Procedure GdkRgbSetInstall(i : gboolean);
asmname 'gdk_rgb_set_install';

Procedure GdkRgbSetMincolors (min : gint);
asmname 'gdk_rgb_set_min_colors';

Function GdkRgbGetCmap : PGdkColormap;
asmname 'gdk_rgb_get_cmap';

Function GdkRgbGetVisual : PGdkVisual;
asmname 'gdk_rgb_get_visual';

Implementation

Procedure CGdkInit(argc : Pgint; argv : pointer);
  asmname 'gdk_init';
Function CGdkInitCheck(argc : Pgint; argv : pointer) : gboolean;
  asmname 'gdk_init_check';


Procedure GdkInit;
Begin
  CGdkInit(@CParamCount, @CParameters)
End;

Function GdkInitCheck : gboolean;
Begin
  GdkInitCheck := CGdkInitCheck(@CParamCount, @CParameters)
End;



End.

