{ From glibconfig.h and glib.h }
unit Glib;

interface

const
  { GTraverseFlags }
  G_TRAVERSE_LEAVES =1;
  G_TRAVERSE_NON_LEAVES =2;
  G_TRAVERSE_ALL =3;
  G_TRAVERSE_MASK =3;
  
  { GTraverseType }
  G_IN_ORDER    = 0;
  G_PRE_ORDER   = 1;
  G_POST_ORDER  = 2;
  G_LEVEL_ORDER = 3;
  
  { GHookFlagMask }
  G_HOOK_FLAG_ACTIVE    = 1;
  G_HOOK_FLAG_IN_CALL   = 2;
  G_HOOK_FLAG_USER_SHIFT= 4;
  G_HOOK_FLAG_MASK      = 15;

  G_ALLOCATOR_LIST      = 1;
  G_ALLOCATOR_SLIST     =2;
  G_ALLOCATOR_NODE      =3;

  G_ALLOC_ONLY    = 1;
  G_ALLOC_AND_FREE= 2;

  { Error types }
  G_ERR_UNKNOWN = 0;
  G_ERR_UNEXP_EOF = 1;
  G_ERR_UNEXP_EOF_IN_STRING =2;
  G_ERR_UNEXP_EOF_IN_COMMENT =3;
  G_ERR_NON_DIGIT_IN_CONST =4;
  G_ERR_DIGIT_RADIX = 5;
  G_ERR_FLOAT_RADIX = 6;
  G_ERR_FLOAT_MALFORMED =7;

  { Token types }
  G_TOKEN_EOF                   =   0;
  G_TOKEN_LEFT_PAREN            = '(';
  G_TOKEN_RIGHT_PAREN           = ')';
  G_TOKEN_LEFT_CURLY            = '{';
  G_TOKEN_RIGHT_CURLY           = '}';
  G_TOKEN_LEFT_BRACE            = '[';
  G_TOKEN_RIGHT_BRACE           = ']';
  G_TOKEN_EQUAL_SIGN            = '=';
  G_TOKEN_COMMA                 = ',';
  G_TOKEN_NONE                  = 256;
  G_TOKEN_ERROR = 1;
  G_TOKEN_CHAR =2 ;
  G_TOKEN_BINARY=3;
  G_TOKEN_OCTAL=4;
  G_TOKEN_INT=5;
  G_TOKEN_HEX=6;
  G_TOKEN_FLOAT=7;
  G_TOKEN_STRING =8;
  G_TOKEN_SYMBOL =9;
  G_TOKEN_IDENTIFIER =10;
  G_TOKEN_IDENTIFIER_NULL =11;
  G_TOKEN_COMMENT_SINGLE =12;
  G_TOKEN_COMMENT_MULTI =13;
  G_TOKEN_LAST =14;

  { enum used to specify order of appearance in parsed date strings }
  G_DATE_DAY   = 0;
  G_DATE_MONTH = 1;
  G_DATE_YEAR  = 2;

  { actual week and month values }
  G_DATE_BAD_WEEKDAY  = 0;
  G_DATE_MONDAY       = 1;
  G_DATE_TUESDAY      = 2;
  G_DATE_WEDNESDAY    = 3;
  G_DATE_THURSDAY     = 4;
  G_DATE_FRIDAY       = 5;
  G_DATE_SATURDAY     = 6;
  G_DATE_SUNDAY       = 7;


  { GDateMonth }
  G_DATE_BAD_MONTH = 0;
  G_DATE_JANUARY   = 1;
  G_DATE_FEBRUARY  = 2;
  G_DATE_MARCH     = 3;
  G_DATE_APRIL     = 4;
  G_DATE_MAY       = 5;
  G_DATE_JUNE      = 6;
  G_DATE_JULY      = 7;
  G_DATE_AUGUST    = 8;
  G_DATE_SEPTEMBER = 9;
  G_DATE_OCTOBER   = 10;
  G_DATE_NOVEMBER  = 11;
  G_DATE_DECEMBER  = 12;
  
  G_DATE_BAD_JULIAN = 0;
  G_DATE_BAD_DAY  =0;
  G_DATE_BAD_YEAR = 0;

  { GIOError }
  G_IO_ERROR_NONE=0;
  G_IO_ERROR_AGAIN=1;
  G_IO_ERROR_INVAL=2;
  G_IO_ERROR_UNKNOWN=3;

  { GSeekType }
  G_SEEK_CUR = 0;
  G_SEEK_SET =1;
  G_SEEK_END =2;

  {* Standard priorities *}

  G_PRIORITY_HIGH           = -100;
  G_PRIORITY_DEFAULT        =  0;
  G_PRIORITY_HIGH_IDLE      =  100;
  G_PRIORITY_DEFAULT_IDLE   =  200;
  G_PRIORITY_LOW            =  300;

  { !! WARNING
    You can't always be sure that the original gboolean value
    is 1 (G_TRUE), it might also be 2 and mean True just the same.
    So, use Variable <> G_FALSE instead of Variable = G_TRUE.
    But hey, this is not very nice. }

  const
    G_TRUE = 1;
    G_FALSE = 0;
    GTK_TRUE = G_TRUE;
    GTK_FALSE = G_FALSE;

Type
  PGMutex = Pointer;

  PGUint30 = ^GUint30;
  GUint30 = Word(30);

  PGUint3 = ^GUint3;
  GUint3 = Word(3);
  PGUint2 = ^GUint2;
  GUint2 = Word(2);
  PGUint1 = ^GUint1;
  GUint1 = Word(1);

  PGInt3 = ^GInt3;
  GInt3 = Integer(3);

  pgint8 = ^gint8;
  gint8 = Integer(8);
  pguint8 = ^guint8;
  guint8 = Word(8);
  
  pgint16 = ^gint16;
  gint16 = Integer(16);
  pguint16 = ^guint16;
  guint16 = Word(16);

  pgint32 = ^gint32;
  gint32 = Integer(32);
  ppguint32 = ^pguint32;
  pguint32 = ^guint32;
  guint32 = Word(32);

  PPPGChar = ^PPGChar;
  PPGChar = ^PGChar;
  PGChar = PChar;
  GChar = Char;

  ppguchar = ^pguchar;
  pguchar = ^guchar;
  guchar = Byte;
  gshort = ShortInt;
  pgushort = ^gushort;
  gushort = ShortCard;
  PGLong = ^GLong;
  glong = MedInt;
  pgulong=^gulong;
  gulong = MedCard;

  ppgint = ^pgint;
  pgint = ^gint;
  gint = Integer;

  pguint = ^guint;
  guint = Cardinal;
        
  gssize = gint32;
  gsize = guint32;
  GQuark = guint32;
  GTime = gint32;
  PPGdata = ^PGData;
  PGData = ^GData;
  GData = pointer;
  PGBoolean = ^GBoolean;
  GBoolean  = GInt;

  pgfloat = ^gfloat;
  gfloat = Single;
  pgdouble = ^gdouble;
  gdouble = Double;
  gldouble = Extended;
        
  pgpointer = ^gpointer;
  gpointer = Pointer;
  gconstpointer = Pointer;
  GUint4 = cardinal(4);
  GUint6 = cardinal(6);

  PGHook = ^GHook;
  PGHookList = ^GHookList;
  PGNode = ^GNode;
  PGIOChannel = ^GIOChannel;
  PGPollFD = ^GPollFD;
  GIOCondition = Integer;
  PGSCanner = Pointer;
  PGIOFuncs = ^GIOFuncs;
  PGHashTable = Pointer;
  PGCache = Pointer;
  PGTree = Pointer;
  PGAllocator = Pointer;
  PGMemChunk = Pointer;
  PGStringChunk = Pointer;
  PGMainLoop = Pointer;
  PGDate = ^GDate;
  PGList = ^GList;
  PGSList = ^GSList;
  PPGSList = ^PGSList;
  PGSourceFuncs = ^GSourceFuncs;
  PGTimer = Pointer;
  PGRelation = Pointer;  
  PGTuples = Pointer;
  PGTimeVal = ^GTimeVal;

  GErrorType = Integer;
  GTokenType = Integer;
  GIOError = Integer;
  GSeekType = Integer;
  GTraverseType = Integer;

  (* !! I just added "Type", because there are
  Functions with the same name *)

  GDateYearType = guint16;
  GDateDayType = guint8;   { day of the month }
  GDateDMYType = Integer;
  GDateWeekDayType = Integer;
  GDateMonthType = Integer;



  GIOChannel  = Record
    ChannelFlags : guint;
    RefCount : guint;
    Funcs : PGIOFuncs;
  End;

  GTimeVal  = Record
    TvSec, TvUsec : glong;
  End;

  GPollFD  = Record
    fd : gint;
    events, revents : gushort;
  End;
  
  GCacheNewFunc = ^Function(key : gpointer) : gpointer;
  GCacheDupFunc = ^Function(key : gpointer) : gpointer;
  GCacheDestroyFunc = ^Procedure(key : gpointer);
  GCompareFunc = ^Function(a, b : gconstpointer) : gint;
  GCompletionFunc = ^Function(a : gpointer) : gchar;
  GDestroyNotify = ^Procedure (data : gpointer);
  GDataForeachFunc = ^Procedure (keyid : GQuark; data, userdata : GPointer);
  GFunc = ^Procedure (data, UserData : gpointer);
  GHashFunc = ^Function (key : gconstpointer) : guint;
  GFreeFunc = ^Procedure (data : gpointer);
  GHFunc =  ^Procedure (k, v, udata : gpointer);
  GHRFunc = ^Function (key, v, u : gpointer ) : gboolean;
  GHookCompareFunc = ^Function (nh, sib : PGHook): gint;
  
  { !! Twice the same name ->  different with "F" :-(( }
  GHookFindFuncF = ^Function (h : PGHook; d : gpointer) : gboolean;
  GHookMarshaller =^Procedure(h : PGHook; d : gpointer);
  GHookCheckMarshaller =^Function (h : PGHook; d : gpointer) : gboolean;
  GHookFunc = ^Procedure (data : gpointer);
  GHookCheckFunc = ^Function (data : gpointer) : gboolean;
  GHookFreeFunc = ^Procedure (hl : PGHookList; h : PGHook);
  GNodeTraverseFunc = ^Function(n : PGNode; d : gpointer) : gboolean;
  GNodeForeachFunc = ^Procedure(n : PGNode; d : gpointer);
  GSearchFunc = ^Function (k, d : gpointer) : gint;
  GScannerMsgFunc =^Procedure (s : PGScanner; msg : PGChar; err : gint);
  GTraverseFunc =^Function (k, v, d : gpointer) : gint;
  GVoidFunc = ^Procedure;
  GPrintFunc =^Procedure ( x : PGChar);
  GIOFunc    =^Function(s:PGIOChannel;cond:GIOCondition;data:gpointer):gboolean;
  GSourceFunc=^Function(data : gpointer) : gboolean;
  GPollFunc  =^Function (ufds:PGPollFD; nfsd:guint; timeout:gint) : gint;

  GSourceFuncs  = Record
    prepare : ^Function(source:gpointer; currtime:PGTimeVal; timeout:pgint; userdata:gpointer) : gboolean;
    check   : ^Function(source:gpointer; currtime:PGTimeVal; userdata:gpointer) : gboolean;
    dispatch: ^Function(source:gpointer; dispatchtime:PGTimeVal; userdata:gpointer) : gboolean;
    destroy : GDestroyNotify;
  End;




  {* Note: directly manipulating structs is generally a bad idea, but
   * in this case it's an *incredibly* bad idea, because all or part
   * of this struct can be invalid at any given time. Use the functions,
   * or you will get hosed, I promise.
   *}

  GDate  =  Packed Record
    JulianDays : GUint32;  {* julian days representation - we use a
                               *  bitfield hoping that 64 bit platforms
                               *  will pack this whole struct in one big
                               *  int }
    julian : GUint1;    { julian is valid }
    dmy    : GUint1;    { dmy is valid }
    { DMY representation }
    day    : GUint6;  
    month  : GUint4; 
    year   : GUint16; 
  End;
  
  GList = Record
    data : gpointer;
    next, prev : PGList;
  End;
  
  GSList = Record
    data : gpointer;
    next : PGSList;
  End;

  GString = Record
    str : PGChar;
    len : gint;
  End;
    
  GArray = Record 
    data : PGChar;
    len : guint;
  End;

  GByteArray = Record 
    data : pguint8;
    len : guint;
  End;

  GPtrArray = Record
    pdata : gpointer;
    len : guint;
  End;

  GTuples = Record
    len : guint;
  End;
  
  GDebugKey = Record
    key : PGChar;
    val : guint;
  End;

  GNode = Record
    data : gpointer;
    next, prev, parent, children : PGNode;
  End;


  GHook = Record
    data : gpointer;
    next, prev : PGHook;
    refCount, hookId, flags : guint;
    func : gpointer;
    destroy : GDestroyNotify;
  End;
    
  GHookList = Record 
    seqId, hookSize : guint;
    isSetup : Integer(1);
    hooks : PGHook;
    hookMemchunk : PGMemChunk;
    hookFree, hookDestroy : GHookFreeFunc;
  End;

  GIOFuncs  = Record
    ioRead : ^Function(c:PGIOChannel; buf:PGChar;
                        count:guint; bytesRead:guint) : GIOError;
    ioWrite: ^Function(c:PGIOChannel; buf:PGChar;
                        count:guint; bytesWritten:guint) : GIOError;
    ioSeek : ^Function(c:PGIOChannel;offset:gint;typ:GSeekType):GIOError;
    ioClose: ^Procedure(c : PGIOChannel);
    ioAddWatch:^Function(c:PGIOChannel; priority:gint; cond:GIOCondition;
                        func:GIOFunc; userdata:gpointer; 
                        notify:GDestroyNotify) : guint;
    ioFree : ^Procedure (c : GIOChannel);
  End;
  
 

  { Doubly linked lists }

  Procedure GListPushAllocator(allocator : PGAllocator);
    asmname 'g_list_push_allocator';
  Procedure GListPopAllocator;
    asmname 'g_list_pop_allocator';
  Function GListAlloc : PGList;
    asmname 'g_list_alloc';
  Procedure GListFree(list : PGList);
    asmname 'g_list_free';
  Procedure GListFree1(list : PGList);
    asmname 'g_list_free_1';
  Function GListAppend(list : PGList; data : gpointer) : PGList;
    asmname 'g_list_append';
  Function GListPrepend(list : PGList; data : gpointer) : PGList;
    asmname 'g_list_prepend';
  Function GListInsert(list : PGList; data : gpointer; pos : gint) : PGList;
    asmname 'g_list_insert';
  Function GListInsertSorted(list:PGList;data:gpointer;func:GCompareFunc):PGList;
    asmname 'g_list_insert_sorted';
  Function GListConcat(list1, list2 : PGList):PGList;
    asmname 'g_list_concat';
  Function GListRemove(list : PGList; data : gpointer):PGList;
    asmname 'g_list_remove';
  Function GListRemoveLink(list, llist : PGList) : PGList;
    asmname 'g_list_remove_link';
  Function GListReverse(list : PGList) : PGList;
    asmname 'g_list_reverse';
  Function GListCopy(list : PGList) : PGList;
    asmname 'g_list_copy';
  Function GListNth(list : PGList; n : guint) : PGList;
    asmname 'g_list_nth';
  Function GListFind(list : PGList; data  : gpointer) : PGList;
    asmname 'g_list_find';
  Function GListFindCustom(list:PGList;data:gpointer;func:GCompareFunc) : PGList;
    asmname 'g_list_find_custom';
  Function GListFindPosition(list, llist : PGList) : gint;
    asmname 'g_list_position';
  Function GListIndex(list : PGList; data : gpointer) : gint;
    asmname 'g_list_index';
  Function GListLast(list : PGList) : PGList;
    asmname 'g_list_last';
  Function GListFirst(list : PGList) : PGList;
    asmname 'g_list_first';
  Function GListLength(list : PGList) : guint;
    asmname 'g_list_length';
  Procedure GListForEach(list : PGList; func : GFunc; userData:gpointer);
    asmname 'g_list_foreach';
  Function GListSort(list : PGList; func : GCompareFunc) : PGList;
    asmname 'g_list_sort';
  Function GListNthData(list : PGList; n : guint) : gpointer;
    asmname 'g_list_nth_data';
  Function GListPrevious(list : PGList) : PGList;
    asmname 'g_list_previous';
  Function GListNext(list : PGList) : PGList;
    asmname 'g_list_next';

  { Singly linked lists }

  Procedure GSListPushAllocator(a : PGAllocator);
    asmname 'g_slist_push_allocator';
  Procedure GSListPopAllocator;
    asmname 'g_slist_pop_allocator';
  Function GSListAlloc : PGSList;
    asmname 'g_slist_alloc';
  Procedure GSListFree(list : PGSList);
    asmname 'g_slist_free';
  Procedure GSListFree(list : PGSList);
    asmname 'g_slist_free_1';
  Function GSListAppend(list : PGSList; data : gpointer) : PGSList;
    asmname 'g_slist_append';
  Function GSListPrepend(list : PGSList; data : gpointer) : PGSList;
    asmname 'g_slist_prepend';
  Function GSListInsert(list : PGSList; data : gpointer; pos : gint) : PGSList;
    asmname 'g_slist_insert';
  Function GSListInsertSorted(list:PGSList;data:gpointer;func:GCompareFunc) : PGSList;
    asmname 'g_slist_insert_sorted';
  Function GSListConcat(list1, list2 : PGSList) : PGSList;
    asmname 'g_slist_concat';
  Function GSListRemove(list : PGSList; data : gpointer) : PGSList;
    asmname 'g_slist_remove';
  Function GSListRemoveLink(list, link : PGSList) : PGSList;
    asmname 'g_slist_remove_link';
  Function GSListReverse(list : PGSList) : PGSList;
    asmname 'g_slist_reverse';
  Function GSListCopy(list : PGSList) : PGSList;
    asmname 'g_slist_Copy';
  Function GSListNth(list : PGSList; n : guint) : PGSList;
    asmname 'g_slist_nth';
  Function GSListFind(list : PGSList; data : gpointer) : PGSList;
    asmname 'g_slist_find';
  Function GSListFindCustom(list:PGSList;data:gpointer; func:GCompareFunc) : PGSList;
    asmname 'g_slist_find_custom';

  Function GSListPosition(list, llink:PGSList) : gint;
    asmname 'g_slist_position';
  Function GSListIndex(list : PGSList; data : gpointer) : gint;
    asmname 'g_slist_index';
  Function GSListLast(list : PGSList) : PGSList;
    asmname 'g_slist_last';
  Function GSListLength(list : PGSList) : guint;
    asmname 'g_slist_length';
  Procedure GSListForeach(list : PGSList;func:GFunc;data:gpointer);
    asmname 'g_slist_foreach';
  Function GSListSort(list : PGSList;func:GCompareFunc) : PGSList;
    asmname 'g_slist_sort';
  Function GSListNthData(list : PGSList; n : guint) : gpointer;
    asmname 'g_slist_nth_data';
  Function GSListNext(list : PGSList) : PGSList;
    asmname 'g_slist_next';
  
  { Hash tables }

  Function GHashTableNew(f:GHashFunc; comFunc:GCompareFunc): PGHashTable;
    asmname 'g_hash_table_new';
  Procedure GHashTableDestroy(ht : PGHashTable);
    asmname 'g_hash_table_destroy';
  Procedure GHashTableInsert(ht : PGHashTable; k, v:gpointer);
    asmname 'g_hash_table_insert';
  Procedure GHashTableRemove(ht : PGHashTable; k :gconstpointer);
    asmname 'g_hash_table_remove';
  Function GHashTableLookup(ht : PGHashTable; k :gconstpointer) : gpointer;
    asmname 'g_hash_table_lookup';
  Function GHashTableLookupExtended(ht : PGHashTable; lk :gconstpointer;
                                    ok, v : gpointer) : gboolean;
    asmname 'g_hash_table_lookup_extended';
  Procedure GHashTableFreeze(ht : PGHashTable);
    asmname 'g_hash_table_freeze';
  Procedure GHashTableThaw(ht : PGHashTable);
    asmname 'g_hash_table_thaw';
  Procedure GHashTableForeach(ht : PGHashTable; func : GHFunc; udata : gpointer);
    asmname 'g_hash_table_foreach';
  Function GHashTableForeachRemove(ht : PGHashTable; func : GHRFunc;
                                   udata : gpointer) : guint;
    asmname 'g_hash_table_foreach_remove';
  Function GHashTableSize(ht : PGHashTable) : guint;
    asmname 'g_hash_table_size';

  { Caches }
  Function GCacheNew(vnf : GCacheNewFunc; vdf : GCacheDestroyFunc;
                     kdf : GCacheDupFunc; kdesf : GCacheDestroyFunc;
                     hkf, hvf : GHashFunc; kcf : GCompareFunc) : PGCache;
    asmname 'g_cache_new';
  Procedure GCacheDestroy(cache:PGCache);
    asmname 'g_cache_destroy';
  Function GCacheInsert(cache:PGCache; key: gpointer) : gpointer;
    asmname 'g_cache_insert';
  Procedure GCacheRemove(cache:PGCache; value: gpointer);
    asmname 'g_cache_remove';
  Procedure GCacheKeyForeach(cache:PGCache; func : GHFunc; value: gpointer);
    asmname 'g_cache_key_foreach';
  Procedure GCacheValueForeach(cache:PGCache; func : GHFunc; value: gpointer);
    asmname 'g_cache_value_foreach';

  { Balanced binary trees }

  Function GTreeNew (kcf : GCompareFunc) : PGTree;
    asmname 'g_tree_new';
  Procedure GTreeDestroy (tree: PGTree);
    asmname 'g_tree_destroy';
  Procedure GTreeInsert (tree: PGTree; key, value : GPointer);
    asmname 'g_tree_insert';
  Procedure GTreeRemove (tree: PGTree; key : GPointer);
    asmname 'g_tree_remove';
  Function GTreeLookup (tree: PGTree; key : GPointer) : gpointer;
    asmname 'g_tree_lookup';
  Procedure GTreeTraverse (tree: PGTree; tv : GTraverseFunc;
                           tt : GTraverseType; data : GPointer);
    asmname 'g_tree_traverse';
  Function GTreeSearch (tree: PGTree; sf : GSearchFunc;
                        data : GPointer) : gpointer;
    asmname 'g_tree_search';
  Function GTreeHeight (tree: PGTree) : gint;
    asmname 'g_tree_height';
  Function GTreeNnodes (tree: PGTree) : gint;
    asmname 'g_tree_nnodes';


  { N-way tree implementation }

  Function GNodeIsRoot(node : PGNode) : gboolean;
    asmname 'G_NODE_IS_ROOT';
  Function GNodeIsLeaf(node : PGNode) : gboolean;
    asmname 'G_NODE_IS_LEAF';
  Procedure GNodePushAllocator(allocator : PGAllocator);
    asmname 'g_node_push_allocator';
  Procedure GNodePopAllocator;
    asmname 'g_node_pop_allocator';
  Function GNodeNew(data : gpointer) : PGNode;
    asmname 'g_node_new';
  Procedure GNodeDestroy(root : PGNode);
    asmname 'g_node_destroy';
  Procedure GNodeUnlink(node : PGNode);
    asmname 'g_node_unlink';
  Function GNodeInsert(parent : PGNode; pos : gint; node : PGNode) : PGNode;
    asmname 'g_node_insert';
  Function GNodeInsertBefore(parent, sibl, node : PGNode) : PGNode;
    asmname 'g_node_insert_before';
  Function GNodePrepend(parent, node : PGNode) : PGNode;
    asmname 'g_node_prepend';
  Function GNodeNNodes(root : PGNode; flags : Integer) : guint;
    asmname 'g_node_n_nodes';
  Function GNodeGetRoot(node : PGNode) : PGNode;
    asmname 'g_node_get_root';
  Function GNodeIsAncestor(node, descendant : PGNode) : gboolean;
    asmname 'g_node_is_ancestor';
  Function GNodeDepth(node : PGNode) : guint;
    asmname 'g_node_depth';
  Function GNodeFind(root : PGNode; order, flags : Integer; data : gpointer) : PGNode;
    asmname 'g_node_find';

  { convenience macros }
  Function GNodeAppend(parent, node : PGNode) : PGNode;
    asmname 'g_node_append';
  Function GNodeInsertData(parent : PGNode; pos : gint; data : gpointer) : PGNode;
    asmname 'g_node_insert_data';
  Function GNodeInsertDataBefore(parent, sibl : PGNode; data : gpointer) : PGNode;
    asmname 'g_node_insert_data_before';
  Function GNodePrependData(parent : PGNode; data : gpointer) : PGNode;
    asmname 'g_node_prepend_data';
  Function GNodeAppendData(parent : PGNode; data : gpointer) : PGNode;
    asmname 'g_node_append_data';

{  
  traversal function, assumes that `node' is root
  (only traverses `node' and its subtree).
  this function is just a high level interface to
  low level traversal functions, optimized for speed.
}
  Procedure GNodeTraverse(root : PGNode; order, flags : Integer;
                          maxDepth : gint; func : GTraverseFunc;
                          data : gpointer);
    asmname 'g_node_traverse';

{ return the maximum tree height starting with `node', this is an expensive
  operation, since we need to visit all nodes. this could be shortened by
  adding `guint height' to struct _GNode, but then again, this is not very
  often needed, and would make g_node_insert() more time consuming.
}
  Function GNodeMaxHeight(root : PGNode) : guint;
    asmname 'g_node_max_height';
  Procedure GNodeChildrenForeach (node : PGNode; flags : Integer;
                                  f : GNodeForeachFunc; data : GPointer);
    asmname 'g_node_children_foreach';
  Procedure GNodeReverseChildren(node : PGNode);
    asmname 'g_node_reverse_children';
  Function GNodeNChildren(node : PGNode) : guint;
    asmname 'g_node_n_children';
  Function GNodeNthChild(node : PGNode; n : guint) : PGNode;
    asmname 'g_node_nth_child';
  Function GNodeLastChild(node : PGNode) : PGNode;
    asmname 'g_node_last_child';
  Function GNodeFindChild(node : PGNode; flag : Integer; data : gpointer) : PGNode;
    asmname 'g_node_find_child';
  Function GNodeChildPosition(node, child : PGNode) : gint;
    asmname 'g_node_child_position';
  Function GNodeChildIndex(node:PGNode; data : gpointer) : gint;
    asmname 'g_node_child_index';
  Function GNodeFirstSibling(node : PGNode) : PGNode;
    asmname 'g_node_first_sibling';
  Function GNodeLastSibling(node : PGNode) : PGNode;
    asmname 'g_node_last_sibling';

  Function GNodePrevSibling(node : PGNode) : PGNode;
    asmname 'g_node_prev_sibling';
  Function GNodeNextSibling(node : PGNode) : PGNode;
    asmname 'g_node_next_sibling';
  Function GNodeFirstChild(node : PGNode) : PGNode;
    asmname 'g_node_first_child';


  { Callback maintenance functions }

  Procedure GHookListInit(hl : PGHookList; hs : guint);
    asmname 'g_hook_list_init';
  Procedure GHookListClear(hookList : PGHookList);
    asmname 'g_hook_list_clear';
  Function GHookAlloc(hookList : PGHookList) : PGHook;
    asmname 'g_hook_alloc';
  Procedure GHookFree(hookList : PGHookList; h : PGHook);
    asmname 'g_hook_free';
  Procedure GHookRef(hookList : PGHookList; h : PGHook);
    asmname 'g_hook_ref';
  Procedure GHookUnref(hookList : PGHookList; h : PGHook);
    asmname 'g_hook_unref';
  Function GHookDestroy(hookList : PGHookList; hid : guint) : gboolean;
    asmname 'g_hook_destroy';
  Procedure GHookDestroyLink(hookList : PGHookList; h : PGHook);
    asmname 'g_hook_destroy_link';
  Procedure GHookPrepend(hookList : PGHookList; h : PGHook);
    asmname 'g_hook_prepend';
  Procedure GHookInsertBefore(hookList : PGHookList; s, h : PGHook);
    asmname 'g_hook_insert_before';
  Procedure GHookInsertSorted(hookList : PGHookList; h : PGHook; f:GHookCompareFunc);
    asmname 'g_hook_insert_sorted';
  Function GHookGet(hookList : PGHookList; id : guint) : PGHook;
    asmname 'g_hook_get';
  Function GHookFind(hookList : PGHookList; needsValid : gboolean; 
                     f: GHookFindFuncF; data : gpointer) : PGHook;
    asmname 'g_hook_find';
  Function GHookFindData(hookList : PGHookList; needsValid : gboolean; 
                         data : gpointer) : PGHook;
    asmname 'g_hook_find_data';
  Function GHookFindFunc(hookList : PGHookList; needsValid : gboolean; 
                         func : gpointer) : PGHook;
    asmname 'g_hook_find_func';
  Function GHookFindFuncData(hookList : PGHookList; needsValid : gboolean; 
                         func, data : gpointer) : PGHook;
    asmname 'g_hook_find_func_data';
    
  { return the first valid hook, and increment its reference count }
  Function GHookFirstValid(hookList : PGHookList; 
                             maybeInCall : gboolean) : PGHook;
    asmname 'g_hook_first_valid';

  { return the next valid hook with incremented reference count, and
    decrement the reference count of the original hook
  }
  Function GHookNextValid(hookList : PGHookList; hook : PGHook;
                          maybeInCall : gboolean) : PGHook;
    asmname 'g_hook_next_valid';

  { GHookCompareFunc implementation to insert hooks sorted by their id }

  Function GHookCompareIds(hookList : PGHookList; sibling : PGHook) : gint;
    asmname 'g_hook_compare_ids';

  { convenience macros }
  Procedure GHookAppend(hookList : PGHookList; hook : PGHook);
    asmname 'g_hook_append';
  
  { invoke all valid hooks with the (*GHookFunc) signature.}
  Procedure GHookListInvoke(hookList : PGHookList; mayRecursive : gboolean);
    asmname 'g_hook_list_invoke';
  
  { invoke all valid hooks with the (*GHookCheckFunc) signature,
    and destroy the hook if FALSE is returned.
  }
  Procedure GHookListInvokeCheck(hookList : PGHookList; mayRecursive : gboolean);
    asmname 'g_hook_list_invoke_check';

  { invoke a marshaller on all valid hooks. }
  Procedure GHookListMarshal(hookList : PGHookList; mayRecursive : gboolean;
                             marshaller : GHookMarshaller; data : gpointer);
    asmname 'g_hook_list_marshal';
  Procedure GHookListMarshalCheck(hookList:PGHookList; mayRecursive:gboolean;
                             marshaller:GHookMarshaller; data : gpointer);
    asmname 'g_hook_list_marshal_check';

  { Fatal error handlers.
    g_on_error_query() will prompt the user to either
    [E]xit, [H]alt, [P]roceed or show [S]tack trace.
    g_on_error_stack_trace() invokes gdb, which attaches to the current
    process and shows a stack trace.
    These function may cause different actions on non-unix platforms.
    The prg_name arg is required by gdb to find the executable, if it is
    passed as NULL, g_on_error_query() will try g_get_prgname().
  }
  Procedure GOnErrorQuery(prgName : PGChar);
    asmname 'g_on_error_query';
  Procedure GOnErrorStackTrace(prgName : PGChar);
    asmname 'g_on_error_stack_trace';

  {  Memory allocation and debugging }
  
  Function GMalloc (size : gulong) : gpointer;
    asmname 'g_malloc';
  Function GMalloc0 (size : gulong) : gpointer;
    asmname 'g_malloc0';
  Function GRealloc (mem : gpointer; size : gulong) : gpointer;
    asmname 'g_realloc';
  Procedure GFree (mem : gpointer);
    asmname 'g_free';
  Procedure GMemProfile;
    asmname 'g_mem_profile';
  Procedure GMemCheck (mem : gpointer);
    asmname 'g_mem_check';
        
  { Generic allocators }
  Function GAllocatorNew(name : PGChar; npre : guint) : PGAllocator;
    asmname 'g_allocator_new';
  Procedure GAllocatorFree(allocator : PGAllocator);
    asmname 'g_allocator_free';

  Function GMemChunkNew (name : PGChar; atomsize : gint; asize: gulong; 
                         typ : gint) : PGMemChunk;
  asmname 'g_mem_chunk_new';

  Procedure GMemChunkDestroy(memchunk : PGMemChunk);
  asmname 'g_mem_chunk_destroy';
  
  Function GMemChunkAlloc (memchunk : PGMemChunk) : gpointer;
  asmname 'g_mem_chunk_alloc';

  Function GMemChunkAlloc0 (memchunk : PGMemChunk) : gpointer;
  asmname 'g_mem_chunk_alloc0';

  Procedure GMemChunkFree (memchunk : PGMemChunk; mem : gpointer);
  asmname 'g_mem_chunk_free';

  Procedure GMemChunkClean (memchunk : PGMemChunk);
  asmname 'g_mem_chunk_clean';

  Procedure GMemChunkReset (memchunk : PGMemChunk);
  asmname 'g_mem_chunk_reset';

  Procedure GMemChunkPrint (memchunk : PGMemChunk);
  asmname 'g_mem_chunk_print';

  Procedure GMemChunkInfo;
  asmname 'g_mem_chunk_info';

{* Ah yes...we have a "g_blow_chunks" function.
 * "g_blow_chunks" simply compresses all the chunks. This operation
 *  consists of freeing every memory area that should be freed (but
 *  which we haven't gotten around to doing yet). And, no,
 *  "g_blow_chunks" doesn't follow the naming scheme, but it is a
 *  much better name than "g_mem_chunk_clean_all" or something
 *  similar.
 }
  Procedure GBlowChunks;
  asmname 'g_blow_chunks';


{ Timer }

  Function GTimerNew : PGTimer;
  asmname 'g_timer_new';
  Procedure GTimerDestroy (timer : PGTimer);
  asmname 'g_timer_destroy';
  Procedure GTimerStart (timer : PGTimer);
  asmname 'g_timer_start';
  Procedure GTimerStop (timer : PGTimer);
  asmname 'g_timer_stop';
  Procedure GTimerReset (timer : PGTimer);
  asmname 'g_timer_reset';
  Function GTimerElapsed (timer : PGTimer; microseconds : gulong) : gdouble;
  asmname 'g_timer_elapsed';


{ String utility functions that modify a string argument or
  return a constant string that must not be freed.
}
  Function GStrdelimit(stringg, delimiter : PGChar; newDelimiter : gchar) : PGChar;
  asmname 'g_strdelimit';


  Function GStrtod(nptr:PGChar; endptr:PPGChar) :gdouble;
  asmname 'g_strtod';

  Function GStrError(errnum : gint) : PGChar;
   asmname 'g_strerror';
  Function GStrError(signum : gint) : PGChar;
   asmname 'g_strsignal';
  Function GStrCaseCmp(stringg1, stringg2 : PGChar) : gint;
    asmname 'g_strcasecmp';
  Function GStrnCaseCmp(stringg1, stringg2 : PGChar; n : guint): gint;
    asmname 'g_strncasecmp';
  Procedure GStrDown(stringg : PGChar);
    asmname 'g_strdown';
  Procedure GStrUp(stringg : PGChar);
    asmname 'g_strup';
  Procedure GStrReverse(stringg : PGChar);
    asmname 'g_strreverse';

  { removes leading spaces }
  Function GStrChug (stringg: PGChar) : PGChar;
    asmname 'g_strchug';
  { removes trailing spaces }
  Function GStrChomp (stringg : PGChar) : PGChar;
    asmname 'g_strchomp';

  { removes leading & trailing spaces }
  Function GStrStrip( stringg: PGChar ) : PGChar;
    asmname 'g_strstrip';


  {  Retrive static string info }

  Function GGetUserName : PGChar;
    asmname 'g_get_user_name';
  Function GGetRealName : PGChar;
    asmname 'g_get_real_name';
  Function GGetHomeDir : PGChar;
    asmname 'g_get_home_dir';
  Function GGetTmpDir : PGChar;
    asmname 'g_get_tmp_dir';
  Function GGetPrgName : PGChar;
    asmname 'g_get_prgname';
  Procedure GSetPrgName(name : PGChar);
    asmname 'g_set_prgname';


  { Miscellaneous utility functions }

  Function GBaseName( fname : PGChar) : PGChar;
    asmname 'g_basename';
  Function GPathIsAbsolute( fname : PGChar) : gboolean;
    asmname 'g_path_is_absolute';
  Function GPathSkipRoot( fname : PGChar) : PGChar;
    asmname 'g_path_skip_root';

  { strings are newly allocated with g_malloc() }
  Function GDirname( fname : PGChar) : PGChar;
    asmname 'g_dirname';
  Function GGetCurrentDir : PGChar;
    asmname 'g_get_current_dir';
  { The returned memory should not be freed. }
  Function GGetEnv(variable : PGChar) : PGChar;
    asmname 'g_getenv';


  { String Chunks }
  Function GStringChunkNew(size : gint) : PGStringChunk;
    asmname 'g_string_chunk_new';
  Procedure GStringChunkFree(chunk : PGStringChunk);
    asmname 'g_string_chunk_free';
  Function GStringChunkInsert(chunk : PGStringChunk; stringg:PGChar) : PGChar;
    asmname 'g_string_chunk_insert';
  Function GStringChunkInsertConst(chunk : PGStringChunk; 
                          sringg:PGChar) : PGChar;
    asmname 'g_string_chunk_insert_const';

  { Hash Functions }
  Function GStrEqual(v, v2 : gconstpointer) : gint;
    asmname 'g_str_equal';
  Function GStrHash(v : gconstpointer) : guint;
    asmname 'g_str_hash';
  Function GIntEqual(v, v2 : gconstpointer) : gint;
    asmname 'g_int_equal';
  Function GIntHash(v : gconstpointer) : guint;
    asmname 'g_int_hash';

 { This "hash" function will just return the key's adress as an
 * unsigned integer. Useful for hashing on plain adresses or
 * simple integer values.
 * passing NULL into g_hash_table_new() as GHashFunc has the
 * same effect as passing g_direct_hash().
 }
  Function GDirectHash(v:gconstpointer) : gint;
    asmname 'g_direct_hash';
  Function GDirectEqual(v, v2 : gconstpointer) : gint;
    asmname 'g_direct_equal';


{* GDate
 *
 * Date calculations (not time for now, to be resolved). These are a
 * mutant combination of Steffen Beyer's DateCalc routines
 * (http://www.perl.com/CPAN/authors/id/STBEY/) and Jon Trowbridge's
 * date routines (written for in-house software).  Written by Havoc
 * Pennington <hp@pobox.com> 
 *}

{* g_date_new() returns an invalid date, you then have to _set() stuff 
 * to get a usable object. You can also allocate a GDate statically,
 * then call g_date_clear() to initialize.
 *}
Function GDateNew : PGDate;
  asmname 'g_date_new';
Function GDateNewDmy (day:GDateDayType; month:GDateMonthType; 
                          year:GDateYearType) : PGDate;
  asmname 'g_date_new_dmy';
Function GDateNewJulian (julianDay:guint32) : PGDate;
  asmname 'g_date_new_julian';
Procedure GDateFree(d : PGDate);
  asmname 'g_date_free';

{* check g_date_valid() after doing an operation that might fail, like
 * _parse.  Almost all g_date operations are undefined on invalid
 * dates (the exceptions are the mutators, since you need those to
 * return to validity).  
 *}
Function GDateValid(date : PGDate) : gboolean;
  asmname 'g_date_valid';
Function GDateValidDay(day : GDateDayType) : gboolean;
  asmname 'g_date_valid_day';
Function GDateValidMonth(month : GDateMonthType) : gboolean;
  asmname 'g_date_valid_month';
Function GDateValidYear(year : GDateYearType) : gboolean;
  asmname 'g_date_valid_year';
Function GDateValidWeekday(weekDay : GDateWeekdayType) : gboolean;
  asmname 'g_date_valid_weekday';
Function GDateValidJulian(julianDate : guint32) : gboolean;
  asmname 'g_date_valid_julian';
Function GDateValidDmy(day:GDateDayType; month:GDateMonthType; 
                          year:GDateYearType) :gboolean;
  asmname 'g_date_valid_dmy';
  
Function GDateWeekday(d:PGDate) :GDateWeekdayType;
  asmname 'g_date_weekday';
Function GDateMonth(d:PGDate) :GDateMonthType;
  asmname 'g_date_month';
Function GDateYear(d:PGDate) :GDateYearType;
  asmname 'g_date_year';
Function GDateDay(d:PGDate) :GDateDayType;
  asmname 'g_date_day';
Function GDateJulian(d:PGDate) :guint32;
  asmname 'g_date_julian';
Function GDateDayOfYear(d:PGDate) :guint;
  asmname 'g_date_day_of_year';

{* First monday/sunday is the start of week 1; if we haven't reached
 * that day, return 0. These are not ISO weeks of the year; that
 * routine needs to be added.
 * these functions return the number of weeks, starting on the
 * corrsponding day
 *}
Function GDateMondayWeekOfYear(d:PGDate) :guint;
  asmname 'g_date_monday_week_of_year';
Function GDateSundayWeekOfYear(d:PGDate) :guint;
  asmname 'g_date_sunday_week_of_year';

{* If you create a static date struct you need to clear it to get it
 * in a sane state before use. You can clear a whole array at
 * once with the ndates argument.
 *}
Procedure GDateClear(date:PGdate; ndates:guint);
  asmname 'g_date_clear';

{* The parse routine is meant for dates typed in by a user, so it
 * permits many formats but tries to catch common typos. If your data
 * needs to be strictly validated, it is not an appropriate function.
 *}
Procedure GDateSetParse(date:PGdate; str:PGChar);
  asmname 'g_date_set_parse';
Procedure GDateSetTime(date:PGdate; time:GTime);
  asmname 'g_date_set_time';
Procedure GDateSetMonth(date:PGdate; month:GDateMonthType);
  asmname 'g_date_set_month';
Procedure GDateSetDay(date:PGdate; day:GDateDayType);
  asmname 'g_date_set_day';
Procedure GDateSetYear(date:PGdate; year:GDateYearType);
  asmname 'g_date_set_year';
Procedure GDateSetDmy(date:PGdate; day:GDateDayType; 
                          month:GDateMonthType; year:GDateYearType);
  asmname 'g_date_set_dmy';
Procedure GDateSetJulian(date:PGdate; juldate:guint32);
  asmname 'g_date_set_julian';
Function GDateIsFirstOfMonth(date:PGdate) : gboolean;
  asmname 'g_date_is_first_of_month';
Function GDateIsLastOfMonth(date:PGdate) : gboolean;
  asmname 'g_date_is_last_of_month';

{* To go forward by some number of weeks just go forward weeks*7 days *}
Procedure GDateAddDays(date:PGdate; ndays:guint);
  asmname 'g_date_add_days';
Procedure GDateSubtractDays(date:PGdate; ndays:guint);
  asmname 'g_date_subtract_days';

{* If you add/sub months while day > 28, the day might change *}
Procedure GDateAddMonths(date:PGdate; nmonths:guint);
  asmname 'g_date_add_months';
Procedure GDateSubtractMonths(date:PGdate; nmonths:guint);
  asmname 'g_date_subtract_months';


{* If it's feb 29, changing years can move you to the 28th *}
Procedure GDateAddYears(date:PGdate; nyears:guint);
  asmname 'g_date_add_years';
Procedure GDateSubtractYears(date:PGdate; nyears:guint);
  asmname 'g_date_subtract_years';
Function GDateIsLeapYear(year:GDateYearType) : gboolean;
  asmname 'g_date_is_leap_year';
Function GDateDaysInMonth(month:GDateMonthType; year:GDateYearType) : guint8;
  asmname 'g_date_days_in_month';
Function GDateMondayWeeksInYear(year:GDateYearType) : guint8;
  asmname 'g_date_monday_weeks_in_year';
Function GDateSundayWeeksInYear(year:GDateYearType) : guint8;
  asmname 'g_date_sunday_weeks_in_year';

{* qsort-friendly (with a cast...) *}
Function GDateCompare(lhs, rhs : PGDate) : gint;
  asmname 'g_date_compare';

{* Just like strftime() except you can only use date-related formats.
 *   Using a time format is undefined.
 *}
Function GDateStrftime(stringg:PGChar;len:gsize;
                          format:PGChar;date:PGDate):gsize;
  asmname 'g_date_strftime';

{* GRelation
 *
 * Indexed Relations.  Imagine a really simple table in a
 * database.  Relations are not ordered.  This data type is meant for
 * maintaining a N-way mapping.
 *
 * g_relation_new() creates a relation with FIELDS fields
 *
 * g_relation_destroy() frees all resources
 * g_tuples_destroy() frees the result of g_relation_select()
 *
 * g_relation_index() indexes relation FIELD with the provided
 *   equality and hash functions.  this must be done before any
 *   calls to insert are made.
 *
 * g_relation_insert() inserts a new tuple.  you are expected to
 *   provide the right number of fields.
 *
 * g_relation_delete() deletes all relations with KEY in FIELD
 * g_relation_select() returns ...
 * g_relation_count() counts ...
 *}
Function GRelationNew(fields : gint) : PGRelation;
  asmname 'g_relation_new';
Procedure GRelationDestroy(relation : PGRelation);
  asmname 'g_relation_destroy';
Procedure GRelationIndex(relation:PGRelation; field:gint;
                         hashfunc:GHashFunc; comparefunc:GCompareFunc);
  asmname 'g_relation_index';
Procedure GRelationInsert(relation:PGRelation; ...);
  asmname 'g_relation_insert';
Function GRelationDelete(r:PGRelation; key:gconstpointer; field:gint) :gint;
  asmname 'g_relation_delete';
Function GRelationSelect(relation:PGRelation; key:gconstpointer; 
                         field:gint) :PGTuples;
  asmname 'g_relation_select';
Function GRelationCount(relation:PGRelation; key:gconstpointer; 
                         field:gint) :gint;
  asmname 'g_relation_count';
Function GRelationExists(relation:PGRelation; ...) : gboolean;
  asmname 'g_relation_exists';
Procedure GRelationPrint(relation:PGRelation);
  asmname 'g_relation_print';
  
Procedure GTuplesDestroy(tuples : PGTuples);
  asmname 'g_tuples_destroy';
Function GTuplesIndex(tuples : PGTuples; index, field : gint) : gpointer;
  asmname 'g_tuples_index';

{* Prime numbers. *}

{* This function returns prime numbers spaced by approximately 1.5-2.0
 * and is for use in resizing data structures which prefer
 * prime-valued sizes.  The closest spaced prime function returns the
 * next largest prime, or the highest it knows about which is about
 * MAXINT/4.
 *}
Function GSpacedPrimesClosest(num : guint) : guint;
  asmname 'g_spaced_primes_closest';

{* GIOChannel *}
Procedure GIOChannelInit( channel : PGIOChannel);
  asmname 'g_io_channel_init';
Procedure GIOChannelRef( channel : PGIOChannel);
  asmname 'g_io_channel_ref';
Procedure GIOChannelUnref( channel : PGIOChannel);
  asmname 'g_io_channel_unref';
Function GIOChannelRead(channel:PGIOChannel; buf:PGChar;
                        countt:guint; bytesRead:pguint) : GIOError;
  asmname 'g_io_channel_read';
Function GIOChannelWrite(channel:PGIOChannel; buf:PGChar;
                        coun:guint; bytesWritten:pguint) : GIOError;
  asmname 'g_io_channel_write';
Function GIOChannelSeek(channel:PGIOChannel; offset:gint;
                        typ:GSeekType) : GIOError;
  asmname 'g_io_channel_seek';
Procedure GIOChannelClose(channel : PGIOChannel);
  asmname 'g_io_channel_close';
Function GIOAddWatchFull(c:PGIOChannel; priority:gint; condition:GIOCondition;
                        func:GIOFunc; userdata:gpointer; 
                        notify:GDestroyNotify) : guint;
  asmname 'g_io_add_watch_full';
Function GIOAddWatch(c:PGIOChannel; condition:GIOCondition; func:GIOFunc; 
                        userdata:gpointer) : guint;
  asmname 'g_io_add_watch';

{* Hooks for adding to the main loop *}
Function GSourceAdd(priority:gint; canrecurse:gboolean; func:PGSourceFuncs;
                    sdata, udata: gpointer; notify:GDestroyNotify):guint;
  asmname 'g_source_add';
Function GSourceRemove(tag:guint) : gboolean;
  asmname 'g_source_remove';
Function GSourceRemoveByUserData(data:gpointer) : gboolean;
  asmname 'g_source_remove_by_user_data';
Function GSourceRemoveBySourceData(data:gpointer) : gboolean;
  asmname 'g_source_remove_by_source_data';
Function GSourceRemoveByFuncsUserData(f : PGSourceFuncs;
                    data:gpointer) : gboolean;
  asmname 'g_source_remove_by_funcs_user_data';
Procedure GGetCurrentTime (res : PGTimeVal);
  asmname 'g_get_current_time';

{* Running the main loop *}
Function GMainLoop(isrunning : gboolean) : PGMainLoop;
  asmname 'g_main_new';
Procedure GMainRun(looop : PGMainLoop);
  asmname 'g_main_run';
Procedure GMainQuit(looop : PGMainLoop);
  asmname 'g_main_quit';
Procedure GMainDestroy(looop : PGMainLoop);
  asmname 'g_main_destroy';
Function GMainIsRunning(looop : PGMainLoop) : gboolean;
  asmname 'g_main_is_running';

{* Run a single iteration of the mainloop. If block is FALSE,
 * will never block
 *}

Function GMainIteration(mayblock : gboolean) : gboolean;
  asmname 'g_main_iteration';
 
{* See if any events are pending *}

Function GMainPending : gboolean;
  asmname 'g_main_pending';


{* Idles and timeouts *}
Function GTimeoutAddFull(priority:gint; interval:guint; func : GSourceFunc;
                        data:gpointer; notify:GDestroyNotify) : guint;
  asmname 'g_timeout_add_full';
Function GTimeoutAdd(interval:guint; func : GSourceFunc;
                        data:gpointer) : guint;
  asmname 'g_timeout_add';
Function GIdleAdd(func : GSourceFunc; data:gpointer) : guint;
  asmname 'g_idle_add';
Function GIdleAddFull(priority:gint; func : GSourceFunc; 
                        data:gpointer; destr:GDestroyNotify) : guint;
  asmname 'g_idle_add_full';
Function GIdleRemoveByData(data:gpointer) : gboolean;
  asmname 'g_idle_remove_by_data';

{* GPollFD
 *
 * System-specific IO and main loop calls
 *
 * On Win32, the fd in a GPollFD should be Win32 HANDLE (*not* a file
 * descriptor as provided by the C runtime) that can be used by
 * MsgWaitForMultipleObjects. This does *not* include file handles
 * from CreateFile, SOCKETs, nor pipe handles. (But you can use
 * WSAEventSelect to signal events when a SOCKET is readable).
 *
 * On Win32, fd can also be the special value G_WIN32_MSG_HANDLE to
 * indicate polling for messages. These message queue GPollFDs should
 * be added with the g_main_poll_win32_msg_add function.
 *
 * But note that G_WIN32_MSG_HANDLE GPollFDs should not be used by GDK
 * (GTK) programs, as GDK itself wants to read messages and convert them
 * to GDK events.
 *
 * So, unless you really know what you are doing, it's best not to try
 * to use the main loop polling stuff for your own needs on
 * Win32. It's really only written for the GIMP's needs so
 * far.
 *}

Procedure GMainAddPoll(fd : PGPollFD; priority:gint);
  asmname 'g_main_add_poll';
Procedure GMainRemovePoll(fd : PGPollFD);
  asmname 'g_main_remove_poll';
Procedure GMainSetPollFunc(PollFunc : GPollFunc);
  asmname 'g_main_set_poll_func';

{* On Unix, IO channels created with this function for any file
 * descriptor or socket.
 *
 * On Win32, use this only for plain files opened with the MSVCRT (the
 * Microsoft run-time C library) _open(), including file descriptors
 * 0, 1 and 2 (corresponding to stdin, stdout and stderr).
 * Actually, don't do even that, this code isn't done yet.
 *
 * The term file descriptor as used in the context of Win32 refers to
 * the emulated Unix-like file descriptors MSVCRT provides.
 *}
Function GIoChannelUnixNew(fd : gint) : PGIoChannel;
  asmname 'g_io_channel_unix_new';
Function GIoChannelGetFd(channel : PGIoChannel) : gint;
  asmname 'g_io_channel_unix_get_fd';

function GPOINTER_TO_INT(x : Pointer) : Integer;
function GINT_TO_POINTER(x : Integer) : Pointer;

implementation

function GPOINTER_TO_INT(x : Pointer) : Integer;
begin
  GPOINTER_TO_INT := Integer(x);
end;

function GINT_TO_POINTER(x : Integer) : Pointer;
begin
  GINT_TO_POINTER := Pointer(x);
end;

end.
