{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GMODULE - GLIB wrapper code for dynamic module loading
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GModule;

interface

uses GPC, Glib;
  
const
  G_MODULE_BIND_LAZY = 1 shl 0;
  G_MODULE_BIND_MASK = 16#01;
type
  PGModuleFlags = ^GModuleFlags;
  xGModuleFlags = G_MODULE_BIND_LAZY .. G_MODULE_BIND_MASK;
  GModuleFlags  = Cardinal(BitSizeOf(xGModuleFlags));

type
  { PGModule is the original version, but since it's just a pointer
    (there's no corresponding TGModule or GModule) I'd declare a
    GModuleHandle, which doesn't hurt, and I would use instead of
    PGModule. }
  PGModule = Pointer;
  GModuleHandle = PGModule;

type
  GModuleCheckInit = ^function (M : PGModule) : PGChar;
  GModuleUnload = ^procedure (M : PGModule);

{ Return TRUE if dynamic module loading is supported }
function GModuleSupported : GBoolean;
asmname 'g_module_supported';

{ Open a module `file_name' and return handle, which is NULL on error. }
function GModuleOpen (FileName : PGChar; Flags : GModuleFlags) : PGModule;
asmname 'g_module_open';

{ Close a previously opened module, returns TRUE on success. }
function GModuleClose (M : PGModule) : GBoolean;
asmname 'g_module_close';

{ Make a module resident so g_module_close on it will be ignored. }
procedure GModuleMakeResident (M : PGModule);
asmname 'g_module_make_resident';

{ Query the last module error as a string. }
function GModuleError : PGChar;
asmname 'g_module_error';

{ Retrieve a symbol pointer from `module', returns TRUE on success. }
function GModuleSymbol (M : PGModule; SymName : PGChar; var Sym : GPointer) : GBoolean;
asmname 'g_module_symbol';

{ Retrieve the file name from an existing module. }
function GModuleName (M : PGModule) : PGChar;
asmname 'g_module_name';

{ Build the actual file name containing a module. `directory' is the
  directory where the module file is supposed to be, or NULL or empty
  in which case it should either be in the current directory or, on
  some operating systems, in some standard place, for instance on the
  PATH. Hence, to be absoultely sure to get the correct module,
  always pass in a directory. The file name consists of the directory,
  if supplied, and `module_name' suitably decorated accoring to
  the operating system's conventions (for instance lib*.so or *.dll).

  No checks are made that the file exists, or is of correct type. }
function GModuleBuildPath (Dir : PGChar; ModName : PGChar) : PGChar;
asmname 'g_module_build_path';
    
implementation

end.
