{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkAccelGroup;

interface

uses Glib, GdkTypes, GtkObject, GtkEnums;

const
  { Should the accelerator appear in the widget's display? }
  GTK_ACCEL_VISIBLE        = 1 shl 0;
  { Should the signal associated with this accelerator be also visible? }
  GTK_ACCEL_SIGNAL_VISIBLE = 1 shl 1;
  { May the accelerator be removed again? }
  GTK_ACCEL_LOCKED         = 1 shl 2;
  GTK_ACCEL_MASK           = 16#07;
type
  PGtkAccelFlags = ^TGtkAccelFlags;
  TGtkAccelFlags  = Integer;

type
  PGtkAccelGroup = ^TGtkAccelGroup;
  TGtkAccelGroup = record
    RefCount, LockCount : GUint;
    ModifierMask : GdkModifierType;
    AttachObjects : PGSList;
  end;

type
  PGtkAccelEntry = ^TGtkAccelEntry;
  TGtkAccelEntry = record
    { Key portion. }
    AccelGroup : PGtkAccelGroup;
    AcceleratorKey : GUint;
    AcceleratorMods : GdkModifierType;

    AccelFlags : TGtkAccelFlags;
    Obj : PGtkObject;
    SignalID : GUint;
  end;

{ Accelerators. }
function GtkAcceleratorValid (KeyVal : GUint; Modifiers : GdkModifierType) : GBoolean;
asmname 'gtk_accelerator_valid';

procedure GtkAcceleratorParse (Accelerator : PGChar; AcceleratorKey : PGUint; AcceleratorMods : PGdkModifierType);
asmname 'gtk_accelerator_parse';

function GtkAcceleratorName (AcceleratorKey : GUint; AcceleratorMods : GdkModifierType) : PGChar;
asmname 'gtk_accelerator_name';

procedure GtkAcceleratorSetDefaultModMask (DefaultModMask : GdkModifierType);
asmname 'gtk_accelerator_set_default_mod_mask';

function GtkAcceleratorGetDefaultModMask : GdkModifierType;
asmname 'gtk_accelerator_get_default_mod_mask';

{ Accelerator Groups. }
function GtkAccelGroupNew : PGtkAccelGroup;
asmname 'gtk_accel_group_new';

function GtkAccelGroupRef (AccelGroup : PGtkAccelGroup) : PGtkAccelGroup;
asmname 'gtk_accel_group_ref';

procedure GtkAccelGroupUnref (AccelGroup : PGtkAccelGroup);
asmname 'gtk_accel_group_unref';

procedure GtkAccelGroupLock (AccelGroup : PGtkAccelGroup);
asmname 'gtk_accel_group_lock';

procedure GtkAccelGroupUnlock (AccelGroup : PGtkAccelGroup);
asmname 'gtk_accel_group_unlock';

function GtkAccelGroupsActivate (Obj : PGtkObject; AccelKey : GUint; AccelMods : GdkModifierType) : GBoolean;
asmname 'gtk_accel_grous_activate';

{ !! Internal functions not implemented.
     Accelerator Group Entries (internal) not implemented.
     Accelerator Signals (internal) not implemented.
     Miscellaneous (internal) not implemented. }

implementation

end.
