{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkAdjustment;

interface

uses Glib, GtkData, GtkObject, GtkTypeUtils;

function GTK_TYPE_ADJUSTMENT : TGtkType;
asmname 'gtk_adjustment_get_type';

function GTK_IS_ADJUSTMENT (Obj : Pointer) : Boolean;
function GTK_IS_ADJUSTMENT_CLASS (Klass : Pointer) : Boolean;

type
  PGtkAdjustmentClass = ^TGtkAdjustmentClass;
  PGtkAdjustment      = ^TGtkAdjustment;

  TGtkAdjustmentClass = record
    ParentClass : TGtkDataClass;

    Changed, ValueChanged : ^procedure (Adj : PGtkAdjustment);
  end;

  TGtkAdjustment = record
    Data : TGtkData;

    Lower, Upper, VValue, StepIncrement, PageIncrement, PageSize : GFloat;
  end;

function GtkAdjustmentGetType : TGtkType;
asmname 'gtk_adjustment_get_type';

function GtkAdjustmentNew(AdjValue, Lower, Upper, StepIncrement, PageIncrement, PageSize : GFloat) : PGtkObject;
asmname 'gtk_adjustment_new';

procedure GtkAdjustmentChanged (Adjustment : PGtkAdjustment);
asmname 'gtk_adjustment_changed';

procedure GtkAdjustmentValueChanged (Adjustment : PGtkAdjustment);
asmname 'gtk_adjustment_value_changed';

procedure GtkAdjustmentClampPage (Adjustment : PGtkAdjustment; Lower, Upper : GFloat);
asmname 'gtk_adjustment_clamp_page';

procedure GtkAdjustmentSetValue (Adjustment : PGtkAdjustment; AdjValue : GFloat);
asmname 'gtk_adjustment_set_value';

implementation

function GTK_IS_ADJUSTMENT(Obj : Pointer) : Boolean;
begin
  GTK_IS_ADJUSTMENT := (Obj <> nil) and GTK_IS_ADJUSTMENT_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_ADJUSTMENT_CLASS(Klass : Pointer) : Boolean;
begin
  GTK_IS_ADJUSTMENT_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_ADJUSTMENT) = G_TRUE);
end;

end.
