{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkArg;

interface

uses Glib, GtkObject, GtkTypeUtils;

type
  PPGtkArgInfo = ^PGtkArgInfo;
  PGtkArgInfo = ^TGtkArgInfo;
  TGtkArgInfo = record
    { hash key portion }
    ClassType : TGtkType;
    Name : PGChar;

    TType : TGtkType;
    ArgFlags : GUint;
    FullName : PGChar;

    { private fields }
    ArgID, SeqID : GUint;
  end;


{ Non-public methods. }
function GtkArgNew(ArgType : TGtkType) : PGtkArg;
asmname 'gtk_arg_new';

function GtkArgCopy(SrcArg, DestArg : PGtkArg) : PGtkArg;
asmname 'gtk_arg_copy';

procedure GtkArgFree(Arg : PGtkArg; FreeContents : GBoolean);
asmname 'gtk_arg_free';

procedure GtkArgReset(Arg : PGtkArg);
asmname 'gtk_arg_reset';

function GtkArgValuesEqual(Arg1, Arg2 : PGtkArg) : GBoolean;
asmname 'gtk_arg_values_equal';

function GtkArgsCollect(ObjectType : TGtkType; ArgInfoHashTable : PGHashTable; ArgListP, InfoListP : PPGSList; FirstArgName : PGChar; VarArgs : PGChar) : PGChar;
asmname 'gtk_args_collect';

procedure GtkArgsCollectCleanup(ArgList, InfoList : PGSList);
asmname 'gtk_args_collect_cleanup';

function GtkArgGetInfo(ObjectType : TGtkType; ArgInfoHashTable : PGHashTable; ArgName : PGChar; InfoP : PPGtkArgInfo) : PGChar;
asmname 'gtk_arg_get_info';

function GtkArgTypeNewStatic(BaseClassType : TGtkType; ArgName : PGChar; ClassNArgsOffset : GUint; ArgInfoHashTable : PGHashTable; ArgType : TGtkType; ArgID, ClassType : GUint) : PGtkArgInfo;
asmname 'gtk_arg_type_new_static';

function GtkArgsQuery(ClassType : TGtkType; ArgInfoHashTable : PGHashTable; ArgFlags : PPGUint32; var NArgsP : GUint) : PGtkArg;
asmname 'gtk_args_query';

function GtkArgNameStripType(ArgName : PGChar) : PGChar;
asmname 'gtk_arg_name_strip_type';

function GtkArgInfoEqual(ArgInfo1, ArgInfo2 : GConstPointer) : GInt;
asmname 'gtk_arg_info_equal';

function GtkArgInfoHash(ArgInfo : GConstPointer) : GUint;
asmname 'gtk_arg_info_hash';

procedure GtkArgToValueLoc(Arg : PGtkArg; ValuePointer : GPointer);
asmname 'gtk_arg_to_valueloc';
       
implementation

end.
