{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkAspectFrame;

interface

uses Glib, GtkBin, GtkFrame, GtkObject, GtkWidget;

function GTK_TYPE_ASPECT_FRAME : TGtkType;
asmname 'gtk_aspect_frame_get_type';

function GTK_IS_ASPECT_FRAME (Obj : Pointer) : Boolean;
function GTK_IS_ASPECT_FRAME_CLASS (Klass : Pointer) : Boolean;

type
  PGtkAspectFrameClass = ^TGtkAspectFrameClass;
  PGtkAspectFrame = ^TGtkAspectFrame;

  TGtkAspectFrameClass = record
    ParentClass : TGtkBinClass;
  end;

  TGtkAspectFrame = record
    Frame : TGtkFrame;
    xAlign, yAlign, Ratio : GFloat;
    ObeyChild : GBoolean;
    CenterAllocation : TGtkAllocation;
  end;

function GtkAspectFrameGetType : TGtkType;
asmname 'gtk_aspect_frame_get_type';

function GtkAspectFrameNew(LLabel : PGChar; xAlign, yAlign, Ratio : GFloat; ObeyChild : GBoolean) : PGtkWidget;
asmname 'gtk_aspect_frame_new';

procedure GtkAspectFrameSet(AspectFrame : PGtkAspectFrame; xAlign, yAlign, Ratio : GFloat; ObeyChild : GBoolean);
asmname 'gtk_aspect_frame_set';

implementation

function GTK_IS_ASPECT_FRAME (Obj : Pointer) : Boolean;
begin
  GTK_IS_ASPECT_FRAME := (Obj <> nil) and GTK_IS_ASPECT_FRAME_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_ASPECT_FRAME_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_ASPECT_FRAME_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_ASPECT_FRAME) = G_TRUE);
end;

end.
