{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkBBox;

interface

uses Glib, GtkEnums, GtkObject, GtkBox;

function GTK_TYPE_BUTTON_BOX : TGtkType;
asmname 'gtk_button_box_get_type';
  
function GTK_IS_BUTTON_BOX (Obj : Pointer) : Boolean;
function GTK_IS_BUTTON_BOX_CLASS (Klass : Pointer) : Boolean;

const
  GTK_BUTTONBOX_DEFAULT = -1;

type
  PGtkButtonBoxClass = ^TGtkButtonBoxClass;
  PGtkButtonBox      = ^TGtkButtonBox;

  TGtkButtonBoxClass = record
    ParentClass : TGtkBoxClass;
  end;

  TGtkButtonBox = record
    Box : TGtkBox;
    Spacing, ChildMinWidth, ChildMinHeight, ChildIPadX, ChildIPadY : GInt;
    LayoutStyle : TGtkButtonBoxStyle;
  end;

function GtkButtonBoxGetType : TGtkType;
asmname 'gtk_button_box_get_type';

procedure GtkButtonBoxGetChildSizeDefault (var MinWidth, MinHeight : Gint);
asmname 'gtk_button_box_get_child_size_default';

procedure GtkButtonBoxGetChildIPaddingDefault(var x, y : GInt);
asmname 'gtk_button_box_get_child_ipadding_default';

procedure GtkButtonBoxSetChildSizeDefault (Width, Height : GInt);
asmname 'gtk_button_box_set_child_size_default';

procedure GtkButtonBoxSetChildIpaddingDefault(x, y : GInt);
asmname 'gtk_button_box_set_child_ipadding_default';

function GtkButtonBoxGetSpaceing (Box : PGtkButtonBox) : GInt;
asmname 'gtk_button_box_get_spacing';

function GtkButtonBoxGetLayout (Box : PGtkButtonBox) : TGtkButtonBoxStyle;
asmname 'gtk_button_box_get_layout';

procedure GtkButtonBoxGetChildSize (Box : PGtkButtonBox; Width, Height : GInt);
asmname 'gtk_button_box_get_child_size';

procedure GtkButtonBoxGetChildIPadding(Box : PGtkButtonBox; var x, y : GInt);
asmname 'gtk_button_box_get_child_ipadding';

procedure GtkButtonBoxSetSpacing (Box : PGtkButtonbox; Spacing : GInt);
asmname 'gtk_button_box_set_spacing';

procedure GtkButtonBoxSetLayout (Box : PGtkButtonBox; Layout : TGtkButtonBoxStyle);
asmname 'gtk_button_box_set_layout';

procedure GtkButtonBoxSetChildSize (Box : PGtkButtonBox; width,height:gint);
asmname 'gtk_button_box_set_child_size';

procedure GtkButtonBoxSetChildIpadding (Box : PGtkButtonBox; X, Y : GInt);
asmname 'gtk_button_box_set_child_ipadding';

implementation

function GTK_IS_BUTTON_BOX (Obj : Pointer) : Boolean;
begin
  GTK_IS_BUTTON_BOX := (Obj <> nil) and GTK_IS_BUTTON_BOX_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_BUTTON_BOX_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_BUTTON_BOX_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_BUTTON_BOX) = G_TRUE);
end;

End.


