{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkBox;

interface

uses Glib, GdkTypes, GtkContainer, GtkEnums, GtkObject, GtkWidget;

function GTK_TYPE_BOX : TGtkType;
asmname 'gtk_box_get_type';

function GTK_IS_BOX (Obj : Pointer) : Boolean;
function GTK_IS_BOX_CLASS (Klass : Pointer) : Boolean;

type
  PGtkBoxChild = ^TGtkBoxChild;
  PGtkBoxClass = ^TGtkBoxClass;
  PGtkBox      = ^TGtkBox;

  TGtkBoxClass = record
     ParentClass : TGtkContainerClass;
  end;

  TGtkBox = record
    Container : TGtkContainer;
    Children : PGList;
    Spacing : GInt16;
    Homogeneous : GUint1;
  end;

  TGtkBoxChildFrame1 = packed record
    Expand, Fill, Pack : GUint1;
  end;

  TGtkBoxChild = record
    Widget : PGtkWidget;
    Padding : GUint16;

    Frame1 : TGtkBoxChildFrame1;
  end;

function GtkBoxGetType : TGtkType;
asmname 'gtk_box_get_type';

procedure GtkBoxPackStart (Box : PGtkBox; Child : PGtkWidget; Expand, Fill : GBoolean; Padding : GUint);
asmname 'gtk_box_pack_start';

procedure GtkBoxPackEnd (Box : PGtkBox; Child : PGtkWidget; Expand, Fill : GBoolean; Padding : GUint);
asmname 'gtk_box_pack_end';

procedure GtkBoxPackStartDefaults (Box : PGtkBox; Child : PGtkWidget);
asmname 'gtk_box_pack_start_defaults';

procedure GtkBoxPackEndDefaults (Box : PGtkBox; Child : PGtkWidget);
asmname 'gtk_box_pack_end_defaults';

procedure GtkBoxSetHomogeneous (Box : PGtkBox; Homogeneous : GBoolean);
asmname 'gtk_box_set_homogeneous';

procedure GtkBoxSetSpacing (Box : PGtkBox; Spacing : GInt);
asmname 'gtk_box_set_spacing';

procedure GtkBoxReorderChild(Box : PGtkBox; Container : PGtkWidget; Position : GInt);
asmname 'gtk_box_reorder_child';

procedure GtkBoxQueryChildPacking (Box : PGtkBox; Child : PGtkWidget; var Expand, Fill : GBoolean; var Padding : GUint; var PackType : TGtkPackType);
asmname 'gtk_box_query_child_packing';

procedure GtkBoxSetChildPacking (Box : PGtkBox; Child : PGtkWidget; Expand, Fill : GBoolean; Padding : GUint; PackType : TGtkPackType);
asmname 'gtk_box_set_child_packing';

implementation

function GTK_IS_BOX (Obj : Pointer) : Boolean;
begin
  GTK_IS_BOX := (Obj <> nil) and GTK_IS_BOX_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_BOX_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_BOX_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_BOX) = G_TRUE);
end;

end.
