{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

Unit GtkCalendar;

Interface

Uses
  Glib, GdkTypes, GtkSignal, GtkObject, GtkWidget;

Const
  { GtkCalendarDisplayOptions }
  GTK_CALENDAR_SHOW_HEADING       = 1 shl 0;
  GTK_CALENDAR_SHOW_DAY_NAMES     = 1 shl 1;
  GTK_CALENDAR_NO_MONTH_CHANGE    = 1 shl 2;
  GTK_CALENDAR_SHOW_WEEK_NUMBERS  = 1 shl 3;
  GTK_CALENDAR_WEEK_START_MONDAY  = 1 shl 4;

type
  dmArray=array[0..5,0..6] Of gint;
  mdArray=array[0..30] Of gint;
  mdcArray=array[0..30] Of GdkColor;
  gsaArray=array[0..31] Of Gchar;
  
Type
  TGtkCalendarDisplayOptions = Integer;
  PGtkCalendar = ^TGtkCalendar;
  PGtkCalendarClass = ^TGtkCalendarClass;

  TGtkCalendar = Record
    Widget : TGtkWidget;
    HeaderStyle, LabelStyle : PGtkStyle;
    Month, Year, SelectedDay : gint;
    DayMonth, Day : dmArray;
    NumMarkedDates : gint;
    MarkedDate : mdArray;
    DisplayFlags : TGtkCalendarDisplayOptions;
    MarkedDateColor : mdcArray;

    GC, XorGC : PGdkGC;
    FocusRow, FocusCol : gint;
    HighlightRow, HighlightCol : gint;
    PrivateData : gpointer;
    GrowSpace: gsaArray;
  End;

  TGtkCalendarClass = Record
    ParentClass : TGtkWidgetClass;
    
    { Signal handlers } 
    MonthChanged : ^Procedure (Calendar : PGtkCalendar);
    DaySelected : ^Procedure (Calendar : PGtkCalendar);
    DaySelectedDoubleClick : ^Procedure (Calendar : PGtkCalendar);
    PrevMonth : ^Procedure (Calendar : PGtkCalendar);
    NextMonth : ^Procedure (Calendar : PGtkCalendar);
    PrevYear : ^Procedure (Calendar : PGtkCalendar);
    NextYear : ^Procedure (Calendar : PGtkCalendar);
  End;

function GTK_TYPE_CALENDAR : TGtkType;
asmname 'gtk_calendar_get_type';

function GTK_IS_CALENDAR (Obj : Pointer) : Boolean;
function GTK_IS_CALENDAR_CLASS (Klass : Pointer) : Boolean;

function GtkCalendarGetType : TGtkType;
asmname 'gtk_calendar_get_type';

function GtkCalendarNew : PGtkWidget;
asmname 'gtk_calendar_new';

function GtkCalendarSelectMonth(Calendar : PGtkCalendar; Month, Year : GUint) : GInt;
asmname 'gtk_calendar_select_month';

procedure GtkCalendarSelectDay(Calendar : PGtkCalendar; Day : guint);
asmname 'gtk_calendar_select_day';

function GtkCalendarMarkDay(Calendar : PGtkCalendar; Day : guint) : gint;
asmname 'gtk_calendar_mark_day';

function GtkCalendarUnmarkDay(Calendar : PGtkCalendar; Day : guint) : gint;
asmname 'gtk_calendar_unmark_day';

procedure GtkCalendarClearMarks(Calendar : PGtkCalendar);
asmname 'gtk_calendar_clear_marks';

procedure GtkCalendarDisplayOptions(Calendar : PGtkCalendar; Flags : TGtkCalendarDisplayOptions);
asmname 'gtk_calendar_display_options';

procedure GtkCalendarGetDate(Calendar : PGtkCalendar; var Year, Month, Day : guint);
asmname 'gtk_calendar_get_date';

procedure GtkCalendarFreeze(Calendar : PGtkCalendar);
asmname 'gtk_calendar_freeze';

procedure GtkCalendarThaw(Calendar : PGtkCalendar);
asmname 'gtk_calendar_thaw';

implementation

function GTK_IS_CALENDAR (Obj : Pointer) : Boolean;
begin
  GTK_IS_CALENDAR := (Obj <> nil) and GTK_IS_CALENDAR_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_CALENDAR_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_CALENDAR_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_CALENDAR) = G_TRUE);
end;

end.

