{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkCheckMenuItem;

interface

uses Glib, GdkTypes, GtkMenuItem, GtkObject, GtkWidget;

function GTK_TYPE_CHECK_MENU_ITEM : TGtkType;
asmname 'gtk_check_menu_item_get_type';

function GTK_IS_CHECK_MENU_ITEM (Obj : Pointer) : Boolean;
function GTK_IS_CHECK_MENU_ITEM_CLASS (Klass : Pointer) : Boolean;

type
  PGtkCheckMenuItemClass = ^TGtkCheckMenuItemClass;
  PGtkCheckMenuItem = ^TGtkCheckMenuItem;

  TGtkCheckMenuItemClass = record
    ParentClass : TGtkMenuItemClass;

    Toggled : ^procedure(CheckMenuItem : PGtkCheckMenuItem);
    DrawIndicator : ^procedure(CheckMenuItem : PGtkCheckMenuItem; Area : PGdkRectangle);
  end;

  TGtkCheckMenuItemFrame1 = packed record
    Active, AlwaysShowToggle : GUint1;
  end;

  TGtkCheckMenuItem = record
    MenuItem : TGtkMenuItem;

    Frame1 : TGtkCheckMenuItemFrame1;
  end;

function GtkCheckMenuItemGetType : TGtkType;
asmname 'gtk_check_menu_item_get_type';

function GtkCheckMenuItemNew : PGtkWidget;
asmname 'gtk_check_menu_item_new';

function GtkCheckMenuItemNewWithLabel(LLabel : PGChar) : PGtkWidget;
asmname 'gtk_check_menu_item_new_with_label';

procedure GtkCheckMenuItemSetActive(CheckMenuItem : PGtkCheckMenuItem; IsActive : GBoolean);
asmname 'gtk_check_menu_item_set_active';

procedure GtkCheckMenuItemSetShowToggle(MenuItem : PGtkCheckMenuItem; Always : GBoolean);
asmname 'gtk_check_menu_item_set_show_toggle';

procedure GtkCheckMenuItemToggled(CheckMenuItem : PGtkCheckMenuItem);
asmname 'gtk_check_menu_item_toggled';

implementation

function GTK_IS_CHECK_MENU_ITEM (Obj : Pointer) : Boolean;
begin
  GTK_IS_CHECK_MENU_ITEM := (Obj <> nil) and GTK_IS_CHECK_MENU_ITEM_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_CHECK_MENU_ITEM_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_CHECK_MENU_ITEM_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_CHECK_MENU_ITEM) = G_TRUE);
end;

end.
