{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkColorSel;

interface

uses Glib, GdkTypes, GtkEnums, GtkObject, GtkVBox, GtkWindow, GtkWidget;

function GTK_TYPE_COLOR_SELECTION : TGtkType;
asmname 'gtk_color_selection_get_type';

function GTK_TYPE_COLOR_SELECTION_DIALOG : TGtkType;
asmname 'gtk_color_selection_dialog_get_type';

function GTK_IS_COLOR_SELECTION (Obj : Pointer) : Boolean;
function GTK_IS_COLOR_SELECTION_CLASS (Klass : Pointer) : Boolean;
function GTK_IS_COLOR_SELECTION_DIALOG (Obj : Pointer) : Boolean;
function GTK_IS_COLOR_SELECTION_DIALOG_CLASS (Klass : Pointer) : Boolean;

type
  PGtkColorSelectionClass = ^TGtkColorSelectionClass;
  PGtkColorSelection = ^TGtkColorSelection;

  PGtkColorSelectionDialogClass = ^TGtkColorSelectionDialogClass;
  PGtkColorSelectionDialog = ^TGtkColorSelectionDialog;

  TGtkColorSelectionClass = record
    ParentClass : TGtkVBoxClass;
    ColorChanged : ^procedure (ColorSelection : PGtkColorSelection);
  end;

  WidArray = array[0..7] of PGtkWidget;
  DoubleArray = array[0..7] of GDouble;

  TGtkColorSelection = record
    VBox : TGtkVBox;
    WheelArea, ValueArea, SampleArea, SampleAreaEB : PGtkWidget;
    Scales, Entries : WidArray;
    OpacityLabel : PGtkWidget;
    WheelGC, ValueGC, SampleGC : PGdkGC;
    Policy : TGtkUpdateType;
    UseOpacity, TimerActive, TimerTag : GInt;
    Values, OldValues : DoubleArray;
    WheelBuf, ValueBuf, SampleBuf : PGUChar;
  end;
  
  TGtkColorSelectionDialogClass = record
    ParentClass : TGtkWindowClass;
  end;

  TGtkColorSelectionDialog = packed record
    Window : TGtkWindow;
    Colorsel, MainVBox, OkButton, ResetButton, CancelButton, HelpButton : PGtkWidget;
  end;

{ ColorSelection }

function GtkColorSelectionGetType : TGtkType;
asmname 'gtk_color_selection_get_type';

function GtkColorSelectionNew : PGtkWidget;
asmname 'gtk_color_selection_new';

procedure GtkColorSelectionSetUpdatePolicy (ColorSelection : PGtkcolorSelection; Policy : TGtkUpdateType);
asmname 'gtk_color_selection_set_update_policy';

procedure GtkColorSelectionSetOpycity (ColorSelection : PGtkColorSelection; UseOP : GInt);
asmname 'gtk_color_selection_set_opacity';

procedure GtkColorSelectionSetColor (ColorSelection : PGtkcolorSelection; Color : PGDouble);
asmname 'gtk_color_selection_set_color';

procedure GtkColorSelectionGetColor (ColorSelection : PGtkColorSelection; var Color : GDouble);
asmname 'gtk_color_selection_get_color';

{ ColorSelectionDialog }

function GtkColorSelectionDialogGetType : TGtkType;
asmname 'gtk_color_selection_dialog_get_type';

function GtkColorSelectionDialogNew (Title : PGChar) : PGtkWidget;
asmname 'gtk_color_selection_dialog_new';

implementation

function GTK_IS_COLOR_SELECTION (Obj : Pointer) : Boolean;
begin
  GTK_IS_COLOR_SELECTION := (Obj <> nil) and GTK_IS_COLOR_SELECTION_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_COLOR_SELECTION_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_COLOR_SELECTION_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_COLOR_SELECTION) = G_TRUE);
end;

function GTK_IS_COLOR_SELECTION_DIALOG (Obj : Pointer) : Boolean;
begin
  GTK_IS_COLOR_SELECTION_DIALOG := (Obj <> nil) and GTK_IS_COLOR_SELECTION_DIALOG_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_COLOR_SELECTION_DIALOG_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_COLOR_SELECTION_DIALOG_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_COLOR_SELECTION_DIALOG) = G_TRUE);
end;

end.
