{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkCombo;

interface

uses Glib, Gdk, GtkHBox, GtkItem, GtkObject, GtkWidget;

function GTK_TYPE_COMBO : TGtkType;
asmname 'gtk_combo_get_type';

function GTK_IS_COMBO (Obj : Pointer) : Boolean;
function GTK_IS_COMBO_CLASS (Klass : Pointer) : Boolean;

type
  PGtkComboClass = ^TGtkComboClass;
  PGtkCombo      = ^TGtkCombo;

  TGtkComboClass = record
    ParentClass : TGtkHBoxClass;
  end;

  TGtkComboFrame1 = packed record
    ValueInList, OkIfEmpty, CaseSensitive, UseArrows, UseArrowsAlways : GUint1;
  end;

  { You should access only the entry and list fields directly. }
  TGtkCombo = record
    HBox : TGtkHBox;
    Entry, Button, PopUp, PopWin, List : PGtkWidget;
    EntryChangeID, ListChangeID : GUint;

    Frame1 : TGtkComboFrame1;

    CurrentButton : GUint16;
    ActivateID : GUint;
  end;

function GtkComboGetType : TGtkType;
asmname 'gtk_combo_get_type';

function GtkComboNew : PGtkWidget;
asmname 'gtk_combo_new';

{ The text in the entry must be or not be in the list. }
procedure GtkComboSetValueInList (Combo : PGtkCombo; V, OkIfEmpty : GInt);
asmname 'gtk_combo_set_value_in_list';

{ Set/unset arrows working for changing the value (can be annoying). }
procedure GtkComboSetUseArrows (Combo : PGtkCombo; V : GInt);
asmname 'gtk_combo_set_use_arrows';

{ Up/down arrows change value if current value not in list. }
procedure GtkComboSetUseArrowsAlways (Combo : PGtkCombo; V : GInt);
asmname 'gtk_combo_set_use_arrows_always';

{ Perform case-sensitive compares. }
procedure GtkComboSetCaseSensitive (Combo : PGtkCombo; V : GInt);
asmname 'gtk_combo_set_case_sensitive';

{ Call this function on an item if it isn't a label or you
  want it to have a different value to be displayed in the entry. }
procedure GtkComboSetItemString (Combo : PGtkCombo; Item : PGtkItem; V : PGChar);
asmname 'gtk_combo_set_item_string';

{ Simple interface. }
procedure GtkComboSetPopdownStrings (Combo : PGtkCombo; Strings : PGList);
asmname 'gtk_combo_set_popdown_strings';

procedure GtkComboDisableActivate (Combo : PGtkCombo);
asmname 'gtk_combo_disable_activate';

implementation

function GTK_IS_COMBO (Obj : Pointer) : Boolean;
begin
  GTK_IS_COMBO := (Obj <> nil) and GTK_IS_COMBO_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_COMBO_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_COMBO_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_COMBO) = G_TRUE);
end;

end.

