{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkCurve;

interface

uses Glib, GdkTypes, GtkDrawingArea, GtkEnums, GtkObject, GtkWidget;

function GTK_TYPE_CURVE : TGtkType;
asmname 'gtk_curve_get_type';

function GTK_IS_CURVE (Obj : Pointer) : Boolean;
function GTK_IS_CURVE_CLASS (Klass : Pointer) : Boolean;

type
  PGtkCurveClass = ^TGtkCurveClass;
  PGtkCurve      = ^TGtkCurve;

  TGtkCurveClass = record
    ParentClass : TGtkDrawingAreaClass;

    CurveTypeChanged : ^procedure(Curve : PGtkCurve);
  end;

  PGtkCurveFrame1 = ^TGtkCurveFrame1;
  TGtkCurveFrame1 = array[0..1] of GFloat;

  TGtkCurve = record
    Graph : TGtkDrawingArea;

    CursorType : GInt;
    MinX, MaxX, MinY, MaxY : GFloat;
    Pixmap : PGdkPixmap;
    CurveType : TGtkCurveType;
    Height,     { (cached) graph height in pixels }
    GrabPoint,  { point currently grabbed         }
    Last : GInt;

    { (cached) curve points: }
    NumPoints : GInt;
    Point : PGdkPoint;

    { control points: }
    NumCtlPoints : GInt; { Number of control points. }
    CtlPoint : PGtkCurveFrame1; { Array of control points. }
  end;

function GtkCurveGetType : TGtkType;
asmname 'gtk_curve_get_type';

function GtkCurveNew : PGtkWidget;
asmname 'gtk_curve_new';

procedure GtkCurveReset(Curve : PGtkCurve);
asmname 'gtk_curve_reset';

procedure GtkCurveSetGamma(Curve : PGtkCurve; Gamma : GFloat);
asmname 'gtk_curve_set_gamma';

procedure GtkCurveSetRange(Curve : PGtkCurve; MinX, MaxX, MinY, MaxY : GFloat);
asmname 'gtk_curve_set_range';

procedure GtkCurveGetVector(Curve : PGtkCurve; VecLen : Integer; Vector : PGFloat);
asmname 'gtk_curve_get_vector';

procedure GtkCurveSetVector(Curve : PGtkCurve; VecLen : Integer; Vector : PGFloat);
asmname 'gtk_curve_set_vector';

procedure GtkCurveSetCurveType(Curve : PGtkCurve; TType : TGtkCurveType);
asmname 'gtk_curve_set_curve_type';

implementation

function GTK_IS_CURVE (Obj : Pointer) : Boolean;
begin
  GTK_IS_CURVE := (Obj <> nil) and GTK_IS_CURVE_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_CURVE_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_CURVE_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_CURVE) = G_TRUE);
end;

end.
