{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkDND;

interface

uses Glib, GdkTypes, GtkSelection, GtkWidget;

const
  GTK_DEST_DEFAULT_MOTION    = 1 shl 0; { respond to "drag_motion" }
  GTK_DEST_DEFAULT_HIGHLIGHT = 1 shl 1; { auto-highlight }
  GTK_DEST_DEFAULT_DROP      = 1 shl 2; { respond to "drag_drop" }
  GTK_DEST_DEFAULT_ALL       = 15#07;
type
  PGtkDestDefaults = ^TGtkDestDefaults;
  TGtkDestDefaults = Integer;

{ Flags for the GtkTargetEntry on the destination side. }
const
  GTK_TARGET_SAME_APP    = 1 shl 0; {< nick=same-app >}
  GTK_TARGET_SAME_WIDGET = 1 shl 1; {< nick=same-widget >}
type
  PGtkTargetFlags = ^TGtkTargetFlags;
  TGtkTargetFlags = Integer;

{ Destination side }

procedure GtkDragGetData(Widget : PGtkWidget; Context : PGdkDragContext; Target : GdkAtom; Time : GUint32);
asmname 'gtk_drag_get_data';

procedure GtkDragFinish(Context : PGdkDragContext; Success, Del : GBoolean; Timne : GUint32);
asmname 'gtk_drag_finish';

function GtkDragGetSourceWidget(Context : PGdkDragContext) : PGtkWidget;
asmname 'gtk_drag_get_source_widget';

procedure GtkDragHighlight(Widget : PGtkWidget);
asmname 'gtk_drag_highlight';

procedure GtkDragUnhighlight(Widget : PGtkWidget);
asmname 'gtk_drag_unhighlight';

procedure GtkDragDestSet(Widget : PGtkWidget; Flags : TGtkDestDefaults; Targets : PGtkTargetEntry; NTargets : GInt; Actions : GdkDragAction);
asmname 'gtk_drag_dest_set';

procedure GtkDragDestSetProxy(Widget : PGtkWidget; ProxyWindow : PGdkWindow; Protocol : GdkDragProtocol; UseCoordinates : GBoolean);
asmname 'gtk_drag_dest_set_proxy';

{ There probably should be functions for setting the targets
  as a GtkTargetList. }

procedure GtkDragDestUnset(Widget : PGtkWidget);
asmname 'gtk_drag_dest_unset';

{ Source side }

procedure GtkDragSourceSet(Widget : PGtkWidget; StartButtonMask : GdkModifierType; Targets : PGtkTargetEntry; NTargets : GInt; Actions : GdkDragAction);
asmname 'gtk_drag_source_set';

procedure GtkDragSourceUnset(Widget : PGtkWidget);
asmname 'gtk_drag_source_unset';

procedure GtkDragSourceSetIcon(Widget : PGtkWidget; Colormap : PGdkColormap; Pixmap : PGdkPixmap; Mask : PGdkBitmap);
asmname 'gtk_drag_source_set_icon';

{ There probably should be functions for setting the targets as a GtkTargetList. }

function GtkDragBegin(Widget : PGtkWidget; Targets : PGtkTargetList; Actions : GdkDragAction; Button : GInt; Event : PGdkEvent) : PGdkDragContext;
asmname 'gtk_drag_begin';

{ Set the image being dragged around. }
procedure GtkDragSetIconWidget(Context : PGdkDragContext; Widget : PGtkWidget; HotX, HotY : GInt);
asmname 'gtk_drag_set_icon_widget';

procedure GtkDragSetIconPixmap(Context : PGdkDragContext; Colormap : PGdkColormap; Pixmap : PGdkPixmap; Mask : PGdkBitmap; HotX, HotY : GInt);
asmname 'gtk_drag_set_icon_pixmap';

procedure GtkDragSetIconDefault(Context : PGdkDragContext);
asmname 'gtk_drag_set_icon_default';

procedure GtkDragSetDefaultIcon(Colormap : PGdkColormap; Pixmap : PGdkPixmap; Mask : PGdkBitmap; HotX, HotY : GInt);
asmname 'gtk_drag_set_default_icon';

{ !! Internal functions not implemented. }

implementation

end.
