{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkDrawingArea;

interface

uses Glib, GtkObject, GtkWidget;

function GTK_TYPE_DRAWING_AREA : TGtkType;
asmname 'gtk_drawing_area_get_type';

function GTK_IS_DRAWING_AREA (Obj : Pointer) : Boolean;
function GTK_IS_DRAWING_AREA_CLASS (Klass : Pointer) : Boolean;

type
  PGtkDrawingAreaClass = ^TGtkDrawingAreaClass;
  PGtkDrawingArea      = ^TGtkDrawingArea;

  TGtkDrawingAreaClass = record
    ParentClass : TGtkWidgetClass;
  end;

  TGtkDrawingArea = record
    Widget : TGtkWidget;
    DrawData : GPointer;
  end;

function GtkDrawingAreaGetType : TGtkType;
asmname 'gtk_drawing_area_get_type';

function GtkDrawingAreaNew : PGtkWidget;
asmname 'gtk_drawing_area_new';

procedure GtkDrawingAreaSize (DArea : PGtkDrawingArea; Width, Height : GInt);
asmname 'gtk_drawing_area_size';

implementation

function GTK_IS_DRAWING_AREA (Obj : Pointer) : Boolean;
begin
  GTK_IS_DRAWING_AREA := (Obj <> nil) and GTK_IS_DRAWING_AREA_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_DRAWING_AREA_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_DRAWING_AREA_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_DRAWING_AREA) = G_TRUE);
end;

end.

