{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkEnums;

interface

const
  GTK_ARROW_UP    = 0;
  GTK_ARROW_DOWN  = 1;
  GTK_ARROW_LEFT  = 2;
  GTK_ARROW_RIGHT = 3;
type
  PGtkArrowType = ^TGtkArrowType;
  TGtkArrowType = Integer;

{ Attach options (for tables). }
const
  GTK_EXPAND = 1 shl 0;
  GTK_SHRINK = 1 shl 1;
  GTK_FILL   = 1 shl 2;
type
  PGtkAttachOptions = ^TGtkAttachOptions;
  TGtkAttachOptions = Integer;

{ Button box styles. }
const
  GTK_BUTTONBOX_DEFAULT_STYLE = 0;
  GTK_BUTTONBOX_SPREAD        = 1;
  GTK_BUTTONBOX_EDGE          = 2;
  GTK_BUTTONBOX_START         = 3;
  GTK_BUTTONBOX_END           = 4;
type
  PGtkButtonBoxStyle = ^TGtkButtonBoxStyle;
  TGtkButtonBoxStyle = Integer;

{ Curve types. }
const
  GTK_CURVE_TYPE_LINEAR = 0; { linear interpolation }
  GTK_CURVE_TYPE_SPLINE = 1; { spline interpolation }
  GTK_CURVE_TYPE_FREE   = 2; { free form curve      }
type
  PGtkCurveType = ^TGtkCurveType;
  TGtkCurveType = Integer;

{ Focus movement types. }
const
  GTK_DIR_TAB_FORWARD  = 0;
  GTK_DIR_TAB_BACKWARD = 1;
  GTK_DIR_UP           = 2;
  GTK_DIR_DOWN         = 3;
  GTK_DIR_LEFT         = 4;
  GTK_DIR_RIGHT        = 5;
type
  PGtkDirectionType = ^TGtkDirectionType;
  TGtkDirectionType = Integer;

{ Justification for label and maybe other widgets (text?). }
const
  GTK_JUSTIFY_LEFT   = 0;
  GTK_JUSTIFY_RIGHT  = 1;
  GTK_JUSTIFY_CENTER = 2;
  GTK_JUSTIFY_FILL   = 3;
type
  PGtkJustification = ^TGtkJustification;
  TGtkJustification = Integer;

{ GtkPatternSpec match types. }
const
  GTK_MATCH_ALL      = 0;  { "*A?A*" }
  GTK_MATCH_ALL_TAIL = 1;  { "*A?AA" }
  GTK_MATCH_HEAD     = 2;  { "AAAA*" }
  GTK_MATCH_TAIL     = 3;  { "*AAAA" }
  GTK_MATCH_EXACT    = 4;  { "AAAAA" }
  GTK_MATCH_LAST     = 5;
type
  PGtkMatchType = ^TGtkMatchType;
  TGtkMatchType = Integer;

{ Menu keyboard movement types. }
const
  GTK_MENU_DIR_PARENT = 0;
  GTK_MENU_DIR_CHILD  = 1;
  GTK_MENU_DIR_NEXT   = 2;
  GTK_MENU_DIR_PREV   = 3;
type
  PGtkMenuDirectionType = ^TGtkMenuDirectionType;
  TGtkMenuDirectionType = Integer;

const
  GTK_MENU_FACTORY_MENU        = 0;
  GTK_MENU_FACTORY_MENU_BAR    = 1;
  GTK_MENU_FACTORY_OPTION_MENU = 2;
type
  PGtkMenuFactoryType = ^TGtkMenuFactoryType;
  TGtkMenuFactoryType = Integer;

const
  GTK_PIXELS      = 0;
  GTK_INCHES      = 1;
  GTK_CENTIMETERS = 2;
type
  PGtkMetricType = ^TGtkMetricType;
  TGtkMetricType = Integer;

{ Orientation for toolbars, etc. }
const
  GTK_ORIENTATION_HORIZONTAL = 0;
  GTK_ORIENTATION_VERTICAL   = 1;
type
  PGtkOrientation = ^TGtkOrientation;
  TGtkOrientation = Integer;

{ Placement type for scrolled window. }
const
  GTK_CORNER_TOP_LEFT     = 0;
  GTK_CORNER_BOTTOM_LEFT  = 1;
  GTK_CORNER_TOP_RIGHT    = 2;
  GTK_CORNER_BOTTOM_RIGHT = 3;
type
  PGtkCornerType = ^TGtkCornerType;
  TGtkCornerType = Integer;

{ Packing types (for boxes). }
const
  GTK_PACK_START = 0;
  GTK_PACK_END   = 1;
type
  PGtkPackType = ^TGtkPackType;
  TGtkPackType = Integer;

{ Priorities for path lookups. }
const
  GTK_PATH_PRIO_LOWEST      = 0;
  GTK_PATH_PRIO_GTK         = 4;
  GTK_PATH_PRIO_APPLICATION = 8;
  GTK_PATH_PRIO_RC          = 12;
  GTK_PATH_PRIO_HIGHEST     = 15;
  GTK_PATH_PRIO_MASK        = 16#0f;
type
  PGtkPathPriorityType = ^TGtkPathPriorityType;
  TGtkPathPriorityType = Integer;

{ Widget path types. }
const
  GTK_PATH_WIDGET       = 0;
  GTK_PATH_WIDGET_CLASS = 1;
  GTK_PATH_CLASS        = 2;
type
  PGtkPathType = ^TGtkPathType;
  TGtkPathType = Integer;

{ Scrollbar policy types (for scrolled windows). }
const
  GTK_POLICY_ALWAYS    = 0;
  GTK_POLICY_AUTOMATIC = 1;
  GTK_POLICY_NEVER     = 2;
type
  PGtkPolicyType = ^TGtkPolicyType;
  TGtkPolicyType = Integer;

const
  GTK_POS_LEFT   = 0;
  GTK_POS_RIGHT  = 1;
  GTK_POS_TOP    = 2;
  GTK_POS_BOTTOM = 3;
type
  PGtkPositionType = ^TGtkPositionType;
  TGtkPositionType = Integer;

const
  GTK_PREVIEW_COLOR     = 0;
  GTK_PREVIEW_GRAYSCALE = 1;
type
  PGtkPreviewType = ^TGtkPreviewType;
  TGtkPreviewType = Integer;

{ Style for buttons. }
const
  GTK_RELIEF_NORMAL = 0;
  GTK_RELIEF_HALF   = 1;
  GTK_RELIEF_NONE   = 2;
type
  PGtkReliefStyle = ^TGtkReliefStyle;
  TGtkReliefStyle = Integer;

{ Resize type. }
const
  GTK_RESIZE_PARENT    = 0; { Pass resize request to the parent. }
  GTK_RESIZE_QUEUE     = 1; { Queue resizes on this widget. }
  GTK_RESIZE_IMMEDIATE = 2; { Perform the resizes now. }
type
  PGtkResizeMode = ^TGtkResizeMode;
  TGtkResizeMode = Integer;

{ Signal run types. }
const
  GTK_RUN_FIRST      = 1 shl 0;
  GTK_RUN_LAST       = 1 shl 1;
  GTK_RUN_BOTH       = GTK_RUN_FIRST or GTK_RUN_LAST;
  GTK_RUN_NO_RECURSE = 1 shl 2;
  GTK_RUN_ACTION     = 1 shl 3;
  GTK_RUN_NO_HOOKS   = 1 shl 4;
type
  PGtkSignalRunType = ^TGtkSignalRunType;
  TGtkSignalRunType = Integer;

{ Scrolling types. }
const
  GTK_SCROLL_NONE          = 0;
  GTK_SCROLL_STEP_BACKWARD = 1;
  GTK_SCROLL_STEP_FORWARD  = 2;
  GTK_SCROLL_PAGE_BACKWARD = 3;
  GTK_SCROLL_PAGE_FORWARD  = 4;
  GTK_SCROLL_JUMP          = 5;
type
  PGtkScrollType = ^TGtkScrollType;
  TGtkScrollType = Integer;

{ List selection modes. }
const
  GTK_SELECTION_SINGLE   = 0;
  GTK_SELECTION_BROWSE   = 1;
  GTK_SELECTION_MULTIPLE = 2;
  GTK_SELECTION_EXTENDED = 3;
type
  PGtkSelectionMode = ^TGtkSelectionMode;
  TGtkSelectionMode = Integer;

{ Shadow types. }
const
  GTK_SHADOW_NONE       = 0;
  GTK_SHADOW_IN         = 1;
  GTK_SHADOW_OUT        = 2;
  GTK_SHADOW_ETCHED_IN  = 3;
  GTK_SHADOW_ETCHED_OUT = 4;
type
  PGtkShadowType = ^TGtkShadowType;
  TGtkShadowType = Integer;

{ Widget states. }
const
  GTK_STATE_NORMAL      = 0;
  GTK_STATE_ACTIVE      = 1;
  GTK_STATE_PRELIGHT    = 2;
  GTK_STATE_SELECTED    = 3;
  GTK_STATE_INSENSITIVE = 4;
type
  PGtkStateType = ^TGtkStateType;
  TGtkStateType = Integer;

{ Directions for submenus. }
const
  GTK_DIRECTION_LEFT  = 0;
  GTK_DIRECTION_RIGHT = 1;
type
  PGtkSubmenuDirection = ^TGtkSubmenuDirection;
  TGtkSubmenuDirection = Integer;

{ Placement of submenus. }
const
  GTK_TOP_BOTTOM = 0;
  GTK_LEFT_RIGHT = 1;
type
  PGtkSubmenuPlacement = ^TGtkSubmenuPlacement;
  TGtkSubmenuPlacement = Integer;

{ Style for toolbars. }
const
  GTK_TOOLBAR_ICONS = 0;
  GTK_TOOLBAR_TEXT  = 1;
  GTK_TOOLBAR_BOTH  = 2;
type
  PGtkToolbarStyle = ^TGtkToolbarStyle;
  TGtkToolbarStyle = Integer;

{ Trough types for GtkRange. }
const
  GTK_TROUGH_NONE  = 0;
  GTK_TROUGH_START = 1;
  GTK_TROUGH_END   = 2;
  GTK_TROUGH_JUMP  = 3;
type
  PGtkTroughType = ^TGtkTroughType;
  TGtkTroughType = Integer;

{ Data update types (for ranges). }
const
  GTK_UPDATE_CONTINUOUS    = 0;
  GTK_UPDATE_DISCONTINUOUS = 1;
  GTK_UPDATE_DELAYED       = 2;
type
  PGtkUpdateType = ^TGtkUpdateType;
  TGtkUpdateType = Integer;

{ Generic visibility flags. }
const
  GTK_VISIBILITY_NONE    = 0;
  GTK_VISIBILITY_PARTIAL = 1;
  GTK_VISIBILITY_FULL    = 2;
type
  PGtkVisibility = ^TGtkVisibility;
  TGtkVisibility = Integer;

{ Window position types. }
const
  GTK_WIN_POS_NONE          = 0;
  GTK_WIN_POS_CENTER        = 1;
  GTK_WIN_POS_MOUSE         = 2;
  GTK_WIN_POS_CENTER_ALWAYS = 3;
type
  PGtkWindowPosition = ^TGtkWindowPosition;
  TGtkWindowPosition = Integer;

{ Window types. }
const
  GTK_WINDOW_TOPLEVEL = 0;
  GTK_WINDOW_DIALOG   = 1;
  GTK_WINDOW_POPUP    = 2;
type
  PGtkWindowType = ^TGtkWindowType;
  TGtkWindowType = Integer;

{ How to sort. }
const
  GTK_SORT_ASCENDING  = 0;
  GTK_SORT_DESCENDING = 1;
type
  PGtkSortType = ^TGtkSortType;
  TGtkSortType = Integer;

implementation

end.
