{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkFileSel;

interface

uses Glib, GtkObject, GtkWidget, GtkWindow;

function GTK_TYPE_FILE_SELECTION : TGtkType;
asmname 'gtk_file_selection_get_type';

function GTK_IS_FILE_SELECTION (Obj : Pointer) : Boolean;
function GTK_IS_FILE_SELECTION_CLASS (Klass : Pointer) : Boolean;

type
  PGtkFileSelectionClass = ^TGtkFileSelectionClass;
  PGtkFileSelection = ^TGtkFileSelection;


  TGtkFileSelectionClass = record
    ParentClass : TGtkWindowClass;
  end;

  TGtkFileSelection = packed record
    Window : TGtkWindow;

    DirList, FileList, SelectionEntry, SelectionText, MainVBox,
    OkButton, CancelButton, HelpButton, HistoryPulldown, HistoryMenu : PGtkWidget;

    HistoryList : PGList;

    FileOpDialog, FileOpEntry : PGtkWidget;
    FileOpFile : PGChar;
    CmplState : GPointer;

    FileOpCDir, FileOPDelFile, FileOpRenFile : PGtkWidget;
    ButtonArea, ActionArea : PGtkWidget;
  end;

function GtkFileSelectionGetType : TGtkType;
asmname 'gtk_file_selection_get_type';

function GtkFileSelectionNew(Title : PGChar) : PGtkWidget;
asmname 'gtk_file_selection_new';

procedure GtkFileSelectionSetFileName(FileSel : PGtkFileSelection; FileName : PGChar);
asmname 'gtk_file_selection_set_filename';

function GtkFileSelectionGetFileName(FileSel : PGtkFileSelection) : PGChar;
asmname 'gtk_file_selection_get_filename';

procedure GtkFileSelectionComplete(FileSel : PGtkFileSelection; Pattern : PGChar);
asmname 'gtk_file_selection_complete';

procedure GtkFileSelectionShowFileOpButtons(FileSel : PGtkFileSelection);
asmname 'gtk_file_selection_show_fileop_buttons';

procedure GtkFileSelectionHideFileOpButtons(FileSel : PGtkFileSelection);
asmname 'gtk_file_selection_hide_fileop_buttons';

implementation

function GTK_IS_FILE_SELECTION (Obj : Pointer) : Boolean;
begin
  GTK_IS_FILE_SELECTION := (Obj <> nil) and GTK_IS_FILE_SELECTION_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_FILE_SELECTION_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_FILE_SELECTION_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_FILE_SELECTION) = G_TRUE);
end;

end.
