{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkFrame;

interface

uses Glib, GtkObject, GtkEnums, GtkBin, GtkWidget;

function GTK_TYPE_FRAME : TGtkType;
asmname 'gtk_frame_get_type';

function GTK_IS_FRAME (Obj : Pointer) : Boolean;
function GTK_IS_FRAME_CLASS (Klass : Pointer) : Boolean;

type
  PGtkFrameClass = ^TGtkFrameClass;
  PGtkFrame      = ^TGtkFrame;

  TGtkFrameClass = record
    ParentClass : TGtkBinClass;
  end;

  TGtkFrame = record
    Bin : TGtkBin;
    Lbl : PGChar;
    ShadowType, LabelWidth, LabelHeigth : Gint16;
    LabelXAlign, LabelYAlign : GFloat;
  end;

function GtkFrameGetType : TGtkType;
asmname 'gtk_frame_get_type';

function GtkFrameNew(Lbl : PGChar) : PGtkWidget;
asmname 'gtk_frame_new';

procedure GtkFrameSetLabel (Frame : PGtkFrame; Lbl : PGChar);
asmname 'gtk_frame_set_label';

procedure GtkFrameSetLabelAlign (Frame : PGtkFrame; xAlign, yAlign : GFloat);
asmname 'gtk_frame_set_label_align';

procedure GtkFrameSetShadowType (Frame : PGtkFrame; ShadowType : TGtkShadowType);
asmname 'gtk_frame_set_shadow_type';

implementation

function GTK_IS_FRAME (Obj : Pointer) : Boolean;
begin
  GTK_IS_FRAME := (Obj <> nil) and GTK_IS_FRAME_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_FRAME_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_FRAME_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_FRAME) = G_TRUE);
end;

end.
