{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkHandleBox;

interface

uses Glib, GdkTypes, GtkBin, GtkEnums, GtkObject, GtkWidget;

function GTK_TYPE_HANDLE_BOX : TGtkType;
asmname 'gtk_handle_box_get_type';

function GTK_IS_HANDLE_BOX (Obj : Pointer) : Boolean;
function GTK_IS_HANDLE_BOX_CLASS (Klass : Pointer) : Boolean;

type
  PGtkHandleBoxClass = ^TGtkHandleBoxClass;
  PGtkHandleBox = ^TGtkHandleBox;

  TGtkHandleBoxClass = record
    ParentClass : TGtkBinClass;

    ChildAttached, ChildDetached : ^procedure(HandleBox : PGtkHandleBox; Child : PGtkWidget);
  end;

  TGtkHandleBoxFrame1 = packed record
    HandlePosition : GUint2;
    FloatWindowMapped, ChildDetached, InDrag, ShrinkOnDetach : GUint1;
    SnapEdge : GInt3; { -1 == unset }
  end;

  TGtkHandleBox = record
    Bin : TGtkBin;

    BinWindow { Parent window for children }, FloatWindow : PGdkWindow;
    ShadowType : TGtkShadowType;

    Frame1 : TGtkHandleBoxFrame1;

    { Variables used during a drag. }
    DeskOffX, DeskOffY : GInt; { Offset between root relative coordinates
                                 and deskrelative coordinates }

    AttachAllocation, FloatAllocation : TGtkAllocation;
  end;

function GtkHandleBoxGetType : TGtkType;
asmname 'gtk_handle_box_get_type';

function GtkHandleBoxNew : PGtkWidget;
asmname 'gtk_handle_box_new';

procedure GtkHandleBoxSetShadowType(HandleBox : PGtkHandleBox; TType : TGtkShadowType);
asmname 'gtk_handle_box_set_shadow_type';

procedure GtkHandleBoxSetHandlePosition(HandleBox : PGtkHandleBox; Position : TGtkPositionType);
asmname 'gtk_handle_box_set_handle_position';

procedure GtkHandleBoxSetSnapEdge(HandleBox : PGtkHandleBox; Edge : TGtkPositionType);
asmname 'gtk_handle_box_set_snap_edge';

implementation

function GTK_IS_HANDLE_BOX (Obj : Pointer) : Boolean;
begin
  GTK_IS_HANDLE_BOX := (Obj <> nil) and GTK_IS_HANDLE_BOX_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_HANDLE_BOX_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_HANDLE_BOX_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_HANDLE_BOX) = G_TRUE);
end;

end.
