{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

Unit GtkItemfactory;

Interface

Uses
  Glib, GdkTypes, GtkAccelGroup, GtkBindings, GtkMenuFactory, GtkObject,
  GtkTypeUtils, GtkWidget;

Function GTK_TYPE_ITEM_FACTORY : TGtkType;
  asmname 'gtk_item_factory_get_type';

function GTK_IS_ITEM_FACTORY (Obj : Pointer) : Boolean;
function GTK_IS_ITEM_FACTORY_CLASS (Klass : Pointer) : Boolean;

Type
  TGtkPrintFunc = ^Procedure (data:gpointer; str : PGChar);
  TGtkTranslateFunc = ^Function (path : PGChar; funcData:gpointer):PGChar;
  { !! Note this are pointes, not pointers fo procedures, because those
       can't be casted with Pascal. }
  TGtkItemFactoryCallback = Pointer;
  TGtkItemFactoryCallback1 = Pointer;
                            
  PGtkItemFactory = ^TGtkItemFactory;
  PGtkItemFactoryClass = ^TGtkItemFactoryClass;
  PGtkItemFactoryEntry = ^TGtkItemFactoryEntry;
  PGtkItemFactoryItem = ^TGtkItemFactoryItem;
  
  TGtkItemFactory = Record
    OObject : TGtkObject;
    path : PGChar;
    accelGroup : PGtkAccelGroup;
    widget : PGtkWidget;
    items : PGSList;
    translateFunc : TGtkTranslateFunc;
    translateData : gpointer;
    translateNotify : TGtkDestroyNotify;
  End;
  
  TGtkItemFactoryClass = Record
    ObjectClass : TGtkObjectClass;
    cpairCommentSingle : PGChar;
    itemHt : PGHashTable;
    dummy : gpointer;
  End;

  TGtkItemFactoryEntry = Record
    path, accelerator : PGChar;
    callback : TGtkItemFactoryCallback;
    callbackAction : guint;
   { possible values:
   * NULL               -> "<Item>"
   * ""                 -> "<Item>"
   * "<Title>"          -> create a title item
   * "<Item>"           -> create a simple item
   * "<CheckItem>"      -> create a check item
   * "<ToggleItem>"     -> create a toggle item
   * "<RadioItem>"      -> create a radio item
   * <path>             -> path of a radio item to link against
   * "<Separator>"      -> create a separator
   * "<Branch>"         -> create an item to hold sub items
   * "<LastBranch>"     -> create a right justified item to hold sub items
   } 
    itemType : PGChar;
  End;

  TGtkItemFactoryItem = Record
    path : PGChar;
    acceleratorKey, acceleratorMods : guint;
    modified, inPropagation : guint1;
    dummy : PGChar;
    widgets : PGSList;
  End;

Function GtkItemfactoryGetType : TGtkType;
  asmname 'gtk_item_factory_get_type';

 { `container_type' must be of GTK_TYPE_MENU_BAR, GTK_TYPE_MENU,
 * or GTK_TYPE_OPTION_MENU.
 } 
Function GtkItemfactoryNew(ct:TGtkType; path:PGChar; accel:PGtkAccelGroup)
                            : PGtkItemFactory;
  asmname 'gtk_item_factory_new';
Procedure GtkItemfactoryConstruct(i:PGtkItemFactory; t:TGtkType;
                            path:PGChar; accel:PGtkAccelGroup);
  asmname 'gtk_item_factory_construct';
     
 { These functions operate on GtkItemFactoryClass basis.
 } 
Procedure GtkItemfactoryParseRc(filename:PGChar);
  asmname 'gtk_item_factory_parse_rc';
Procedure GtkItemfactoryParseRcString(rcs:PGChar);
  asmname 'gtk_item_factory_parse_rc_string';
Procedure GtkItemfactoryParseRcScanner(s:PGScanner);
  asmname 'gtk_item_factory_parse_rc_scanner';
Procedure GtkItemfactoryAddForeign(accel:PGtkWidget; path:PGChar;
                            accelGroup:PGtkAccelGroup; keyval:guint;
                            modifier:GdkModifierType);
  asmname 'gtk_item_factory_add_foreign';
Function GtkItemfactoryFromWidget(w:PGtkWidget):PGtkItemFactory;
  asmname 'gtk_item_factory_from_widget';
Function GtkItemfactoryPathFromWidget(w:PGtkWidget):PGChar;
  asmname 'gtk_item_factory_path_from_widget';
Function GtkItemfactoryGetItem(i:PGtkItemFactory; path:PGChar):PGtkWidget;
  asmname 'gtk_item_factory_get_item';
Function GtkItemfactoryGetWidget(i:PGtkItemFactory; path:PGChar):PGtkWidget;
  asmname 'gtk_item_factory_get_widget';
Function GtkItemfactoryGetWidgetByAction(i:PGtkItemFactory; action:guint)
                            : PGtkWidget;
  asmname 'gtk_item_factory_get_widget_by_action';
Function GtkItemfactoryGetItemByAction(i:PGtkItemFactory; action:guint)
                            : PGtkWidget;
  asmname 'gtk_item_factory_get_item_by_action';

 { If `path_pspec' is passed as `NULL', this function will iterate over
 * all hash entries. otherwise only those entries will be dumped for which
 * the pattern matches, e.g. "<Image>*...".
 } 
Procedure GtkItemfactoryDumpItems(pathPSpec:TGtkPatternSpec;
                            modifierOnly:gboolean; printFunc:TGtkPrintFunc;
                            data:gpointer);
  asmname 'gtk_item_factory_dump_items';
Procedure GtkItemfactoryDumpRc(filename:PGChar; pathPSpec:PGtkPatternSpec;
                            modifiedOnly:gboolean);
  asmname 'gtk_item_factory_dump_rc';
Procedure GtkItemfactoryPrintFunc(FilePointer:gpointer; s:PGChar);
  asmname 'gtk_item_factory_print_func';
Procedure GtkItemfactoryCreateItem(i:PGtkItemFactory;
                            e:PGtkItemFactoryEntry; cb:gpointer; typee:guint);
  asmname 'gtk_item_factory_create_item';
Procedure GtkItemfactoryCreateItems(i:PGtkItemFactory; num:guint; 
                            e:PGtkItemFactoryEntry; cb:gpointer);
  asmname 'gtk_item_factory_create_items';
Procedure GtkItemfactoryDeleteItem(i:PGtkItemFactory; path:PGChar);
  asmname 'gtk_item_factory_delete_item';
Procedure GtkItemfactoryDeleteEntry(i:PGtkItemFactory; e:PGtkItemFactoryEntry);
  asmname 'gtk_item_factory_delete_entry';
Procedure GtkItemfactoryDeleteEntries(i:PGtkItemFactory; num:guint;
                            e:PGtkItemFactoryEntry);
  asmname 'gtk_item_factory_delete_entries';
Procedure GtkItemfactoryPopup(i:PGtkItemFactory; x,y,MButton,time:guint32);
  asmname 'gtk_item_factory_popup';
Procedure GtkItemfactoryPopupWithData(i:PGtkItemFactory; popup:gpointer;
                            destrooy:TGtkDestroyNotify;
                            x,y,MouseButton,time:guint32);
  asmname 'gtk_item_factory_popup_with_data';
Function GtkItemfactoryPopupData(i:PGtkItemFactory):gpointer;
  asmname 'gtk_item_factory_popup_data';
Function GtkItemfactoryPopupDataFromWidget(w:PGtkWidget):gpointer;
  asmname 'gtk_item_factory_popup_data_from_widget';
Procedure GtkItemfactorySetTranslateFunc(i:PGtkItemFactory; f:TGtkTranslateFunc;
                            data:gpointer; notify:TGtkDestroyNotify);
  asmname 'gtk_item_factory_set_translate_func';

{ Compatibility functions for deprecated GtkMenuFactory code. }

function GtkItemFactoryFromPath(Path : PGChar) : PGtkItemFactory;
asmname 'gtk_item_factory_from_path';

procedure GtkItemFactoryCreateMenuEntrie(NEntries : GUint; Entries : PGtkMenuEntry);
asmname 'gtk_item_factory_create_menu_entries';

procedure GtkItemFactoriesPathDelete(IFactoryPath, Path : PGChar);
asmname 'gtk_item_factories_path_delete';

type
  TGtkItemFactoryCallback2 = ^procedure(Widget : PGtkWidget; CallbackData : GPointer; CallbackAction : GUint);

procedure GtkItemFactoryCreateItemsAC(IFactory : PGtkItemFactory; NEntries : GUint; Entries : TGtkItemFactoryEntry; CallbackData : GPointer; CallbackType : GUint);
asmname 'gtk_item_factory_create_items_ac';

Implementation

function GTK_IS_ITEM_FACTORY (Obj : Pointer) : Boolean;
begin
  GTK_IS_ITEM_FACTORY := (Obj <> nil) and GTK_IS_ITEM_FACTORY_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_ITEM_FACTORY_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_ITEM_FACTORY_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_ITEM_FACTORY) = G_TRUE);
end;

End.
