{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkLabel;

interface

uses Glib, GdkTypes, GtkEnums, GtkMisc, GtkObject, GtkWidget;

function GTK_TYPE_LABEL : TGtkType;
asmname 'gtk_label_get_type';

function GTK_IS_LABEL (Obj : Pointer) : Boolean;
function GTK_IS_LABEL_CLASS (Klass : Pointer) : Boolean;

type
  PGtkLabelWord  = GPointer; { !! Warning. }
  PGtkLabelClass = ^TGtkLabelClass;
  PGtkLabel      = ^TGtkLabel;

  TGtkLabelClass = record
    ParentClass : TGtkMiscClass;
  end;

  TGtkLabel = record
    Misc : TGtkMisc;

    LabelText : PGChar;
    LabelWC : PGdkWChar;
    Pattern : PGChar;
    Words : PGtkLabelWord;

    MaxWidth : GUint16;
    JType : GUint2;

    Wrap : GBoolean;
  end;

function GtkLabelGetType : TGtkType;
asmname 'gtk_label_get_type';

function GtkLabelNew (Str : PGChar) : PGtkWidget;
asmname 'gtk_label_new';

procedure GtkLabelSetText (Lbl : PGtkLabel; Str : PGChar);
asmname 'gtk_label_set_text';

procedure GtkLabelSetJustify (Lbl : PGtkLabel; JType : TGtkJustification);
asmname 'gtk_label_set_justify';

procedure GtkLabelSetPattern (Lbl : PGtkLabel; Pattern : PGChar);
asmname 'gtk_label_set_pattern';

procedure GtkLabelSetLineWrap (Lbl : PGtkLabel; Wrap : GBoolean);
asmname 'gtk_label_set_line_wrap';

procedure GtkLabelGet (Lbl : PGtkLabel; var Str : PGChar);
asmname 'gtk_label_get';

{ Convenience function to set the name and pattern by parsing
  a string with embedded underscores, and return the appropriate
  key symbol for the accelerator. }
function GtkLabelParseULine (Lbl : PGtkLabel; Str : PGChar) : GUint;
asmname 'gtk_label_parse_uline';

implementation

function GTK_IS_LABEL (Obj : Pointer) : Boolean;
begin
  GTK_IS_LABEL := (Obj <> nil) and GTK_IS_LABEL_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_LABEL_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_LABEL_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_LABEL) = G_TRUE);
end;

end.
