{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

Unit GtkLayout;

Interface

Uses
  Glib, GdkTypes, GtkContainer, GtkAdjustment, GtkObject, GtkWidget;

Function GTK_TYPE_LAYOUT : TGtkType;
  asmname 'gtk_layout_get_type';

function GTK_IS_LAYOUT (Obj : Pointer) : Boolean;
function GTK_IS_LAYOUT_CLASS (Klass : Pointer) : Boolean;

Type

  PGtkLayout = ^TGtkLayout;
  PGtkLayoutClass = ^TGtkLayoutClass;
  
  TGtkLayout = Record
    container : TGtkContainer;
    children : PGList;
    width, height : guint;
    xoffset, yoffset : guint;
    hadjustment, vadjustment : PGtkAdjustment;
    binWindow : PGdkWindow;
    visibility : GdkVisibilityState;
    configureSerial : gulong;
    scrollX, scrollY : gint;
    freezeCount : guint;
  End;

  TGtkLayoutClass = Record
    ParentClass : TGtkContainerClass;
    SetScrollAdjustments : ^Procedure(l:PGtkLayout;
                            hadj, vadj: PGtkAdjustment);
  End;

Function GtkLayoutGetType : TGtkType;
  asmname 'gtk_layout_get_type';
Function GtkLayoutNew(h, v: PGtkAdjustment) : PGtkWidget;
  asmname 'gtk_layout_new';
Procedure GtkLayoutPut(l:PGtkLayout; w:PGtkWidget; x,y:gint);
  asmname 'gtk_layout_put';
Procedure GtkLayoutMove(l:PGtkLayout; w:PGtkWidget; x,y:gint);
  asmname 'gtk_layout_move';
Procedure GtkLayoutSetSize(l:PGtkLayout; x,y:gint); 
  asmname 'gtk_layout_set_size';
Function GtkLayoutGetHAdjustment(l:PGtkLayout) : PGtkAdjustment;
  asmname 'gtk_layout_get_hadjustment';
Function GtkLayoutGetVAdjustment(l:PGtkLayout) : PGtkAdjustment;
  asmname 'gtk_layout_get_vadjustment';
Procedure GtkLayoutSetHAdjustment(l:PGtkLayout; a:PGtkAdjustment);
  asmname 'gtk_layout_set_hadjustment';
Procedure GtkLayoutSetVAdjustment(l:PGtkLayout; a:PGtkAdjustment);
  asmname 'gtk_layout_set_vadjustment';

 { These disable and enable moving and repainting the scrolling window
 * of the GtkLayout, respectively.  If you want to update the layout's
 * offsets but do not want it to repaint itself, you should use these
 * functions.
 *
 * - I don't understand these are supposed to work, so I suspect
 * - they don't now.                    OWT 1/20/98
 }
Procedure GtkLayoutFreeze(l:PGtkLayout);
  asmname 'gtk_layout_freeze';
Procedure GtkLayoutThaw(l:PGtkLayout);
  asmname 'gtk_layout_thaw';

Implementation

function GTK_IS_LAYOUT (Obj : Pointer) : Boolean;
begin
  GTK_IS_LAYOUT := (Obj <> nil) and GTK_IS_LAYOUT_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_LAYOUT_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_LAYOUT_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_LAYOUT) = G_TRUE);
end;

End.
