{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

Unit GtkList;

Interface

Uses
  GLib, Gdk, GtkEnums, GtkContainer, GtkListItem, GtkObject,
  GtkWidget;

Function GTK_TYPE_LIST : TGtkType;
  asmname 'gtk_list_get_type';

function GTK_IS_LIST (Obj : Pointer) : Boolean;
function GTK_IS_LIST_CLASS (Klass : Pointer) : Boolean;

Type
  PGtkList = ^TGtkList;
  PGtkListClass = ^TGtkListClass;

  TGtkList = Record
    Container : TGtkContainer;
    children, selection, undo_selection, undo_unselection : PGList;
    last_focus_child, undo_focus_child : PGtkWidget;
    htimer, vtimer : guint;
    anchor, drag_pos : gint;
    anchor_state : TGtkStateType;
    selection_mode : guint2;
    drag_selection : guint1;
    add_mode : guint1;
  End;
  
  TGtkListClass = Record
    ParentClass : TGtkContainerClass;
    selection_changed : ^Procedure (l:PGtkList);
    select_child : ^Procedure (l:PGtkList; child:PGtkWidget);
    unselect_child : ^Procedure (l:PGtkList; child:PGtkWidget);
  End;

Function GtkListGetType : TGtkType;
  asmname 'gtk_list_get_type';
Function GtkListNew : PGtkWidget;
  asmname 'gtk_list_new';
Procedure GtkListInsertItems(l:PGtkList; i:PGtkList; p:gint);
  asmname 'gtk_list_insert_items';
Procedure GtkListAppendItems(l: PGtkList; Items : PGList);
  asmname 'gtk_list_append_items';
Procedure GtkListPrependItems(l : PGtkList; Items : PGList);
  asmname 'gtk_list_prepend_items';
Procedure GtkListRemoveItems(l : PGtkList; Items : PGList);
  asmname 'gtk_list_remove_items';
Procedure GtkListRemoveItemsNoUnref(l : PGtkList; Items : PGList);
  asmname 'gtk_list_remove_items_no_unref';
Procedure GtkListClearItems(l:PGtkList; start, last:gint);
  asmname 'gtk_list_clear_items';
Procedure GtkListSelectItem(l:PGtkList; i:gint);
  asmname 'gtk_list_select_item';
Procedure GtkListUnselectItem(l:PGtkList; i:gint);
  asmname 'gtk_list_unselect_item';
Procedure GtkListSelectChild(l:PGtkList; c:PGtkWidget);
  asmname 'gtk_list_select_child';
Procedure GtkListUnselectChild(l:PGtkList; c:PGtkWidget);
  asmname 'gtk_list_unselect_child';
Function GtkListChildPosition(l:PGtkList; c:PGtkWidget) : gint;
  asmname 'gtk_list_child_position';
Procedure GtkListSetSelectionMode(l:PGtkList; mode:TGtkSelectionMode);
  asmname 'gtk_list_set_selection_mode';
Procedure GtkListExtendSelection(l:PGtkList; scroll:TGtkScrollType;
                            position:gfloat; autostart:gboolean);
  asmname 'gtk_list_extend_selection';
Procedure GtkListStartSelection(l:PGtkList);
  asmname 'gtk_list_start_selection';
Procedure GtkListEndSelection(l:PGtkList);
  asmname 'gtk_list_end_selection';
Procedure GtkListSelectAll(l:PGtkList);
  asmname 'gtk_list_select_all';
Procedure GtkListUnselectAll(l:PGtkList);
  asmname 'gtk_list_unselect_all';
Procedure GtkListScrollHorizontal(l:PGtkList; st:TGtkScrollType;
                            position:gfloat);
  asmname 'gtk_list_scroll_horizontal';
Procedure GtkListScrollVertical(l:PGtkList; st:TGtkScrollType;
                            position:gfloat);
  asmname 'gtk_list_scroll_vertical';
Procedure GtkListToggleAddMode(l:PGtkList);
  asmname 'gtk_list_toggle_add_mode';
Procedure GtkListToggleFocusNow(l:PGtkList);
  asmname 'gtk_list_toggle_focus_row';
Procedure GtkListToggleRow(l:PGtkList; i:PGtkWidget);
  asmname 'gtk_list_toggle_row';
Procedure GtkListUndoSelection(l:PGtkList);
  asmname 'gtk_list_undo_selection';
Procedure GtkListEndDragSelection(l:PGtkList);
  asmname 'gtk_list_end_drag_selection';

Implementation

function GTK_IS_LIST (Obj : Pointer) : Boolean;
begin
  GTK_IS_LIST := (Obj <> nil) and GTK_IS_LIST_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_LIST_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_LIST_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_LIST) = G_TRUE);
end;

End.
