{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkMain;

interface

uses GPC, Glib, GdkTypes, GtkObject, GtkWidget;

{ Priorities for redrawing and resizing. }
const
  GTK_PRIORITY_REDRAW = (G_PRIORITY_HIGH_IDLE + 20);
  GTK_PRIORITY_RESIZE = (G_PRIORITY_HIGH_IDLE + 10);

{ Deprecated. Use G_PRIORITY #define's instead. }
const
  GTK_PRIORITY_HIGH     = G_PRIORITY_HIGH;
  GTK_PRIORITY_INTERNAL = GTK_PRIORITY_REDRAW;
  GTK_PRIORITY_DEFAULT  = G_PRIORITY_DEFAULT_IDLE;
  GTK_PRIORITY_LOW      = G_PRIORITY_LOW;

type
  TGtkModuleInitFunc = ^procedure (Argc : PGInt; Argv : PPPGChar);
  TGtkKeySnoopFunc = ^function (GrabWidget : PGtkWidget; Event : PGdkEventKey; FuncData : GPointer) : GInt;

{ Gtk version. }
var
  GtkMajorVersion : GUint; asmname 'gtk_major_version';
  GtkMinorVersion : GUint; asmname 'gtk_minor_version';
  GtkMicroVersion : GUint; asmname 'gtk_micro_version';
  GtkInterfaceAge : GUint; asmname 'gtk_interface_age';
  GtkBinaryAge    : GUint; asmname 'gtk_binary_age';

function GtkCheckVersion (RequiredMajor, RequiredMinor, RequiredMicro : GUint) : PGChar;
asmname 'gtk_check_version';

{ Initialization, exit, mainloop and miscellaneous routines. }

procedure GtkInit;
function GtkInitCheck : GBoolean;

procedure GtkExit (ErrorCode : GInt);
asmname 'gtk_exit';

function GtkSetLocale : PGChar;
function GtkEventsPending : GInt;

{ The following is the event func GTK+ registers with GDK
  we expose it mainly to allow filtering of events between
  GDK and GTK+. }
procedure GtkMainDoEvent (Event : PGdkEvent);
asmname 'gtk_main_do_event';

procedure GtkMain;
asmname 'gtk_main';

function GtkMainLevel : GUint;
asmname 'gtk_main_level';

procedure GtkMainQuit;
asmname 'gtk_main_quit';

function GtkMainIteration : GInt;
asmname 'gtk_main_iteration';

{ gtk_main_iteration() calls gtk_main_iteration_do(TRUE) }
function GtkMainIterationDo (Blocking : GBoolean) : GInt;
asmname 'gtk_main_iteration_do';

function GtkTrue : GInt;
asmname 'gtk_true';

function GtkFalse : GInt;
asmname 'gtk_false';

procedure GtkGrabAdd (Widget : PGtkWidget);
asmname 'gtk_grab_add';

function GtkGrabGetCurrent : PGtkWidget;
asmname 'gtk_grab_get_current';

procedure GtkGrabRemove (Widget : PGtkWidget);
asmname 'gtk_grab_remove';

procedure GtkInitAdd (Func : TGtkFunction; Data : GPointer);
asmname 'gtk_init_add';

procedure GtkQuitAddDestroy (MainLevel : GUint; Obj : PGtkObject);
asmname 'gtk_quit_add_destroy';

function GtkQuitAdd (MainLevel : GUint; Func : TGtkFunction; Data : GPointer) : GUint;
asmname 'gtk_quit_add';

function GtkQuitAddFull (MainLevel : GUint; Func : TGtkFunction; Marshal : TGtkCallbackMarshal; Data : GPointer; Destroy : TGtkDestroyNotify) : GUint;
asmname 'gtk_quit_add_full';

procedure GtkQuitRemove (QuitHandlerID : GUint);
asmname 'gtk_quit_remove';

procedure GtkQuitRemoveByData (Data : GPointer);
asmname 'gtk_quit_remove_by_data';

function GtkTimeoutAdd (Interval : GUint32; Func : TGtkFunction; Data : GPointer) : GUint;
asmname 'gtk_timeout_add';

function GtkTimeoutAddFull (Interval : GUint32; Func : TGtkFunction; Marshal : TGtkCallbackMarshal; Data : GPointer; Destroy : TGtkDestroyNotify) : GUint;
asmname 'gtk_timeout_add_full';

procedure GtkTimeoutRemove (TimeoutHandlerID : GUint);
asmname 'gtk_timeout_remove';

function GtkIdleAdd (Func : TGtkFunction; Data : GPointer) : GUint;
asmname 'gtk_idle_add';

function GtkIdleAddPriority (Priority : GInt; Func : TGtkFunction; Data : GPointer) : GUint;
asmname 'gtk_idle_add_priority';

function GtkIdleAddFull (Priority : GInt; Func : TGtkFunction; Marshal : TGtkCallbackMarshal; Data : GPointer; Destroy : TGtkDestroyNotify) : GUint;
asmname 'gtk_idle_add_full';

procedure GtkIdleRemove (IdleHandlerID : GUint);
asmname 'gtk_idle_remove';

procedure GtkIdleRemoveByData (Data : GPointer);
asmname 'gtk_idle_remove_by_data';

function GtkInputAddFull (Source : GInt; Condition : GdkInputCondition; Func : GdkInputFunction; Marshal : TGtkCallbackMarshal; Data : GPointer; Destroy : TGtkDestroyNotify) : GUint;
asmname 'gtk_input_add_full';

procedure GtkInputRemove (InputHandlerID : GUint);
asmname 'gtk_input_remove';

function GtkKeySnooperInstall (Snooper : TGtkKeySnoopFunc; FuncData : GPointer) : GUint;
asmname 'gtk_key_snooper_install';

procedure GtkKeySnooperRemove (SnooperHandlerID : GUint);
asmname 'gtk_key_snooper_remove';

function GtkGetCurrentEvent : PGdkEvent;
asmname 'gtk_get_current_event';

function GtkGetEventWidget (Event : PGdkEvent) : PGtkWidget;
asmname 'gtk_get_event_widget';

{ !! Private routines internal to GTK+ not implemented. }

implementation

{$L gtkmainc.c}

procedure GtkInit;
procedure CGtkInit(ArgCount : GInt; ArgVector : PCStrings);
asmname '_p_gtk_init';
begin
  CGtkInit(CParamCount, CParameters);
end;

function GtkInitCheck = B : GBoolean;
function CGtkInitCheck(ArgCount : GInt; ArgVector : PCStrings) : GBoolean;
asmname '_p_gtk_init_check';
begin
  B := CGtkInitCheck(CParamCount, CParameters);
end;

end.
