{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkMenuFactory;

interface

uses Glib, GtkAccelGroup, GtkEnums, GtkWidget;

type
  TGtkMenuCallback = ^procedure (Widget : PGtkWidget; UserData : GPointer);

type
  PGtkMenuEntry = ^TGtkMenuEntry;
  TGtkMenuEntry = record
    Path, Accelerator : PGChar;
    Callback : TGtkMenuCallback;
    CallbackData : GPointer;
    Widget : PGtkWidget;
  end;

type
  PGtkMenuPath = ^TGtkMenuPath;
  TGtkMenuPath = record
    Path : PGChar;
    Widget : PGtkWidget;
  end;

type
  PGtkMenuFactory = ^TGtkMenuFactory;
  TGtkMenuFactory = record
    Path : PGChar;
    TType : TGtkMenuFactoryType;
    AccelGroup : PGtkAccelGroup;
    Widget : PGtkWidget;
    Subfactories : PGList;
  end;

{ Note: the use of GtkMenuFactory is strongly deprecated.
  use GtkItemFactory instead (gtkitemfactory.h and gtkitemfactory.c).
  gtkmenufactory.h and gtkmenufactory.c are sheduled for removal
  in some future gtk versions. }

function GtkMenuFactoryNew(TType : TGtkMenuFactoryType) : PGtkMenuFactory;
asmname 'gtk_menu_factory_new';

procedure GtkMenuFactoryDestroy(Factory : PGtkMenuFactory);
asmname 'gtk_menu_factory_destroy';

procedure GtkMenuFactoryAddEntries(Factory : PGtkMenuFactory; Entries : PGtkMenuEntry; NEntries : Integer);
asmname 'gtk_menu_factory_add_entries';

procedure GtkMenuFactoryAddSubfactory(Factory, Subfactory : PGtkMenuFactory; Path : PGChar);
asmname 'gtk_menu_factory_add_subfactory';

procedure GtkMenuFactoryRemovePaths(Factory : PGtkMenuFactory; Paths : PPGChar; NPaths : Integer);
asmname 'gtk_menu_factory_remove_paths';

procedure GtkMenuFactoryRemoveEntries(Factory : PGtkMenuFactory; Entries : PGtkMenuEntry; NEntries : Integer);
asmname 'gtk_menu_factory_remove_entries';

procedure GtkMenuFactoryRemoveSubfactory(Factory, Subfactory : PGtkMenuFactory; Path : PGChar);
asmname 'gtk_menu_factory_remove_subfactory';

function GtkMenuFactoryFind(Factory : PGtkMenuFactory; Path : PGChar) : PGtkMenuPath;
asmname 'gtk_menu_factory_find';

implementation

end.
