{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkMenuItem;

interface

uses Glib, GtkObject, GtkEnums, GtkItem, GtkWidget;

function GTK_TYPE_MENU_ITEM : TGtkType;
asmname 'gtk_menu_item_get_type';

function GTK_IS_MENU_ITEM (Obj : Pointer) : Boolean;
function GTK_IS_MENU_ITEM_CLASS (Klass : Pointer) : Boolean;

type
  PGtkMenuItemClass = ^TGtkMenuItemClass;
  PGtkMenuItem      = ^TGtkMenuItem;

  TGtkMenuItemClass = record
    ParentClass : TGtkItemClass;
    ToggleSize : GUint;
    { If the following flag is true, then we should always hide
      the menu when the MenuItem is activated. Otherwise, the
      it is up to the caller. For instance, when navigating
      a menu with the keyboard, <Space> doesn't hide, but
      <Return> does. }
    HideOnActivate : GUint1;

    Activate, ActivateItem : ^procedure (MenuItem : PGtkMenuItem);
  end;

  TGtkMenuItemFrame1 = packed record
    ShowToggleIndicator,
    ShowSubmenuIndicator,
    SubmenuPlacement,
    SubmenuDirection,
    RightJustify : GUint1;
  end;

  TGtkMenuItem = record
    Item : TGtkItem;
    Submenu : PGtkWidget;
    AcceleratorSignal : GUint;
    ToggleSize, AcceleratorWidth : GUint16;

    Frame1 : TGtkMenuItemFrame1;

    Timer : GUint;
  end;

function GtkMenuItemGetType : TGtkType;
asmname 'gtk_menu_item_get_type';

function GtkMenuItemNew : PGtkWidget;
asmname 'gtk_menu_item_new';

function GtkMenuItemNewWithLabel (Lbl : PGChar) : PGtkWidget;
asmname 'gtk_menu_item_new_with_label';

procedure GtkMenuItemSetSubmenu (MenuItem : PGtkMenuItem; Submenu : PGtkWidget);
asmname 'gtk_menu_item_set_submenu';

procedure GtkMenuItemRemoveSubmenu (MenuItem : PGtkMenuItem);
asmname 'gtk_menu_item_remove_submenu';

procedure GtkMenuItemSetPlacement (MenuItem : PGtkMenuItem; Placement : TGtkSubmenuPlacement);
asmname 'gtk_menu_item_set_placement';

procedure GtkMenuItemConfigure (MenuItem : PGtkMenuItem; ShowToggleIndicator, ShowSubmenuIndicator : GInt);
asmname 'gtk_menu_item_configure';

procedure GtkMenuItemSelect (MenuItem : PGtkMenuItem);
asmname 'gtk_menu_item_select';

procedure GtkMenuItemDeselect (MenuItem : PGtkMenuItem);
asmname 'gtk_menu_item_deselect';

procedure GtkMenuItemActivate (MenuItem : PGtkMenuItem);
asmname 'gtk_menu_item_activate';

procedure GtkMenuItemRightJustify (MenuItem : PGtkMenuItem);
asmname 'gtk_menu_item_right_justify';

implementation

function GTK_IS_MENU_ITEM (Obj : Pointer) : Boolean;
begin
  GTK_IS_MENU_ITEM := (Obj <> nil) and GTK_IS_MENU_ITEM_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_MENU_ITEM_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_MENU_ITEM_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_MENU_ITEM) = G_TRUE);
end;

end.
