{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkMenuShell;

interface

uses Glib, GtkObject, GtkEnums, GtkContainer, GtkWidget;

function GTK_TYPE_MENU_SHELL : TGtkType;
asmname 'gtk_menu_shell_get_type';

function GTK_IS_MENU_SHELL (Obj : Pointer) : Boolean;
function GTK_IS_MENU_SHELL_CLASS (Klass : Pointer) : Boolean;

type
  PGtkMenuShellClass = ^TGtkMenuShellClass;
  PGtkMenuShell      = ^TGtkMenuShell;

  TGtkMenuShellClass = record
    ParentClass : TGtkContainerClass;
    SubmenuPlacement : GUint1;

    Deactivate, SelectionDone : ^procedure (MenuShell : PGtkMenuShell);
    MoveCurrent : ^procedure (MenuShell : PGtkMenuShell; Direction : TGtkMenuDirectionType);
    ActivateCurrent : ^procedure (MenuShell : PGtkMenuShell; ForceHide : GBoolean);
    Cancel : ^procedure (MenuShell : PGtkMenuShell);
  end;

  TGtkMenuShellFrame1 = packed record
    Active, HaveGrab, HaveXGrab : GUint1;
    Button : GUint2;
    IgnoreLeave, MenuFlag, IgnoreEnter : GUint1;
  end;

  TGtkMenuShell = record
    Container : TGtkContainer;
    Children : PGList;
    ActiveMenuItem, ParentMenuShell : PGtkWidget;

    Frame1 : TGtkMenuShellFrame1;

    ActivateTime : GUint32;
  end;

function GtkMenuShellGetType : TGtkType;
asmname 'gtk_menu_shell_get_type';

procedure GtkMenuShellAppend (MenuShell : PGtkMenuShell; Child : PGtkWidget);
asmname 'gtk_menu_shell_append';

procedure GtkMenuShellPrepend (MenuShell : PGtkMenuShell; Child : PGtkWidget);
asmname 'gtk_menu_shell_prepend';

procedure GtkMenuShellInsert (MenuShell : PGtkMenuShell; Child : PGtkWidget; Position : GInt);
asmname 'gtk_menu_shell_insert';

procedure GtkMenuShellDeactivate (MenuShell : PGtkMenuShell);
asmname 'gtk_menu_shell_deactivate';

procedure GtkMenuShellSelectItem (MenuShell : PGtkMenuShell; MenuItem : PGtkWidget);
asmname 'gtk_menu_shell_select_item';

procedure GtkMenuShellDeselect (MenuShell : PGtkMenuShell);
asmname 'gtk_menu_shell_deselect';

procedure GtkMenuShellActivateItem (MenuShell : PGtkMenuShell; MenuItem : PGtkWidget; ForceDeactivate : GBoolean);
asmname 'gtk_menu_shell_activate_item';

implementation

function GTK_IS_MENU_SHELL (Obj : Pointer) : Boolean;
begin
  GTK_IS_MENU_SHELL := (Obj <> nil) and GTK_IS_MENU_SHELL_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_MENU_SHELL_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_MENU_SHELL_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_MENU_SHELL) = G_TRUE);
end;

end.
