{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

Unit GtkNotebook;
Interface

Uses
  Glib, GdkTypes, GtkContainer, GtkEnums, GtkObject, GtkWidget;

Type
  PGtkNotebook = ^TGtkNotebook;
  PGtkNotebookClass = ^TGtkNotebookClass;
  PGtkNotebookPage = ^TGtkNotebookPage;

  TGtkNotebookFrame1 = packed record
    ShowTabs, Homogeneous, ShowBorder : guint1;
    TabPos : guint2;
    Scrollable : guint1;
    InChild, ClickChild, Button : GUint2;
    NeedTimer, ChildHasFocus, HaveVisibleChild : GUint1;
  end;

  TGtkNotebook  = Record
    Container : TGtkContainer;
    CurPage : PGtkNotebookPage;
    Children, FirstTab, FocusTab : PGList;
    Menu, Panel : PGdkWindow;
    Timer : guint32;
    TabHBorder, TabVBorder : guint16;

    Frame1 : TGtkNotebookFrame1;
  End;

  TGtkNotebookClass = Record
    parentClass : TGtkContainerClass;
    switchPage : ^Procedure (nb : PGtkNotebook;
                            page : PGtkNotebookPage; pageNum : guint);
  End;

  TGtkNotebookPageFrame1 = packed record
    DefaultMenu, DefaultTab, Expand, Fill, Pack : guint1;
  end;

  TGtkNotebookPage = Record
    child, tabLabel, menuLabel : PGtkWidget;
    Frame1 : TGtkNotebookPageFrame1;
    requisition : TGtkRequisition;
    allocation : TGtkAllocation;
  End;

Function GTK_TYPE_NOTEBOOK : TGtkType;
  asmname 'gtk_notebook_get_type';

function GTK_IS_NOTEBOOK (Obj : GPointer) : Boolean;
function GTK_IS_NOTEBOOK_CLASS (Klass : GPointer) : Boolean;
function GTK_NOTEBOOK_PAGE(P : PGList) : PGtkNotebookPage;


 {**********************************************************
 *           Creation, insertion, deletion                 *
 **********************************************************} 
Function GtkNotebookGetType  : TGtkType;
  asmname 'gtk_notebook_get_type';
Function GtkNotebookNew : PGtkWidget;
  asmname 'gtk_notebook_new';
Procedure GtkNotebookAppendPage(nb:PGtkNotebook; c, tblbl: PGtkWidget);
  asmname 'gtk_notebook_append_page';
Procedure GtkNotebookAppendPageMenu(nb:PGtkNotebook; child, 
                            tabLabel, menuLabel:PGtkWidget);
  asmname 'gtk_notebook_append_page_menu';
Procedure GtkNotebookPrependPage(nb:PGtkNotebook; c, tblbl: PGtkWidget);
  asmname 'gtk_notebook_prepend_page';
Procedure GkNotebookPrependPageMenu(nb:PGtkNotebook; child, 
                            tabLabel, menuLabel:PGtkWidget);
  asmname 'gtk_notebook_prepend_page_menu';
Procedure GtkNotebookInsertPage(nb:PGtkNotebook; child, 
                            tabLabel:PGtkWidget; posi:gint);
  asmname 'gtk_notebook_insert_page';
Procedure GtkNotebookInsertPageMenu(nb:PGtkNotebook; child, 
                            tabLabel, menuLabel:PGtkWidget; posi:gint);
  asmname 'gtk_notebook_insert_page_menu';
Procedure GtkNotebookRemovePage(nb:PGtkNotebook; pgNum:gint);
  asmname 'gtk_notebook_remove_page';

 {**********************************************************
 *            query, set current NoteebookPage             *
 **********************************************************} 

Function GtkNotebookGetCurrentPage(nb:PGtkNotebook) : gint;
  asmname 'gtk_notebook_get_current_page';
Function GtkNotebookGetNthPage(nb:PGtkNotebook; pgNum:gint) : PGtkWidget;
  asmname 'gtk_notebook_get_nth_page';
Function GtkNotebookPageNum(nb:PGtkNotebook; c:PGtkWidget): GInt;
  asmname 'gtk_notebook_page_num';
Procedure GtkNotebookSetPage(nb:PGtkNotebook; pgNum:gint);
  asmname 'gtk_notebook_set_page';
Procedure GtkNotebookNextPage(nb:PGtkNotebook);
  asmname 'gtk_notebook_next_page';
Procedure GtkNotebookPrevPage(nb:PGtkNotebook);
  asmname 'gtk_notebook_prev_page';

 {**********************************************************
 *            set Notebook, NotebookTab style              *
 **********************************************************} 

Procedure GtkNotebookSetShowBorder(nb:PGtkNotebook; show:gboolean);
  asmname 'gtk_notebook_set_show_border';
Procedure GtkNotebookSetShowTabs(nb:PGtkNotebook; show:gboolean);
  asmname 'gtk_notebook_set_show_tabs';
Procedure GtkNotebookSetTabPos(nb:PGtkNotebook; p:TGtkPositionType);
  asmname 'gtk_notebook_set_tab_pos';
Procedure GtkNotebookSetHomogeneousTabs(nb:PGtkNotebook; h:gboolean);
  asmname 'gtk_notebook_set_homogeneous_tabs';
Procedure GtkNotebookSetTabBorder(nb:PGtkNotebook; width:guint);
  asmname 'gtk_notebook_set_tab_border';
Procedure GtkNotebookSetTabHBorder(nb:PGtkNotebook; hborder:guint);
  asmname 'gtk_notebook_set_tab_hborder';
Procedure GtkNotebookSetTabVBorder(nb:PGtkNotebook; vborder:guint);
  asmname 'gtk_notebook_set_tab_vborder';
Procedure GtkNotebookSetScrollable(nb:PGtkNotebook; scroll:gboolean);
  asmname 'gtk_notebook_set_scrollable';

 {**********************************************************
 *               enable/disable PopupMenu                  *
 **********************************************************} 

Procedure GtkNotebookPopupEnable(nb:PGtkNotebook);
  asmname 'gtk_notebook_popup_enable';
Procedure GtkNotebookPopupDisable (nb:PGtkNotebook);
  asmname 'gtk_notebook_popup_disable';

 {**********************************************************
 *             query/set NotebookPage Properties           *
 **********************************************************} 

Function GtkNotebookGetTabLabel(nb:PGtkNotebook; c:PGtkWidget) :PGtkWidget;
  asmname 'gtk_notebook_get_tab_label';
Procedure GtkNotebookSetTabLabel(nb:PGtkNotebook; c,l: PGtkWidget);
  asmname 'gtk_notebook_set_tab_label';
Procedure GtkNotebookSetTabLabelText(nb:PGtkNotebook; 
                            c:PGtkWidget; t:PGChar);
  asmname 'gtk_notebook_set_tab_label_text';
Function GtkNotebookGetMenuLabel(nb:PGtkNotebook; c:PGtkWidget):PgtkWidget;
  asmname 'gtk_notebook_get_menu_label';
Procedure GtkNotebookSetMenuLabel(nb:PGtkNotebook; c,ml:PGtkWidget);
  asmname 'gtk_notebook_set_menu_label';
Procedure GtkNotebookSetMenuLabelText(nb:PGtkNotebook; c:PGtkWidget;
                            menuText:PGChar);
  asmname 'gtk_notebook_set_menu_label_text';
Procedure GtkMenuQueryTabLabelPacking(nb:PGtkNotebook; c:PGtkWidget;
                            expand, fill : pgboolean; pt:PGtkPackType);
  asmname 'gtk_notebook_query_tab_label_packing';
Procedure GtkNotebookSetTabLabelPacking(nb:PGtkNotebook; c:PGtkWidget;
                            expand, fill:gboolean; pt:TGtkPackType);
  asmname 'gtk_notebook_set_tab_label_packing';
Procedure GtkNotebookReorderChild(nb:PGtkNotebook; c:PGtkWidget; p:gint);
  asmname 'gtk_notebook_reorder_child';

Implementation

function GTK_NOTEBOOK_PAGE(P : PGList) : PGtkNotebookPage;
begin
  GTK_NOTEBOOK_PAGE := PGtkNotebookPage(P^.Data);
end;

function GTK_IS_NOTEBOOK (Obj : GPointer) : Boolean;
begin
  GTK_IS_NOTEBOOK := (Obj <> nil) and (GTK_IS_NOTEBOOK_CLASS(PGtkTypeObject(Obj)^.Klass));
end;

function GTK_IS_NOTEBOOK_CLASS (Klass : GPointer) : Boolean;
begin
  GTK_IS_NOTEBOOK_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_NOTEBOOK) = G_TRUE);
end;

End.

