{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

Unit GtkPacker;

Interface

Uses
  Glib, GdkTypes, GtkContainer, GtkObject, GtkWidget;

Function GTK_TYPE_PACKER : TGtkType;
  asmname 'gtk_packer_get_type';

function GTK_IS_PACKER (Obj : Pointer) : Boolean;
function GTK_IS_PACKER_CLASS (Klass : Pointer) : Boolean;

Const

  { GtkPackerOptions }
  GTK_PACK_EXPAND = 1;   {< nick=expand >} 
  GTK_FILL_X      = 1 shl 1;
  GTK_FILL_Y      = 1 shl 2;

  { GtkSideType }
  GTK_SIDE_TOP = 0;
  GTK_SIDE_BOTTOM = 1;
  GTK_SIDE_LEFT = 2;
  GTK_SIDE_RIGHT =3;

  { GtkAnchorType }
  
  GTK_ANCHOR_CENTER = 0;
  GTK_ANCHOR_NORTH  = 1;
  GTK_ANCHOR_NORTH_WEST = 2;
  GTK_ANCHOR_NORTH_EAST = 3;
  GTK_ANCHOR_SOUTH  = 4;
  GTK_ANCHOR_SOUTH_WEST = 5;
  GTK_ANCHOR_SOUTH_EAST = 6;
  GTK_ANCHOR_WEST   = 7;
  GTK_ANCHOR_EAST   = 8;
  GTK_ANCHOR_N  =       GTK_ANCHOR_NORTH;
  GTK_ANCHOR_NW =       GTK_ANCHOR_NORTH_WEST;
  GTK_ANCHOR_NE =       GTK_ANCHOR_NORTH_EAST;
  GTK_ANCHOR_S  =       GTK_ANCHOR_SOUTH;
  GTK_ANCHOR_SW =       GTK_ANCHOR_SOUTH_WEST;
  GTK_ANCHOR_SE =       GTK_ANCHOR_SOUTH_EAST;
  GTK_ANCHOR_W  =       GTK_ANCHOR_WEST;
  GTK_ANCHOR_E  =       GTK_ANCHOR_EAST;

Type
  TGtkPackerOptions = Integer;
  TGtkSideType      = Integer;
  TGtkAnchorType    = Integer;
  
  PGtkPacker      = ^TGtkPacker;
  PGtkPackerClass = ^TGtkPackerClass;
  PGtkPackerChild = ^TGtkPackerChild;

  TGtkPackerChild = Record
    widget : PGtkWidget;
    anchor : TGtkAnchorType;
    side : TGtkSideType;
    options : TGtkPackerOptions;
    useDefault : guint1;
    borderWidth, padX, padY, iPadX, iPadY : guint16;
  End;

  TGtkPacker = Record
    Container : TGtkContainer;
    children : PGList;
    spacing : guint;
    defaultBorderWidth, defaultPadX, defaultPadY, defaultIPadX,
      defaultIPadY : guint16;
  End;

  TGtkPackerClass = record
    ParentClass : TGtkContainerClass;
  End;

Function GtkPackerGetType : TGtkType;
  asmname 'gtk_packer_get_type';
Function GtkPackerNew : PGtkWidget;
  asmname 'gtk_packer_new';
Procedure GtkPackerAddDefaults(p:PGtkPacker; c:PGtkWidget;
                            side:TGtkSideType; anchor:TGtkAnchorType;
                            opts:TGtkPackerOptions);
  asmname 'gtk_packer_add_defaults';
Procedure GtkPackerAdd(p:PGtkPacker; c:PGtkWidget;
                            side:TGtkSideType; anchor:TGtkAnchorType;
                            opts:TGtkPackerOptions; bwidth, padx, pady,
                            ipadx, ipady : guint);
  asmname 'gtk_packer_add';
Procedure GtkPackerSetChildPacking(p:PGtkPacker; c:PGtkWidget;
                            side:TGtkSideType; anchor:TGtkAnchorType;
                            opts:TGtkPackerOptions; bwidth, padx, pady,
                            ipadx, ipady : guint);
  asmname 'gtk_packer_set_child_packing';
Procedure GtkPackerReorderChild(p:PGtkPacker; w:PGtkWidget; pos:gint);
  asmname 'gtk_packer_reorder_child';
Procedure GtkPackerSetSpacing(p:PGtkPacker; spacing:guint);
  asmname 'gtk_packer_set_spacing';
Procedure GtkPackerSetDefaultBorderWidth(p:PGtkPacker; bw:guint);
  asmname 'gtk_packer_set_default_border_width';
Procedure GtkPackerSetDefaultPad(p:PGtkPacker; padx, pady:guint);
  asmname 'gtk_packer_set_default_pad';
Procedure GtkPackerSetDefaultIPad(p:PGtkPacker; ipadx, ipady:guint);
  asmname 'gtk_packer_set_default_ipad';


Implementation

function GTK_IS_PACKER (Obj : Pointer) : Boolean;
begin
  GTK_IS_PACKER := (Obj <> nil) and GTK_IS_PACKER_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_PACKER_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_PACKER_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_PACKER) = G_TRUE);
end;

End.
