{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

Unit GtkPaned;

Interface

uses Glib, GdkTypes, GtkContainer, GtkObject, GtkWidget;

function GTK_TYPE_PANED : TGtkType;
asmname 'gtk_paned_get_type';

function GTK_IS_PANED (Obj : Pointer) : Boolean;
function GTK_IS_PANED_CLASS (Klass : Pointer) : Boolean;

Type
  PGtkPaned = ^TGtkPaned;
  PGtkPanedClass = ^TGtkPanedClass;
  
  TGtkPanedFrame1 = packed record
    Child1Size, LastAllocation, MinPosition, MaxPosition : GInt;

    PositionSet, InDrag, Child1Shrink, Child1Resize, Child2Shrink,
    Child2Resize : GUint1;

    HandleXPos, HandleYPos : GInt16;
  end;

  TGtkPaned = Record
    Container : TGtkContainer;
    Child1, Child2 : PGtkWidget;
    Handle : PGdkWindow;
    GrooveRectangle : GdkRectangle;
    XorGC : PGdkGC;

    {< public >}
    HandleSize, GutterSize : guint16;

    {< private >}
    Frame1 : TGtkPanedFrame1;
  End;

  TGtkPanedClass = Record
    ParentClass : TGtkContainerClass;
  End;
  
Function GtkPanedGetType : TGtkType;
  asmname 'gtk_paned_get_type';
Procedure GtkPanedAdd1(p:PGtkPaned; c:PGtkWidget);
  asmname 'gtk_paned_add1';
Procedure GtkPanedAdd2(p:PGtkPaned; c:PgtkWidget);
  asmname 'gtk_paned_add2';
Procedure GtkPanedPack1(p:PgtkPaned; c:PGtkWidget; resize,shrink:gboolean);
  asmname 'gtk_paned_pack1';
Procedure GtkPanedPack2(p:PGtkPaned; c:PgtkWidget; resize,shrink:gboolean);
  asmname 'gtk_paned_pack2';
Procedure GtkPanedSetPosition(p:PGtkPaned; posi:gint);
  asmname 'gtk_paned_set_position';
Procedure GtkPanedSetHandleSize(p:PGtkPaned; s:guint16);
  asmname 'gtk_paned_set_handle_size';
Procedure GtkPanedSetGutterSize(p:PGtkPaned; s:guint16);
  asmname 'gtk_paned_set_gutter_size';

{ !! Internal functions not implemented. }

implementation

function GTK_IS_PANED (Obj : Pointer) : Boolean;
begin
  GTK_IS_PANED := (Obj <> nil) and GTK_IS_PANED_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_PANED_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_PANED_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_PANED) = G_TRUE);
end;

end.
