{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

Unit GtkPreview;

Interface

Uses
  Glib, Gdk, GdkTypes, GtkEnums, GtkObject, GtkWidget;

Function GTK_TYPE_PREVIEW : TGtkType;
  asmname 'gtk_preview_get_type';

function GTK_IS_PREVIEW (Obj : Pointer) : Boolean;
function GTK_IS_PREVIEW_CLASS (Klass : Pointer) : Boolean;

Type
  PGtkPreview = ^TGtkPreview;
  PGtkPreviewInfo = ^TGtkPreviewInfo;
  PGtkDitherInfo = ^TGtkDitherInfo;
  PGtkPreviewClass = ^TGtkPreviewClass;
  
  TGtkPreview = Record
    Widget : TGtkWidget;
    Buffer : PGChar;
    BufferWidth, BufferHeight : guint16;
    Bpp, RowStride : guint16;
    Dither : GdkRgbDither;
    TType, Expand : guint1;
  End;

  TGtkPreviewInfo = Record
    Visual : PGdkVisual;
    CMap : PGdkColormap;
    Lookup : pguchar;
    Gamma : gdouble;
  End;

  dit1Array = array [0..1] of gushort;
  dit2Array = array [0..3] of guchar;

  TGtkDitherInfo = Record
    Case longint of
      1: (s:dit1Array);
      2: (c:dit2Array);
  End;

  TGtkPreviewClass = Record
    ParentClass : TGtkWidgetClass;
    Info : TGtkPreviewInfo;
  End;

Function GtkPreviewGetType : TGtkType;
  asmname 'gtk_preview_get_type';
Procedure GtkPreviewUninit;
  asmname 'gtk_preview_uninit';
Function GtkPreviewNew(pt:TGtkPreviewType):PGtkWidget;
  asmname 'gtk_preview_new';
Procedure GtkPreviewSize(p:PGtkPreview; w,h:gint);
  asmname 'gtk_preview_size';
Procedure GtkPreviewGet(p:PGtkPreview; win:PGdkWindow; gc:PGdkGC; srcx,
                            srcy, destx, desty, w,h : gint);
  asmname 'gtk_preview_put';
Procedure GtkPreviewDrawRow(p:PGtkPreview; data:pguchar; x,y,w:gint);
  asmname 'gtk_preview_draw_row';
Procedure GtkPreviewSetExpand(p:PGtkPreview; expand:gboolean);
  asmname 'gtk_preview_set_expand';
Procedure GtkPreviewSetGamma(gamma:double);
  asmname 'gtk_preview_set_gamma';
Procedure GtkPreviewSetColorCube(nred,ngreen,nblue,ngray:guint);
  asmname 'gtk_preview_set_color_cube';
Procedure GtkPreviewSetInstallCMap(inst:gint);
  asmname 'gtk_preview_set_install_cmap';
Procedure GtkPreviewSetReserved(nreserved:gint);
  asmname 'gtk_preview_set_reserved';
Procedure GtkPreviewSetDither(p:PGtkPreview; dither:GdkRgbDither);
  asmname 'gtk_preview_set_dither';
Function GtkPreviewGetVisual : PGdkVisual;
  asmname 'gtk_preview_get_visual';
Function GtkPreviewGetCMap : PGdkColormap;
  asmname 'gtk_preview_get_cmap';
Function GtkPreviewGetInfo : PGtkPreviewInfo;
  asmname 'gtk_preview_get_info';

 { This function reinitializes the preview colormap and visual from
 * the current gamma/color_cube/install_cmap settings. It must only
 * be called if there are no previews or users's of the preview
 * colormap in existence.
 } 
Procedure GtkPreviewReset;
  asmname 'gtk_preview_reset';

Implementation

function GTK_IS_PREVIEW (Obj : Pointer) : Boolean;
begin
  GTK_IS_PREVIEW := (Obj <> nil) and GTK_IS_PREVIEW_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_PREVIEW_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_PREVIEW_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_PREVIEW) = G_TRUE);
end;

End.


