{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkProgress;

interface

uses Glib, GdkTypes, GtkObject, GtkAdjustment, GtkWidget;

function GTK_TYPE_PROGRESS : TGtkType;
asmname 'gtk_progress_get_type';

function GTK_IS_PROGRESS (Obj : Pointer) : Boolean;
function GTK_IS_PROGRESS_CLASS (Klass : Pointer) : Boolean;

type
  PGtkProgressClass = ^TGtkProgressClass;
  PGtkProgress      = ^TGtkProgress;

  TGtkProgressClass = record
    ParentClass : TGtkWidgetClass;

    Paint, Update, ActModeEnter : ^procedure (Progress : PGtkProgress);
  end;

  TGtkProgress = record
    Widget : TGtkWidget;
    Adjustment : PGtkAdjustment;
    OffscreenPixmap : GdkPixmap;
    Format : GChar;
    xAlign, yAlign : GFloat;

    ShowText, ActivityMode : GUint1;
  end;

function GtkProgressGetType : TGtkType;
asmname 'gtk_progress_get_type';

procedure GtkProgressSetShowText (Progress : PGtkProgress; ShowText : GInt);
asmname 'gtk_progress_set_show_text';

procedure GtkProgressSetTextAlignment (Progress : PGtkProgress; xAlign, yAlign : GFloat);
asmname 'gtk_progress_set_text_alignment';

procedure GtkProgressSetFormatString (Progress : PGtkProgress; Format : PGChar);
asmname 'gtk_progress_set_format_string';

procedure GtkProgressSetAdjustment (Progress : PGtkProgress; Adjustment : PGtkAdjustment);
asmname 'gtk_progress_set_adjustment';

procedure GtkProgressConfigure (Progress : PGtkProgress; PValue, Min, Max : GFloat);
asmname 'gtk_progress_configure';

procedure GtkProgressSetPercentage (Progress : PGtkProgress; Percentage : GFloat);
asmname 'gtk_progress_set_percentage';

procedure GtkProgressSetValue (Progress : PGtkProgress; PValue : GFloat);
asmname 'gtk_progress_set_value';

function GtkProgressGetValue (Progress : PGtkProgress) : GFloat;
asmname 'gtk_progress_get_value';

procedure GtkProgressSetActivityMode (Progress : PGtkProgress; ActivityMode : GUint);
asmname 'gtk_progress_set_activity_mode';

function GtkProgressGetCurrentText (Progress : PGtkProgress) : PGChar;
asmname 'gtk_progress_get_current_text';

function GtkProgressGetTextFromValue (Progress : PGtkProgress; PValue : GFloat) : PGChar;
asmname 'gtk_progress_get_text_from_value';

function GtkProgressGetCurrentPercentage (Progress : PGtkProgress) : GFloat;
asmname 'gtk_progress_get_current_percentage';

function GtkProgressGetCurrentPercentageFromValue (Progress : PGtkProgress; PValue : GFloat) : GFloat;
asmname 'gtk_progress_get_current_percentage_from_value';

implementation

function GTK_IS_PROGRESS (Obj : Pointer) : Boolean;
begin
  GTK_IS_PROGRESS := (Obj <> nil) and GTK_IS_PROGRESS_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_PROGRESS_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_PROGRESS_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_PROGRESS) = G_TRUE);
end;

end.
