{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkProgressBar;

interface

uses Glib, GtkObject, GtkProgress, GtkAdjustment, GtkWidget;

function GTK_TYPE_PROGRESS_BAR : TGtkType;
asmname 'gtk_progress_bar_get_type';

function GTK_IS_PROGRESS_BAR (Obj : Pointer) : Boolean;
function GTK_IS_PROGRESS_BAR_CLASS (Klass : Pointer) : Boolean;

const
  GTK_PROGRESS_CONTINUOUS = 0;
  GTK_PROGRESS_DISCRETE   = 1;
type
  PGtkProgressBarStyle = ^TGtkProgressBarStyle;
  TGtkProgressBarStyle = Integer;

const
  GTK_PROGRESS_LEFT_TO_RIGHT = 0;
  GTK_PROGRESS_RIGHT_TO_LEFT = 1;
  GTK_PROGRESS_BOTTOM_TO_TOP = 2;
  GTK_PROGRESS_TOP_TO_BOTTOM = 3;
type
  PGtkProgressBarOrientation = ^TGtkProgressBarOrientation;
  TGtkProgressBarOrientation = Integer;

type
  PGtkProgressBarClass = ^TGtkProgressBarClass;
  PGtkProgressBar      = ^TGtkProgressBar;

  TGtkProgressBarClass = record
     ParentClass : TGtkProgressClass;
  end;

  TGtkProgressBar = record
    Progress : TGtkProgress;

    BarStyle : TGtkProgressBarStyle;
    Orientation : TGtkProgressBarOrientation;

    Blocks : GUint;
    InBlock : GInt;
    ActivityPos : GInt;
    ActivityStep : GUint;
    ActivityBlocks : GUint;
    ActivityDir : GUint1;
  end;

function GtkProgressBarGetType : TGtkType;
asmname 'gtk_progress_bar_get_type';

function GtkProgressBarNew : PGtkWidget;
asmname 'gtk_progress_bar_new';

function GtkProgressBarNewWithAdjustment (Adjustment : PGtkAdjustment) : PGtkWidget;
asmname 'gtk_progress_bar_new_with_adjustment';

procedure GtkProgressBarSetBarStyle (PBar : PGtkProgressBar; Style : TGtkProgressBarStyle);
asmname 'gtk_progress_bar_set_bar_style';

procedure GtkProgressBarSetDiscreteBlocks (PBar : PGtkProgressBar; Blocks : GUint);
asmname 'gtk_progress_bar_set_discrete_blocks';

procedure GtkProgressBarSetActivityStep (PBar : PGtkProgressBar; Step : GUint);
asmname 'gtk_progress_bar_set_activity_step';

procedure GtkProgressBarSetActivityBlocks (PBar : PGtkProgressBar; Step : GUint);
asmname 'gtk_progress_bar_set_activity_blocks';

procedure GtkProgressBarSetOrientation (PBar : PGtkProgressBar; Orientation : TGtkProgressBarOrientation);
asmname 'gtk_progress_bar_set_orientation';

procedure GtkProgressBarUpdate (PBar : PGtkProgressBar; Percentage : GFloat);
asmname 'gtk_progress_bar_update';

implementation

function GTK_IS_PROGRESS_BAR (Obj : Pointer) : Boolean;
begin
  GTK_IS_PROGRESS_BAR := (Obj <> nil) and GTK_IS_PROGRESS_BAR_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_PROGRESS_BAR_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_PROGRESS_BAR_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_PROGRESS_BAR) = G_TRUE);
end;

end.
