{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

Unit GtkRadioMenuItem;

Interface

uses Glib, GdkTypes, GtkCheckMenuItem, GtkObject, GtkWidget;

function GTK_TYPE_RADIO_MENU_ITEM : TGtkType;
asmname 'gtk_radio_menu_item_get_type';

function GTK_IS_RADIO_MENU_ITEM (Obj : Pointer) : Boolean;
function GTK_IS_RADIO_MENU_ITEM_CLASS (Klass : Pointer) : Boolean;

Type

  PGtkRadioMenuItem = ^TGtkRadioMenuItem;
  PGtkRadioMenuItemClass = ^TGtkRadioMenuItemClass;
  
  TGtkRadioMenuItem = Record
    CheckMenuItem : TGtkCheckMenuItem;
    Group : PGSList;
  End;

  TGtkRadioMenuItemClass = Record
    parentClass : TGtkCheckMenuItemClass;
  End;
  
Function GtkRadioMenuItemGetType : TGtkType;
asmname 'gtk_radio_menu_item_get_type';

Function GtkRadioMenuItemNew(group:PGSList) : PGtkWidget;
asmname 'gtk_radio_menu_item_new';

Function GtkRadioMenuItemNewWithLabel(Group:PGSList; llabel:PGChar):PGtkWidget;
asmname 'gtk_radio_menu_item_new_with_label';

Function GtkRadioMenuItemGroup(RadioMenuItem : PGtkRadioMenuItem) : PGSList;
asmname 'gtk_radio_menu_item_group';

Procedure GtkRadioMenuItemSetGroup(RadioMenuItem : PGtkRadioMenuItem; Group : PGSList);
asmname 'gtk_radio_menu_item_set_group';

Implementation

function GTK_IS_RADIO_MENU_ITEM (Obj : Pointer) : Boolean;
begin
  GTK_IS_RADIO_MENU_ITEM := (Obj <> nil) and GTK_IS_RADIO_MENU_ITEM_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_RADIO_MENU_ITEM_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_RADIO_MENU_ITEM_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_RADIO_MENU_ITEM) = G_TRUE);
end;

End.
