{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkRC;

interface

uses Glib, GdkTypes, GtkThemes, GtkWidget;

{ !! Exported type definitions to solve interdependencies. }

procedure GtkRcInit;
asmname 'gtk_rc_init';

procedure GtkRcAddDefaultFile (FileName : PGChar);
asmname 'gtk_rc_add_default_file';

procedure GtkRcSetDefaultFiles (FileNames : PPGChar);
asmname 'gtk_rc_set_default_files';

function GtkRcGetDefaultFiles : PPGChar;
asmname 'gtk_rc_get_default_files';

procedure GtkRcParse (FileName : PGChar);
asmname 'gtk_rc_parse';

procedure GtkRcParseString (RcString : PGChar);
asmname 'gtk_rc_parse_string';

function GtkRcReparseAll : GBoolean;
asmname 'gtk_rc_reparse_all';

function GtkRcGetStyle (Widget : PGtkWidget) : PGtkStyle;
asmname 'gtk_rc_get_style';

procedure GtkRcAddWidgetNameStyle (RcStyle : PGtkRcStyle; Pattern : PGChar);
asmname 'gtk_rc_add_widget_name_style';

procedure GtkRcAddWidgetClassStyle (RcStyle : PGtkRcStyle; Pattern : PGChar);
asmname 'gtk_rc_add_widget_class_style';

procedure GtkRcAddClassStyle (RcStyle : PGtkRcStyle; Pattern : PGChar);
asmname 'gtk_rc_add_class_style';

function GtkRcStyleNew : PGtkRcStyle;
asmname 'gtk_rc_style_new';

procedure GtkRcStyleRef (RcStyle : PGtkRcStyle);
asmname 'gtk_rc_style_ref';

procedure GtkRcStyleUnref (RcStyle : PGtkRcStyle);
asmname 'gtk_rc_style_unref';

{ Tell gtkrc to use a custom routine to load images specified in rc
  files instead of the default xpm-only loader. }
type
  TGtkImageLoader = ^function (Window : PGdkWindow; Colormap : PGdkColormap; Mask : PPGdkBitmap; TransparentColor : PGdkColor; FileName : PGChar) : PGdkPixmap;

procedure GtkRcSetImageLoader (Loader : TGtkImageLoader);
asmname 'gtk_rc_set_image_loader';

function GtkRcLoadImage (Colormap : PGdkColormap; TransparentColor : PGdkColor; FileName : PGChar) : PGdkPixmap;
asmname 'gtk_rc_load_image';

function GtkRcFindPixmapInPath (Scanner : PGScanner; PixmapFile : PGChar) : PGChar;
asmname 'gtk_rc_find_pixmap_in_path';

function GtkRcFindModuleInPath (ModuleFile : PGChar) : PGChar;
asmname 'gtk_rc_find_module_in_path';

function GtkRcGetThemeDir : PGchar;
asmname 'gtk_rc_get_theme_dir';

function GtkRcGetModuleDir : PGChar;
asmname 'gtk_rc_get_module_dir';

{ !! Private functions/definitions skipped. }

implementation

end.
