{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

Unit GtkRuler;

Interface

uses Glib, GdkTypes, GtkEnums, GtkObject, GtkWidget;

function GTK_TYPE_RULER : TGtkType;
asmname 'gtk_ruler_get_type';

function GTK_IS_RULER (Obj : Pointer) : Boolean;
function GTK_IS_RULER_CLASS (Klass : Pointer) : Boolean;

Type
  PGtkRuler = ^TGtkRuler;
  PGtkRulerClass = ^TGtkRulerClass;
  PGtkRulerMetric = ^TGtkRulerMetric;
  
  { All distances below are in 1/72nd's of an inch. (According to
    Adobe that's a point, but points are really 1/72.27 in.) }
  
  TGtkRuler = Record
    Widget : TGtkWidget;
    backingStore : PGdkPixmap;
    nonGrExpGc : PGdkGC;
    metric : PGtkRulerMetric;
    xsrc, ysrc, sliderSize : gint;
    
    { The upper limit of the ruler (in points) } 
    lower : gfloat;
    
    { The lower limit of the ruler } 
    upper : gfloat;
    
    { The position of the mark on the ruler } 
    position : gfloat;
    
    { The maximum size of the ruler } 
    maxSize : gfloat;
  End;

  TGtkRulerClass = Record
    ParentClass : TGtkWidgetClass;
    DrawTicks : ^Procedure (r:PGtkRuler);
    DrawPos :  ^Procedure (r:PGtkRuler);
  End;
  
  gfaArray=array[0..9] of gfloat;
  giaArray=array[0..4] of gint;
  
  TGtkRulerMetric = Record
    metricName, abbrev : PGChar;
    
    { This should be points_per_unit. This is the size of the unit
    * in 1/72nd's of an inch and has nothing to do with screen pixels } 
    pixels_per_unit : gfloat;
    
    rulerScale : gfaArray;
    subdivide : giaArray;         { five possible modes of subdivision }
  End;

function GtkRulerGetType : TGtkType;
  asmname 'gtk_ruler_get_type';
Procedure GtkRulerSetMetric (r:PGtkRuler; m:TGtkMetricType);
  asmname 'gtk_ruler_set_metric';
Procedure GtkRulerSetRange(r:PGtkRuler; lower,upper,posi,maxSize:gfloat);
  asmname 'gtk_ruler_set_range';
Procedure GtkRulerDrawTicks(r:PGtkRuler);
  asmname 'gtk_ruler_draw_ticks';
Procedure GtkRulerDrawPos(r:PGtkRuler);
  asmname 'gtk_ruler_draw_pos';

Implementation

function GTK_IS_RULER (Obj : Pointer) : Boolean;
begin
  GTK_IS_RULER := (Obj <> nil) and GTK_IS_RULER_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_RULER_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_RULER_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_RULER) = G_TRUE);
end;

End.




