{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

Unit GtkScrolledWindow;

Interface

Uses
  Glib, GdkTypes, GtkAdjustment, GtkBin, GtkEnums, GtkHScrollbar,
  GtkVScrollbar, GtkViewPort, GtkObject, GtkWidget;
  
Function GTK_TYPE_SCROLLED_WINDOW : TGtkType;
asmname 'gtk_scrolled_window_get_type';

function GTK_IS_SCROLLED_WINDOW (Obj : Pointer) : Boolean;
function GTK_IS_SCROLLED_WINDOW_CLASS (Klass : Pointer) : Boolean;

Type

  PGtkScrolledWindow = ^TGtkScrolledWindow;
  PGtkScrolledWindowClass = ^TGtkScrolledWindowClass;
  
  TGtkScrolledWindowFrame1 = packed record
    HScrollbarPolicy, VScrollbarPolicy : guint2;
    HScrollbarVisible, VScrollbarVisible : guint1;
    WindowPlacement : guint2;
  end;

  TGtkScrolledWindow = Record
    Container : TGtkBin;
    HScrollbar, VScrollbar : PGtkWidget;

    Frame1 : TGtkScrolledWindowFrame1;
  End;

  TGtkScrolledWindowClass = Record
    ParentClass : TGtkBinClass;
    ScrollbarSpacing : gint;
  End;

Function GtkScrolledWindowGetType : TGtkType;
asmname 'gtk_scrolled_window_get_type';

Function GtkScrolledWindowNew(hAdjust, vAdjust:PGtkAdjustment) : PGtkWidget;
asmname 'gtk_scrolled_window_new';

Procedure GtkScrolledWindowSetHAdjustment(scrolled_window :
                          PGtkScrolledWindow; hadjustment : PGtkAdjustment);
asmname 'gtk_scrolled_window_set_hadjustment';

Procedure GtkScrolledwindowSetVAdjustment(ScrolledWindow : PGtkScrolledWindow; VAdjustment : PGtkAdjustment);
asmname 'gtk_scrolled_window_set_vadjustment';

Function GtkScrollesWindowGetHAdjustment(scrollWindow:PGtkScrolledWindow) : PGtkAdjustment;
asmname 'gtk_scrolled_window_get_hadjustment';

Function GtkScrollesWindowGetVAdjustment(scrollWindow:PGtkScrolledWindow) : PGtkAdjustment;
asmname 'gtk_scrolled_window_get_vadjustment';

Procedure GtkScrolledWindowSetPolicy(scrolled_window : PGtkScrolledWindow;
                          hscrollbarPolicy,vscrollbarPolicy : TGtkPolicyType);
asmname 'gtk_scrolled_window_set_policy';

Procedure GtkScrolledWindowSetPlacement(scrolledWindow : PGtkScrolledWindow;
                          windowPlacement : TGtkCornerType);
asmname 'gtk_scrolled_window_set_placement';

Procedure GtkScrolledWindowAddWithViewport(scrolledWindow
                          : PGtkScrolledWindow;child : PGtkWidget);
asmname 'gtk_scrolled_window_add_with_viewport';
 
Implementation

function GTK_IS_SCROLLED_WINDOW (Obj : Pointer) : Boolean;
begin
  GTK_IS_SCROLLED_WINDOW := (Obj <> nil) and GTK_IS_SCROLLED_WINDOW_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_SCROLLED_WINDOW_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_SCROLLED_WINDOW_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_SCROLLED_WINDOW) = G_TRUE);
end;

End.



