{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

Unit GtkSelection;

Interface

Uses
  Glib, GdkTypes, GtkEnums, GtkWidget;
  

Type
  PGtkTargetList = ^TGtkTargetList;
  PGtkTargetEntry = ^TGtkTargetEntry;
  PGtkTargetPair = ^TGtkTargetPair;
  
  TGtkTargetEntry = Record
    target : PGChar;
    flags, info : guint;
  End;

 { These structures not public, and are here only for the convenience of gtkdnd.c }

 { This structure is a list of destinations, and associated guint id's }
  TGtkTargetList = Record
    list : PGList; 
    refCount : guint;
  End;

  TGtkTargetPair = Record
    target : GdkAtom;
    flags, info : guint;
  End;

Function GtkTargetListNew(targets:PGtkTargetEntry; ntargets:guint):PGtkTargetList;
asmname 'gtk_target_list_new';

Procedure GtkTargetListRef(list : PGtkTargetList);
asmname 'gtk_target_list_ref';

Procedure GtkTargetListUnref(list : PGtkTargetList);
asmname 'gtk_target_list_unref';

Procedure GtkTargetListAdd(list : PGtkTargetList; target:GdkAtom; 
                          flags, info:guint);
asmname 'gtk_target_list_add';

Procedure GtkTargetListAddTable(list : PGtkTargetList;
                          targets:PGtkTargetEntry; ntargets:guint);
asmname 'gtk_target_list_add_table';

Procedure GtkTargetListRemove(list : PGtkTargetList; target:GdkAtom);
asmname 'gtk_target_list_remove';

Function GtkTargetListFind(list : PGtkTargetList; target:GdkAtom; Var info:guint) : gboolean;
asmname 'gtk_target_list_find';

 { Public interface }

Function GtkSelectionOwnerSet(widget:PGtkWidget; selection:GdkAtom;
                          time:guint32) : gint;
asmname 'gtk_selection_owner_set';

Procedure GtkSelectionAddTarget(widget:PGtkWidget; selection,target:GdkAtom;
                          info:guint);
asmname 'gtk_selection_add_target';

Procedure GtkSelectionAddTargets(w:PGtkWidget; sel:GdkAtom;
                          targets:PGtkTargetEntry; ntargets:guint);
asmname 'gtk_selection_add_targets';

Function GtkSelectionConvert(widget:PGtkWidget; selection,target:GdkAtom;
                          time:guint32) : gint;
asmname 'gtk_selection_convert';

Procedure GtkSelectionDataSet(selectionData:PGtkSelectionData;
                          TType:GdkAtom; format:gint; data:PGUChar; len:gint);
asmname 'gtk_selection_data_set';

 { Called when a widget is destroyed }

Procedure GtkSelectionRemoveAll(w:PGtkWidget);
asmname 'gtk_selection_remove_all';

 { Event handlers }

Function GtkSelectionClear(w:PGtkWidget; evt:GdkEventSelection) : gint;
asmname 'gtk_selection_clear';

Function GtkSelectionRequest(w:PGtkWidget; evt:PGdkEventSelection):gint;
asmname 'gtk_selection_request';

Function GtkSelectionIncrEvent(win:PGdkWindow; evt:PGdkEventProperty) : gint;
asmname 'gtk_selection_incr_event';

Function GtkSelectionNotify(widget:PGtkWidget; evt:PGdkEventSelection):gint;
asmname 'gtk_selection_notify';

Function GtkSelectionPropertyNotify(widget:PGtkWidget;
                          evt:PGdkEventProperty) : gint;
asmname 'gtk_selection_property_notify';

Function GtkSelectionDataCopy(data:PGtkSelectionData) : PGtkSelectionData;
asmname 'gtk_selection_data_copy';

Procedure GtkSelectionDataFree(data:PGtkSelectionData);
asmname 'gtk_selection_data_free';


Implementation

End.




