{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkSignal;

interface

uses Glib, GtkObject, GtkTypeUtils, GtkEnums;

type
  TGtkSignalMarshal = Pointer; (* !! Note that this is a generic pointer,
                                     since function/procedure type-casting
                                     isn't allowed. (Yet?) *)
  TGtkSignalDestroy = ^procedure (Data : GPointer);
  TGtkEmissionHook = ^function (Obj : PGtkObject; SignalID, NParams : GUint; Params : PGtkArg; Data : GPointer) : GBoolean;

type
  PGtkSignalQuery = ^TGtkSignalQuery;
  TGtkSignalQuery = record
    ObjectType : TGtkType;
    SignalID : GUint;
    SignalName : PGChar;
    IsUserSignal : GUint1;
    SignalFlags : TGtkSignalRunType;
    ReturnVal : TGtkType;
    NParams : GUint;
    Params : PGtkType;
  end;

{ Application-level methods. }
function GtkSignalLookup (Name : PGChar; ObjectType : TGtkType) : GUint;
asmname 'gtk_signal_lookup';

function GtkSignalName (SignalID : GUint) : PGChar;
asmname 'gtk_signal_name';

function GtkSignalNEmissions (Obj : PGtkObject; SignalID : GUint) : GUint;
asmname 'gtk_signal_n_emissions';

function GtkSignalNEmissionsByName (Obj : PGtkObject; Name : PGChar) : GUint;
asmname 'gtk_signal_n_emissions_by_name';

procedure GtkSignalEmitStop (Obj : PGtkObject; SignalID : GUint);
asmname 'gtk_signal_emit_stop';

procedure GtkSignalEmitStopByName (Obj : PGtkObject; Name : PGChar);
asmname 'gtk_signal_emit_stop_by_name';

function GtkSignalConnect (Obj : PGtkObject; Name : PGChar; Func : TGtkSignalFunc; FuncData : GPointer) : GUint;
asmname 'gtk_signal_connect';

function GtkSignalConnectAfter (Obj : PGtkObject; Name : PGChar; Func : TGtkSignalFunc; FuncData : GPointer) : GUint;
asmname 'gtk_signal_connect_after';

function GtkSignalConnectObject (Obj : PGtkObject; Name : PGChar; Func : TGtkSignalFunc; SlotObj : PGtkObject) : GUint;
asmname 'gtk_signal_connect_object';

function GtkSignalConnectObjectAfter (Obj : PGtkObject; Name : PGChar; Func : TGtkSignalFunc; SlotObj : PGtkObject) : GUint;
asmname 'gtk_signal_connect_object_after';

function GtkSignalConnectFull (Obj : PGtkObject; Name : PGChar; Func : TGtkSignalFunc; Marshal : TGtkCallbackMarshal; Data : GPointer; DestroyFunc : TGtkDestroyNotify; ObjSignal, After : GInt) : GUint;
asmname 'gtk_signal_connect_full';

function GtkSignalConnectObjectWhileAlive (Obj : PGtkObject; Name : PGChar; Func : TGtkSignalFunc; AliveObj : PGtkObject) : GUint;
asmname 'gtk_signal_connect_object_while_alive';

function GtkSignalConnectWhileAlive (Obj : PGtkObject; Name : PGChar; Func : TGtkSignalFunc; FuncData : GPointer; AliveObj : PGtkObject) : GUint;
asmname 'gtk_signal_connect_while_alive';

procedure GtkSignalDisconnect (Obj : PGtkObject; HandlerID : GUint);
asmname 'gtk_signal_disconnect';

procedure GtkSignalDisconnectByFunc (Obj : PGtkObject; Func : TGtkSignalFunc; Data : GPointer);
asmname 'gtk_signal_disconnect_by_func';

procedure GtkSignalDisconnectByData (Obj : PGtkObject; Data : GPointer);
asmname 'gtk_signal_disconnect_by_data';

procedure GtkSignalHandlerBlock (Obj : PGtkObject; HandlerID : GUint);
asmname 'gtk_signal_handler_block';

procedure GtkSignalHandlerBlockByFunc (Obj : PGtkObject; Func : TGtkSignalFunc; Data : GPointer);
asmname 'gtk_signal_handler_block_by_func';

procedure GtkSignalHandlerBlockByData (Obj : PGtkObject; Data : GPointer);
asmname 'gtk_signal_handler_block_by_data';

procedure GtkSignalHandlerUnblock (Obj : PGtkObject; HandlerID : GUint);
asmname 'gtk_signal_handler_unblock';

procedure GtkSignalHandlerUnblockByFunc (Obj : PGtkObject; Func : TGtkSignalFunc; Data : GPointer);
asmname 'gtk_signal_handler_unblock_by_func';

procedure GtkSignalHandlerUnblockByData (Obj : PGtkObject; Data : GPointer);
asmname 'gtk_signal_handler_unblock_by_data';

function GtkSignalHandlerPending (Obj : PGtkObject; SignalID : GUint; MayBeBlocked : GBoolean) : GUint;
asmname 'gtk_signal_handler_pending';

function GtkSignalHandlerPendingByFunc (Obj : PGtkObject; SignalID : GUint; MayBeBlocked : GBoolean; Func : TGtkSignalFunc; Data : GPointer) : GUint;
asmname 'gtk_signal_handler_pending_by_func';

function GtkSignalHandlerPendingByID (Obj : PGtkObject; HandlerID : GUint; MayBeBlocked : GBoolean) : GInt;
asmname 'gtk_signal_handler_pending_by_id';

function GtkSignalAddEmissionHook (SignalID : GUint; HookFunc : TGtkEmissionHook; Data : GPointer) : GUint;
asmname 'gtk_signal_add_emission_hook';

function GtkSignalAddEmissionHookFull (SignalID : GUint; HookFunc : TGtkEmissionHook; Data : GPointer; Destroy : GDestroyNotify) : GUint;
asmname 'gtk_signal_add_emission_hook_full';

procedure GtkSignalRemoveEmissionHook (SignalID, HookID : GUint);
asmname 'gtk_signal_remove_emission_hook';

{ Report internal information about a signal. The caller has the
  responsibility to invoke a subsequent g_free (returned_data); but
  must not modify data pointed to by the members of GtkSignalQuery. }
function GtkSignalQuery(SignalID : GUint) : PGtkSignalQuery;
asmname 'gtk_signal_query';

{ Widget-level methods. }
procedure GtkSignalInit;
asmname 'gtk_signal_init';

function GtkSignalNew (Name : PGChar; SignalFlags : TGtkSignalRunType; ObjectType : TGtkType; FunctionOffset : GUint; Marshaller : TGtkSignalMarshaller; ReturnVal : TGtkType; NParams : GUint; ...) : GUint;
asmname 'gtk_signal_new';

function GtkSignalNewV (Name : PGChar; SignalFlags : TGtkSignalRunType; ObjectType : TGtkType; FunctionOffset : GUint; Marshaller : TGtkSignalMarshaller; ReturnVal : TGtkType; NParams : GUint; Params : PGtkType) : GUint;
asmname 'gtk_signal_newv';

procedure GtkSignalEmit (Obj : PGtkObject; SignalID : GUint; ...);
asmname 'gtk_signal_emit';

procedure GtkSignalEmitByName (Obj : PGtkObject; Name : PGChar; ...);
asmname 'gtk_signal_emit_by_name';

procedure GtkSignalEmitV (Obj : PGtkObject; SignalID : GUint; Params : PGtkArg);
asmname 'gtk_signal_emitv';

procedure GtkSignalEmitVByName (Obj : PGtkObject; Name : PGChar; Params : PGtkArg);
asmname 'gtk_signal_emitv_by_name';

{ !! Non-public methods not implemented. }
       
implementation

end.
