{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

Unit GtkSpinbutton;

Interface

Uses
  GLib, GdkTypes, GtkAdjustment, GtkEntry, GtkEnums, GtkObject, GtkWidget;

Function GTK_TYPE_SPIN_BUTTON : TGtkType;
  asmname 'gtk_spin_button_get_type';

function GTK_IS_SPIN_BUTTON (Obj : Pointer) : Boolean;
function GTK_IS_SPIN_BUTTON_CLASS (Klass : Pointer) : Boolean;

Const
  { GtkSpinButtonUpdatePolicy }
  GTK_UPDATE_ALWAYS   = 0;
  GTK_UPDATE_IF_VALID = 1;
  
  { GtkSpinType }
  GTK_SPIN_STEP_FORWARD   = 0;
  GTK_SPIN_STEP_BACKWARD  = 1;
  GTK_SPIN_PAGE_FORWARD   = 2;
  GTK_SPIN_PAGE_BACKWARD  = 3;
  GTK_SPIN_HOME           = 4;
  GTK_SPIN_END            = 5;
  GTK_SPIN_USER_DEFINED   = 6;

Type
  TGtkSpinButtonUpdatePolicy = Integer;
  TGtkSpinType = Integer;
  
  PGtkSpinButton = ^TGtkSpinButton;
  PGtkSpinButtonClass = ^TGtkSpinButtonClass;

  TGtkSpinButtonFrame1 = packed record
    InChild, ClickChild, Button : GUint2;
    NeedTimer : GUint1;
    TimerCalls, Digits : GUint3;
    Numeric, Wrap, SnapToTicks : GUint1;
  end;

  TGtkSpinButton = Record
    Entry : TGtkEntry;
    Adjustment : PGtkAdjustment;
    Panel : PGdkWindow;
    ShadowType : TGtkShadowType;
    Timer, EvTime : guint32;
    ClimbRate, TimerStep : gfloat;
    UpdatePolicy : TGtkSpinButtonUpdatePolicy;

    Frame1 : TGtkSpinButtonFrame1;
  End;

  TGtkSpinButtonClass = Record
    ParentClass : TGtkEntryClass;
  End;

Function GtkSpinButtonGetType : TGtkType;
  asmname 'gtk_spin_button_get_type';
Procedure GtkSpinButtonConfigure(s:PGtkSpinButton; adj:PGtkAdjustment;
                            climbRate:gfloat; digi:guint);
  asmname 'gtk_spin_button_configure';
Function GtkSpinButtonNew(adj:PgtkAdjustment; climbRate:gfloat; digi:guint)
:                            PGtkWidget;
  asmname 'gtk_spin_button_new';
Procedure GtkSpinButtonSetAdjustment(s:PGtkSpinButton; adj:PGtkAdjustment);
  asmname 'gtk_spin_button_set_adjustment';
Function GtkSpinButtonGetAdjustment(s:PGtkSpinButton) : PGtkAdjustment;
  asmname 'gtk_spin_button_get_adjustment';
Procedure GtkSpinButtonSetDigits(s:PGtkSpinButton; digi:guint);
  asmname 'gtk_spin_button_set_digits';
Function GtkSpinButtonGetValueAsFloat(s:PGtkSpinButton):gfloat;
  asmname 'gtk_spin_button_get_value_as_float';
Function GtkSpinButtonGetValueAsInt(s:PGtkSpinButton):gint;
  asmname 'gtk_spin_button_get_value_as_int';
Procedure GtkSpinButtonSetValue(s:PGtkSpinButton; v:gfloat);
  asmname 'gtk_spin_button_set_value';
Procedure GtkSpinButtonSetUpdatePolicy(s:PgtkSpinButton;
                            p:TGtkSpinButtonUpdatePolicy);
  asmname 'gtk_spin_button_set_update_policy';
Procedure GtkSpinButtonSetNumeric(s:PGtkSpinButton; n:gboolean);
  asmname 'gtk_spin_button_set_numeric';
Procedure GtkSpinButtonSpin(s:PGtkSpinButton; direct:TGtkSpinType;
                            increment:gfloat);
  asmname 'gtk_spin_button_spin';
Procedure GtkSpinButtonSetWrap(s:PGtkSpinButton; wrap:gboolean);
  asmname 'gtk_spin_button_set_wrap';
Procedure GtkSpinButtonSetShadowType(s:PGtkSpinButton; shadow:TGtkShadowType);
  asmname 'gtk_spin_button_set_shadow_type';
Procedure GtkSpinButtonSetSnapToTicks(s:PGtkSpinButton; snap:gboolean);
  asmname 'gtk_spin_button_set_snap_to_ticks';
Procedure GtkSpinButtonUpdate(s:PgtkSpinButton);
  asmname 'gtk_spin_button_update';


Implementation

function GTK_IS_SPIN_BUTTON (Obj : Pointer) : Boolean;
begin
  GTK_IS_SPIN_BUTTON := (Obj <> nil) and GTK_IS_SPIN_BUTTON_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_SPIN_BUTTON_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_SPIN_BUTTON_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_SPIN_BUTTON) = G_TRUE);
end;

End.
