{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkStatusbar;

interface

uses Glib, GtkObject, GtkHBox, GtkWidget;

function GTK_TYPE_STATUSBAR : TGtkType;
asmname 'gtk_statusbar_get_type';

function GTK_IS_STATUSBAR (Obj : Pointer) : Boolean;
function GTK_IS_STATUSBAR_CLASS (Klass : Pointer) : Boolean;

type
  PGtkStatusbarMsg = ^TGtkStatusbarMsg;
  TGtkStatusbarMsg = record
    MsgText : PGChar;
    ContextID, MessageID : GUint;
  end;

type
  PGtkStatusbarClass = ^TGtkStatusbarClass;
  PGtkStatusbar      = ^TGtkStatusbar;

  TGtkStatusbarClass = record
    ParentClass : TGtkHBoxClass;
    MessagesMemChunk : PGMemChunk;
    TextPushed, TextPopped : ^procedure (StatusBar : PGtkStatusbar; ID : GUint; Txt : PGChar);
  end;

  TGtkStatusbar = record
    ParentWidget : TGtkHBox;
    Frame, BarLabel : PGtkWidget;
    Messages, Keys : PGSList;
    SeqContextID, SeqMessageID : GUint;
  end;

function GtkStatusbarGetType : TGtkType;
asmname 'gtk_statusbar_get_type';

function GtkStatusbarNew : PGtkWidget;
asmname 'gtk_statusbar_new';

function GtkStatusbarGetContextId(Statusbar : PGtkStatusbar; Descr : PGChar) : GUint;
asmname 'gtk_statusbar_get_context_id';

{ Returns message_id used for gtk_statusbar_remove }
function GtkStatusbarPush(Statusbar : PGtkStatusbar; ID : GUint; Txt : PGChar) : GUint;
asmname 'gtk_statusbar_push';

procedure GtkStatusbarPop(Statusbar : PGtkStatusbar; ID : GUint);
asmname 'gtk_statusbar_pop';

procedure GtkStatusbarRemove(Statusbar : PGtkStatusbar; CID, MID : GUint);
asmname 'gtk_statusbar_remove';

implementation

function GTK_IS_STATUSBAR (Obj : Pointer) : Boolean;
begin
  GTK_IS_STATUSBAR := (Obj <> nil) and GTK_IS_STATUSBAR_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_STATUSBAR_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_STATUSBAR_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_STATUSBAR) = G_TRUE);
end;

end.
