{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkStyle;

interface

uses Glib, GdkTypes, GtkEnums, GtkWidget;

{ This is used for having dynamic style changing stuff
  fg, bg, light, dark, mid, text, base. }
const
  GTK_STYLE_NUM_STYLECOLORS = 7 * 5;

{ !! Exported type declarations to gtkwidget.pas, to solve interdependencies. }

function GTK_STYLE_ATTACHED(Style : Pointer) : Boolean;

function GtkStyleNew : PGtkStyle;
asmname 'gtk_style_new';

function GtkStyleCopy (Style : PGtkStyle) : PGtkStyle;
asmname 'gtk_style_copy';

function GtkStyleAttach (Style : PGtkStyle; Window : PGdkWindow) : PGtkStyle;
asmname 'gtk_style_attach';

procedure GtkStyleDetach (Style : PGtkStyle);
asmname 'gtk_style_detach';

function GtkStyleRef (Style : PGtkStyle) : PGtkStyle;
asmname 'gtk_style_ref';

procedure GtkStyleUnref (Style : PGtkStyle);
asmname 'gtk_style_unref';

procedure GtkStyleSetBackground (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType);
asmname 'gtk_style_set_background';

procedure GtkStyleApplyDefaultBackground (Style : PGtkStyle; Window : PGdkWindow; SetBG : GBoolean; StateType : TGtkStateType; Area : PGdkRectangle; X, Y, Width, Height : GInt);
asmname 'gtk_style_apply_default_background';

procedure GtkDrawHLine (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; X1, X2, Y : GInt);
asmname 'gtk_draw_hline';

procedure GtkDrawVLine (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; Y1, Y2, X : GInt);
asmname 'gtk_draw_vline';

procedure GtkDrawShadow (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; X, Y, Width, Height  : GInt);
asmname 'gtk_draw_shadow';

procedure GtkDrawPolygon (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Points : PGdkPoint; NPoints : GInt; Fill : GBoolean);
asmname 'gtk_draw_polygon';

procedure GtkDrawArrow (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; ArrowType : TGtkArrowType; Fill : GBoolean; X, Y, Width, Height : GInt);
asmname 'gtk_draw_arrow';

procedure GtkDrawDiamond (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; X, Y, Width, Height : GInt);
asmname 'gtk_draw_diamond';

procedure GtkDrawOval (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; X, Y, Width, Height : GInt);
asmname 'gtk_draw_oval';

procedure GtkDrawString (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; X, Y : GInt; Str : PGChar);
asmname 'gtk_draw_string';

procedure GtkDrawBox (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; X, Y, Width, Height : GInt);
asmname 'gtk_draw_box';

procedure GtkDrawFlatBox (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; X, Y, Width, Height : GInt);
asmname 'gtk_draw_flat_box';

procedure GtkDrawCheck (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; X, Y, Width, Height : GInt);
asmname 'gtk_draw_check';

procedure GtkDrawOption (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; X, Y, Width, Height : GInt);
asmname 'gtk_draw_option';

procedure GtkDrawCross (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; X, Y, Width, Height : GInt);
asmname 'gtk_draw_cross';

procedure GtkDrawRamp (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; ArrowType : TGtkArrowType; X, Y, Width, Height : GInt);
asmname 'gtk_draw_ramp';

procedure GtkDrawTab (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; X, Y, Width, Height : GInt);
asmname 'gtk_draw_tab';

procedure GtkDrawShadowGap (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; x, y, Width, Height : GInt; GapSide : TGtkPositionType; GapX, GapWidth : GInt);
asmname 'gtk_draw_shadow_gap';

procedure GtkDrawBoxGap (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; x, y, Width, Height : GInt; GapSide : TGtkPositionType; GapX, GapWidth : GInt);
asmname 'gtk_draw_box_gap';

procedure GtkDrawExtension (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; x, y, Width, Height : GInt; GapSide : TGtkPositionType);
asmname 'gtk_draw_extension';

procedure GtkDrawFocus (Style : PGtkStyle; Window : PGdkWindow; x, y, Width, Height : GInt);
asmname 'gtk_draw_focus';

procedure GtkDrawSlider (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; x, y, Width, Height : GInt; Orientation : TGtkOrientation);
asmname 'gtk_draw_slider';

procedure GtkDrawHandle (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; x, y, Width, Height : GInt; Orientation : TGtkOrientation);
asmname 'gtk_draw_handle';

procedure GtkPaintHLine (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; x1, x2, y : GInt);
asmname 'gtk_paint_hline';

procedure GtkPaintVLine (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; y1, y2, x : GInt);
asmname 'gtk_paint_vline';

procedure GtkPaintShadow (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; x, y, Width, Heigth : GInt);
asmname 'gtk_paint_shadow';

procedure GtkPaintPolygon (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; Points : PGdkPoint; NPoints : GInt; Fill : Gboolean);
asmname 'gtk_paint_polygon';

procedure GtkPaintArrow (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; ArrowType : TGtkArrowType; Fill : GBoolean; x, y, Width, Height : GInt);
asmname 'gtk_paint_arrow';

procedure GtkPaintDiamond (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; x, y, Width, Height : GInt);
asmname 'gtk_paint_diamond';

procedure GtkPaintOval (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; x, y, Width, Height : GInt);
asmname 'gtk_paint_oval';

procedure GtkPaintString (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; x, y : GInt; Str : PGChar);
asmname 'gtk_paint_string';

procedure GtkPaintBox (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; x, y, Width, Height : GInt);
asmname 'gtk_paint_box';

procedure GtkPaintFlatBox (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; x, y, Width, Height : GInt);
asmname 'gtk_paint_flat_box';

procedure GtkPaintCheck (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; x, y, Width, Height : GInt);
asmname 'gtk_paint_check';

procedure GtkPaintOption (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; x, y, Width, Height : GInt);
asmname 'gtk_paint_option';

procedure GtkPaintCross (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; x, y, Width, Height : GInt);
asmname 'gtk_paint_cross';

procedure GtkPaintRamp (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; ArrowType : TGtkArrowType; x, y, Width, Height : GInt);
asmname 'gtk_paint_ramp';

procedure GtkPaintTab (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; x, y, Width, Height : GInt);
asmname 'gtk_paint_tab';

procedure GtkPaintShadowGap (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; x, y, Width, Height : GInt; GapSide : TGtkPositionType; GapX, GapWidth : GInt);
asmname 'gtk_paint_shadow_gap';

procedure GtkPaintBoxGap (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; x, y, Width, Height : GInt; GapSide : TGtkPositionType; GapX, GapWidth : GInt);
asmname 'gtk_paint_box_gap';

procedure GtkPaintExtension (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; x, y, Width, Height : GInt; GapSide : TGtkPositionType);
asmname 'gtk_paint_extension';

procedure GtkPaintFocus (Style : PGtkStyle; Window : PGdkWindow; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; x, y, Width, Height : GInt);
asmname 'gtk_paint_focus';

procedure GtkPaintSlider (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; x, y, Width, Height : GInt; Orientation : TGtkOrientation);
asmname 'gtk_paint_slider';

procedure GtkPaintHandle (Style : PGtkStyle; Window : PGdkWindow; StateType : TGtkStateType; ShadowType : TGtkShadowType; Area : PGdkRectangle; Widget : PGtkWidget; Detail : PGChar; x, y, Width, Height : GInt; Orientation : TGtkOrientation);
asmname 'gtk_paint_handle';

{ !!
"Temporary GTK+-1.2.9 local patch for use only in theme engines.
 Simple integer geometry properties." ---> Not implemented.
}

implementation

function GTK_STYLE_ATTACHED(Style : Pointer) : Boolean;
begin
  GTK_STYLE_ATTACHED := (PGtkStyle(Style)^.AttachCount > 0);
end;

end.
