{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkTable;

interface

uses Glib, GtkEnums, GtkObject, GtkContainer, GtkWidget;

function GTK_TYPE_TABLE : TGtkType;
asmname 'gtk_table_get_type';

function GTK_IS_TABLE (Obj : Pointer) : Boolean;
function GTK_IS_TABLE_CLASS (Klass : Pointer) : Boolean;

type
  PGtkTableRowCol = ^TGtkTableRowCol;
  PGtkTableChild  = ^TGtkTableChild;
  PGtkTableClass  = ^TGtkTableClass;
  PGtkTable       = ^TGtkTable;

  TGtkTableClass = record
    ParentClass : TGtkContainerClass;
  end;

  TGtkTable = record
    Container : TGtkContainer;
    Children : PGList;
    Rows, Cols : PGtkTableRowCol;
    NRows, NCols, ColumnSpacing, RowSpacing : GUint16;
    Homogeneous : GUint1;
  end;

  TGtkTableChildFrame1 = packed record
    xExpand, yExpand, xShrink, yShrink, xFill, yFill : GUint1;
  end;

  TGtkTableChild = record
    Widget : PGtkWidget;
    LeftAttach, RightAttach, TopAttach, BottomAttach, xPadding, yPadding : GUint16;
    Frame1 : TGtkTableChildFrame1;
  end;

  TGtkTableRowColFrame1 = packed record
    NeedExpand, NeexShrink, Expand, Shrink, Empty : GUint1;
  end;

  TGtkTableRowCol = record
    Requisition, Allocation, Spacing : GUint16;
    Frame1 : TGtkTableRowColFrame1;
  end;

function GtkTableGetType : TGtkType;
asmname 'gtk_table_get_type';

function GtkTableNew (Rows, Columns : GUint; Homogeneous : GBoolean) : PGtkWidget;
asmname 'gtk_table_new';

procedure GtkTableResize (Table : PGtkTable; Rows, Columns : GUint);
asmname 'gtk_table_resize';

procedure GtkTableAttach (Table : PGtkTable; Child : PGtkWidget; LeftAttach, RightAttach, TopAttach, BottomAttach : GUint; xOptions, yOptions : TGtkAttachOptions; xPadding, yPadding : GUint);
asmname 'gtk_table_attach';

procedure GtkTableAttachDefaults (Table : PGtkTable; Child : PGtkWidget; LeftAttach, RightAttach, TopAttach, BottomAttach : GUint);
asmname 'gtk_table_attach_defaults';

procedure GtkTableSetRowSpacing (Table : PGtkTable; Row, Spacing : GUint);
asmname 'gtk_table_set_row_spacing';

procedure GtkTableSetColSpacing (Table : PGtkTable; Col, Spacing : GUint);
asmname 'gtk_table_set_col_spacing';

procedure GtkTableSetRowSpacings (Table : PGtkTable; Spacing : GUint);
asmname 'gtk_table_set_row_spacings';

procedure GtkTableSetColSpacings (Table : PGtkTable; Spacing : GUint);
asmname 'gtk_table_set_col_spacings';

procedure GtkTableSetHomogeneous (Table : PGtkTable; Homogeneous : GBoolean);
asmname 'gtk_table_set_homogeneous';

implementation

function GTK_IS_TABLE (Obj : Pointer) : Boolean;
begin
  GTK_IS_TABLE := (Obj <> nil) and GTK_IS_TABLE_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_TABLE_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_TABLE_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_TABLE) = G_TRUE);
end;

end.
