{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

Unit GtkTipsQuery;

Interface

Uses
  GLib, GdkTypes, GtkLabel, GtkObject, GtkWidget;
  
Function GTK_TYPE_TIPS_QUERY : TGtkType;
asmname 'gtk_tips_query_get_type';

function GTK_IS_TIPS_QUERY (Obj : Pointer) : Boolean;
function GTK_IS_TIPS_QUERY_CLASS (Klass : Pointer) : Boolean;

Type
  PGtkTipsQuery = ^TGtkTipsQuery;
  PGtkTipsQueryClass = ^TGtkTipsQueryClass;
  

  TGtkTipsQuery = Record
    LLabel : TGtkLabel;
    EmitAlways, InQuery : guint1;
    LabelInactive, LabelNoTip : PGChar;

    Caller, LastCrossed : PGtkWidget;
    QueryCursor : PGdkCursor;
  End;

  TGtkTipsQueryClass = Record
    ParentClass : TGtkLabelClass;
    StartQuery : ^Procedure (TipsQuery : PGtkTipsQuery);
    StopQuery : ^Procedure (TipsQuery : PGtkTipsQuery);
    WidgetEntered : ^Procedure (TipsQuery : PGtkTipsQuery; Widget : PGtkWidget; TipTet, TipPrivate : PGChar);
    WidgetSelected : ^Function (TipsQuery : PGtkTipsQuery; Widget : PGtkWidget; TipText, TipPrivate : PGChar; Event : PGdkEventButton) : GInt;
  End;


Function GtkTipsQueryGetType : TGtkType;
asmname 'gtk_tips_query_get_type';

Function GtkTipsQueryNew : PGtkWidget;
asmname 'gtk_tips_query_new';

Procedure GtkTipsQueryStartQuery(tipsQuery:PGtkTipsQuery);
asmname 'gtk_tips_query_start_query';

Procedure GtkTipsQueryStopQuery(tipsQuery:PGtkTipsQuery);
asmname 'gtk_tips_query_stop_query';

Procedure GtkTipsQuerySetCaller(tipsQuery:PGtkTipsQuery; caller:PGtkWidget);
asmname 'gtk_tips_query_set_caller';

Procedure GtkTipsQuerySetLabels(tipsQuery:PGtkTipsQuery; labelInactive,
                          labelNoTip:PGChar);
asmname 'gtk_tips_query_set_labels';


Implementation

function GTK_IS_TIPS_QUERY (Obj : Pointer) : Boolean;
begin
  GTK_IS_TIPS_QUERY := (Obj <> nil) and GTK_IS_TIPS_QUERY_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_TIPS_QUERY_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_TIPS_QUERY_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_TIPS_QUERY) = G_TRUE);
end;

End.




