{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkToggleButton;

interface

uses Glib, GdkTypes, GtkButton, GtkObject, GtkWidget;

function GTK_TYPE_TOGGLE_BUTTON : TGtkType;
asmname 'gtk_toggle_button_get_type';

function GTK_IS_TOGGLE_BUTTON (Obj : Pointer) : Boolean;
function GTK_IS_TOGGLE_BUTTON_CLASS (Klass : Pointer) : Boolean;

type
  PGtkToggleButtonClass = ^TGtkToggleButtonClass;
  PGtkToggleButton      = ^TGtkToggleButton;

  TGtkToggleButtonClass = record
    ParentClass : TGtkButtonClass;

    Toggled : ^procedure (ToggleButton : PGtkToggleButton);
  end;

  TGtkToggleButton = record
    Button : TGtkButton;

    Active, DrawIndicator : GUint1;
    EventWindow : PGdkWindow;
  end;

function GtkToggleButtonGetType : TGtkType;
asmname 'gtk_toggle_button_get_type';

function GtkToggleButtonNew : PGtkWidget;
asmname 'gtk_toggle_button_new';

function GtkToggleButtonNewWithLabel (LLabel : PGChar) : PGtkWidget;
asmname 'gtk_toggle_button_new_with_label';

procedure GtkToggleButtonSetMode (ToggleButton : PGtkToggleButton; DrawIndicator : GBoolean);
asmname 'gtk_toggle_button_set_mode';

procedure GtkToggleButtonSetActive (ToggleButton : PGtkToggleButton; IsActive : GBoolean);
asmname 'gtk_toggle_button_set_active';

function GtkToggleButtonGetActive (ToggleButton : PGtkToggleButton) : GBoolean;
asmname 'gtk_toggle_button_get_active';

procedure GtkToggleButtonToggled (ToggleButton : PGtkToggleButton);
asmname 'gtk_toggle_button_toggled';

implementation

function GTK_IS_TOGGLE_BUTTON (Obj : Pointer) : Boolean;
begin
  GTK_IS_TOGGLE_BUTTON := (Obj <> nil) and GTK_IS_TOGGLE_BUTTON_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_TOGGLE_BUTTON_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_TOGGLE_BUTTON_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_TOGGLE_BUTTON) = G_TRUE);
end;

end.
