{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

Unit GtkToolbar;

Interface

Uses
  GLib, Gdk, GtkContainer, GtkEnums, GtkObject, GtkPixmap, GtkSignal, GtkTooltips,
  GtkTypeUtils, GtkWidget;

Function GTK_TYPE_TOOLBAR : TGtkType;
  asmname 'gtk_toolbar_get_type';

function GTK_IS_TOOLBAR (Obj : Pointer) : Boolean;
function GTK_IS_TOOLBAR_CLASS (Klass : Pointer) : Boolean;

Const
  
  { GtkToolbarChildType }
  GTK_TOOLBAR_CHILD_SPACE = 0;
  GTK_TOOLBAR_CHILD_BUTTON =1;
  GTK_TOOLBAR_CHILD_TOGGLEBUTTON=2;
  GTK_TOOLBAR_CHILD_RADIOBUTTON = 3;
  GTK_TOOLBAR_CHILD_WIDGET =4;

  { GtkToolbarSpaceStyle }
  GTK_TOOLBAR_SPACE_EMPTY=0;
  GTK_TOOLBAR_SPACE_LINE =1;

Type
  TGtkToolbarChildType = Integer;
  TGtkToolbarSpaceStyle = Integer;

  PGtkToolbarChild = ^TGtkToolbarChild;
  PGtkToolbar = ^TGtkToolbar;
  PGtkToolbarClass = ^TGtkToolbarClass;
  
  TGtkToolbarChild = Record
    TType : TGtkToolbarChildType;
    Widget, Icon, LLabel : PGtkWidget;
  End;

  TGtkToolbar = Record
    container : TGtkContainer;
    NumChildren : gint;
    Children : PGList;
    Orientation : TGtkOrientation;
    Style : TGtkToolbarStyle;
    SpaceSize : GInt;  { big optional space between buttons }
    SpaceStyle : TGtkToolbarSpaceStyle;
    Tooltips : PGtkTooltips;
    ButtonMaxW, ButtonMaxH : GInt;
    Relief : TGtkReliefStyle;
  End;

  TGtkToolbarClass = Record
    ParentClass : TGtkContainerClass;
    OrientationChanged : ^Procedure (Toolbar : PGtkToolbar; Orientation : TGtkOrientation);
    StyleChanged : ^Procedure (Toolbar : PGtkToolbar; Style : TGtkToolbarStyle);
  End;

Function GkToolbarGetType : TGtkType;
  asmname 'gtk_toolbar_get_type';
Function GtkToolbarNew(Orientation : TGtkOrientation; Style : TGtkToolbarStyle) : PGtkWidget;
  asmname 'gtk_toolbar_new';

 { Simple button items } 
Function GtkToolbarAppendItem(Toolbar : PGtkToolbar; TText, TooltipsText, TooltipsPrivateText : PGChar;
                            icon:PGtkWidget; cb:TGtkSignalFunc;
                            userData:gpointer) : PGtkWidget;
  asmname 'gtk_toolbar_append_item';

Function GtkToolbarPrependItem(t:PGtkToolbar; txt, tttxt, ttptxt:PGChar;
                            icon:PGtkWidget; cb:TGtkSignalFunc;
                            userData:gpointer) : PGtkWidget;
  asmname 'gtk_toolbar_prepend_item';
Function GtkToolbarInsertItem(t:PGtkToolbar; txt, tttxt, ttptxt:PGChar;
                            icon:PGtkWidget; cb:TGtkSignalFunc;
                            userData:gpointer; posi:gint) : PGtkWidget;
  asmname 'gtk_toolbar_insert_item';

 { Space Items } 
Procedure GtkToolbarAppendSpace(t:PGtkToolbar);
  asmname 'gtk_toolbar_append_space';
Procedure GtkToolbarPrependSpace(t:PGtkToolbar);
  asmname 'gtk_toolbar_prepend_space';
Procedure GtkToolbarInsertSpace(t:PGtkToolbar; posi:gint);
  asmname 'gtk_toolbar_insert_space';

 { Any element type } 
Function GtkToolbarAppendElement(t:PgtkToolbar; typ:TGtkToolbarChildType;
                            txt,tttxt,ttptxt:PGChar; icon:PGtkWidget;
                            cb:TGtkSignalFunc; uData:gpointer) : PGtkWidget;
  asmname 'gtk_toolbar_append_element';
Function GtkToolbarPrependElement(t:PgtkToolbar; TType : TGtkToolbarChildType;
                            txt,tttxt,ttptxt:PGChar; icon:PGtkWidget;
                            cb:TGtkSignalFunc; uData:gpointer) : PGtkWidget;
  asmname 'gtk_toolbar_prepend_element';
Function GtkToolbarInsertElement(t:PgtkToolbar; typ:TGtkToolbarChildType;
                            wdgt:PGtkWidget; txt,tttxt,ttptxt:PGChar; 
                            icon:PGtkWidget; cb:TGtkSignalFunc;
                            uData:gpointer; pos:gint) : PGtkWidget;
  asmname 'gtk_toolbar_insert_element';


 { Generic Widgets } 
Procedure GtkToolbarAppendWidget(t:PGtkToolbar; w:PGtkWidget;
                            tttxt, ttptxt:PGChar);
  asmname 'gtk_toolbar_append_widget';
Procedure GtkToolbarPrependWidget(t:PGtkToolbar; w:PGtkWidget;
                            tttxt, ttptxt:PGChar);
  asmname 'gtk_toolbar_prepend_widget';
Procedure GtkToolbarInsertWidget(t:PGtkToolbar; w:PGtkWidget;
                            tttxt, ttptxt:PGChar; posi:gint);
  asmname 'gtk_toolbar_insert_widget';

 { Style functions } 
Procedure GtkToolbarSetOrientation(t:PGtkToolbar; o:TGtkOrientation);
  asmname 'gtk_toolbar_set_orientation';
Procedure GtkToolbarSetStyle(t:PGtkToolbar; s:TGtkToolbarStyle);
  asmname 'gtk_toolbar_set_style';
Procedure GtkToolbarSetSpaceSize(t:PGtkToolbar; s:gint);
  asmname 'gtk_toolbar_set_space_size';
Procedure GtkToolbarSetSpaceStyle(t:PGtkToolbar; s:TGtkToolbarSpaceStyle);
  asmname 'gtk_toolbar_set_space_style';
Procedure GtkToolbarSetTooltips(t:PGtkToolbar; enable:gint);
  asmname 'gtk_toolbar_set_tooltips';
Procedure GtkToolbarSetButtonRelief(t:PGtkToolbar; r:TGtkReliefStyle);
  asmname 'gtk_toolbar_set_button_relief';
Function GtkToolbarGetButtonRelief(t:PGtkToolbar) : TGtkReliefStyle;
  asmname 'gtk_toolbar_get_button_relief';

Implementation

function GTK_IS_TOOLBAR (Obj : Pointer) : Boolean;
begin
  GTK_IS_TOOLBAR := (Obj <> nil) and GTK_IS_TOOLBAR_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_TOOLBAR_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_TOOLBAR_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_TOOLBAR) = G_TRUE);
end;

End.
