{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

Unit GtkTooltips;

Interface

Uses
  GLib, GdkTypes, GtkData, GtkObject, GtkWidget;

Function GTK_TYPE_TOOLTIPS : TGtkType;
  asmname 'gtk_tooltips_get_type';

function GTK_IS_TOOLTIPS (Obj : Pointer) : Boolean;
function GTK_IS_TOOLTIPS_CLASS (Klass : Pointer) : Boolean;

Type
  PGtkTooltips = ^TGtkTooltips;
  PGtkTooltipsClass = ^TGtkTooltipsClass;
  PGtkTooltipsData = ^TGtkTooltipsData;
  
  TGtkTooltipsData = Record
    Tooltips : PGtkTooltips;
    Widget : PGtkWidget;
    TipText, TipPrivate : PGChar;
    Font : PGdkFont;
    Width : gint;
    Row : PGList;
  End;

  TGtkTooltips = packed Record
    Data : TGtkData;
    tipWindow : PGtkWidget;
    activeTipsData : PGtkTooltipsData;
    tipsDataList : PGList;
    gc : PGdkGC;
    foreground, background : PGdkColor;
    delay : guint30;
    enabled : guint1;
    timerTag : gint;
  End;

  TGtkTooltipsClass = Record
    ParentClass : TGtkDataClass;
  End;

Function GtkTooltipsGetType : TGtkType;
  asmname 'gtk_tooltips_get_type';
Function GtkTooltipsNew : PGtkTooltips;
  asmname 'gtk_tooltips_new';
Procedure GtkTooltipsEnable(t:PGtkTooltips);
  asmname 'gtk_tooltips_enable';
Procedure GtkTooltipsDisable(t:PGtkTooltips);
  asmname 'gtk_tooltips_disable';
Procedure GtkTooltipsSetDelay(t:PGtkTooltips; delay:guint);
  asmname 'gtk_tooltips_set_delay';
Procedure GtkTooltipsSetTip(t:PGTkTooltips; w:PGtkWidget; tt,tp:PGChar);
  asmname 'gtk_tooltips_set_tip';
Procedure GtkTooltipsSetColors(t:PGtkTooltips; bg,fg:PGdkColor);
  asmname 'gtk_tooltips_set_colors';
Function GtkTooltipsDataGet(w:PGtkWidget) : PGtkTooltipsData;
  asmname 'gtk_tooltips_data_get';
Procedure GtkTooltipsForceWindow(t:PGtkTooltips);
  asmname 'gtk_tooltips_force_window';

Implementation

function GTK_IS_TOOLTIPS (Obj : Pointer) : Boolean;
begin
  GTK_IS_TOOLTIPS := (Obj <> nil) and GTK_IS_TOOLTIPS_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_TOOLTIPS_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_TOOLTIPS_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_TOOLTIPS) = G_TRUE);
end;

End.
