{
This unit is part of the Gtk+ units package.
Copyright (C) 2001  Nicola Girardi <nikke@swlibero.org>
                    Eike Lange <eike.lange@uni-essen.de>

This unit is free software; you can redistribute it and/or
modify it under the terms of the GNU unit General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This unit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
unit General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this unit; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.

Original GTK copyright and license information follows.
}

{
GTK - The GIMP Toolkit
Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
}

{
Modified by the GTK+ Team and others 1997-1999.  See the AUTHORS
file for a list of people on the GTK+ Team.  See the ChangeLog
files for a list of changes.  These files are distributed with
GTK+ at ftp://ftp.gtk.org/pub/gtk/.
}

unit GtkVBBox;

interface

uses Glib, GtkEnums, GtkObject, GtkBBox, GtkWidget;

function GTK_TYPE_VBUTTON_BOX : TGtkType;
asmname 'gtk_vbutton_box_get_type';

function GTK_IS_VBUTTON_BOX (Obj : Pointer) : Boolean;
function GTK_IS_VBUTTON_BOX_CLASS (Klass : Pointer) : Boolean;

type
  PGtkVButtonBoxClass = ^TGtkVButtonBoxClass;
  PGtkVButtonBox      = ^TGtkVButtonBox;

  TGtkVButtonBoxClass = record
    ParentClass : TGtkButtonBoxClass;
  end;

  TGtkVButtonBox = record
    ButtonBox : TGtkButtonBox;
  end;
  
function GtkVButtonBoxGetType : TGtkType;
asmname 'gtk_vbutton_box_get_type';

function GtkVButtonBoxNew : PGtkWidget;
asmname 'gtk_vbutton_box_new';

{ Buttons can be added by gtk_container_add(). }

function GtkVButtonBoxGetSpacingDefault : GInt;
asmname 'gtk_vbutton_box_get_spacing_default';

procedure GtkVButtonBoxSetSpacingDefault (Spacing : GInt);
asmname 'gtk_vbutton_box_set_spacing_default';

function GtkVButtonBoxGetLayoutDefault : TGtkButtonBoxStyle;
asmname 'gtk_vbutton_box_get_layout_default';

procedure GtkVButtonBoxSetLayoutDefault(Layout : TGtkButtonBoxStyle);
asmname 'gtk_vbutton_box_set_layout_default';

implementation

function GTK_IS_VBUTTON_BOX (Obj : Pointer) : Boolean;
begin
  GTK_IS_VBUTTON_BOX := (Obj <> nil) and GTK_IS_VBUTTON_BOX_CLASS(PGtkTypeObject(Obj)^.Klass);
end;

function GTK_IS_VBUTTON_BOX_CLASS (Klass : Pointer) : Boolean;
begin
  GTK_IS_VBUTTON_BOX_CLASS := (Klass <> nil) and (GtkTypeIsA(PGtkTypeClass(Klass)^.TType, GTK_TYPE_VBUTTON_BOX) = G_TRUE);
end;

end.
